;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
.equ    _SIGN=$05
.def    FLAGS=r0;                      ; R0 ist flags!


;***************************************************************************
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers 
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor). 
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;*  
;* Number of words	:19
;* Number of cycles	:235/251 (Min/Max)
;* Low registers used	:2 (drem16uL,drem16uH)
;* High registers used  :5 (dres16uL/dd16uL,dres16uH/dd16uH,dv16uL,dv16uH,
;*			    dcnt16u)
;*
;***************************************************************************

;***** Subroutine Register Variables

.def	drem16uL=r14
.def	drem16uH=r15
.def	dres16uL=r16
.def	dres16uH=r17
.def	dd16uL	=r16
.def	dd16uH	=r17
.def	dv16uL	=r18
.def	dv16uH	=r19
.def	dcnt16u	=r20

;***** Code

div16u:	clr	drem16uL	;clear remainder Low byte
	sub	drem16uH,drem16uH;clear remainder High byte and carry
	ldi	dcnt16u,17	;init loop counter
d16u_1:	rol	dd16uL		;shift left dividend
	rol	dd16uH
	dec	dcnt16u		;decrement counter
	brne	d16u_2		;if done
	ret			;    return
d16u_2:	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_3		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
	clc			;    clear carry to be shifted into result
	rjmp	d16u_1		;else
d16u_3:	sec			;    set carry to be shifted into result
	rjmp	d16u_1







;--------------------------------------------------------------------
; COPY32_INDIREKT   Z (dword) = X(dword)
;--------------------------------------------------------------------
COPY32_INDIREKT:
        ld r16,X+
        st Z+,r16
        ld r16,X+
        st Z+,r16
        ld r16,X+
        st Z+,r16
        ld r16,X+
        st Z+,r16
        ret

;--------------------------------------------------------------------
; COPY32_INDIREKT_LO_HI     HIBLOCK Z (dword) = LOBLOCK X(dword)
;--------------------------------------------------------------------
COPY32_INDIREKT_LO_TO_HI:
        push xl
        push xh
        push zl
        push zh
        push r16
        push r17
        push r18
        push r19

        ld r16,X+
        ld r17,X+
        ld r18,X+
        ld r19,X+

        cli                             ; Hier auf keinen Fall INTERRUPT!
        sbi PortD,MCU_A16               ; 2. 64Kblock aktivieren
        st Z+,r16
        st Z+,r17
        st Z+,r18
        st Z+,r19
        cbi PortD,MCU_A16               ; 1. 64Kblock aktivieren
        sei                             ; Wieder zulassen

        pop r19
        pop r18
        pop r17
        pop r16
        pop zh
        pop zl
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; COPY32_INDIREKT_LO_HI     LOBLOCK X (dword) = HIBLOCK Z(dword)
;--------------------------------------------------------------------
COPY32_INDIREKT_HI_TO_LO:
        push xl
        push xh
        push zl
        push zh
        push r16
        push r17
        push r18
        push r19

        cli                             ; Hier auf keinen Fall INTERRUPT!
        sbi PortD,MCU_A16
        ld r16,Z+
        ld r17,Z+
        ld r18,Z+
        ld r19,Z+
        cbi PorTD,MCU_A16
        sei                             ; Wieder zulassen

        st X+,r16
        st X+,r17
        st X+,r18
        st X+,r19

        pop r19
        pop r18
        pop r17
        pop r16
        pop zh
        pop zl
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; ADD32_INDIREKT     Z (dword) = X (dword) + Y (dword)
;--------------------------------------------------------------------
ADD32_INDIREKT:
        ld _ACCBLO,X+
        ld _ACCBHI,X+
        ld _ACCCLO,X+
        ld _ACCCHI,X+

        ld _ACCB,Y+
        ld _ACCA,Y+
        ld _ACCALO,Y+
        ld _ACCAHI,Y+

        ADD _ACCB, _ACCBLO
        ADC _ACCA, _ACCBHI
        ADC _ACCALO, _ACCCLO
        ADC _ACCAHI, _ACCCHI

        st Z+,_ACCB
        st Z+,_ACCA
        st Z+,_ACCALO
        st Z+,_ACCAHI

        ret

;--------------------------------------------------------------------
; SUB32_INDIREKT    z (dword) = x(dword) - y(dword)
;--------------------------------------------------------------------
SUB32_INDIREKT:
        ld _ACCB,X+
        ld _ACCa,X+
        ld _ACCAlo,X+
        ld _ACCAhi,X+

        PUSH _ACCB
        PUSH _ACCA
        PUSH _ACCALO
        PUSH _ACCAHI

        ld _ACCb, Y+
        ld _ACCa, Y+
        ld _ACCalo, Y+
        ld _ACCahi, Y+

        SUBI _ACCB, $01
        SBCI _ACCA, $00
        SBCI _ACCALO, $00
        SBCI _ACCAHI, $00

        COM _ACCALO
        COM _ACCAHI
        COM _ACCA
        COM _ACCB

        POP _ACCCHI
        POP _ACCCLO
        POP _ACCBHI
        POP _ACCBLO

        ADD _ACCB, _ACCBLO
        ADC _ACCA, _ACCBHI
        ADC _ACCALO, _ACCCLO
        ADC _ACCAHI, _ACCCHI

        ST Z+,_ACCB
        st Z+,_ACCA
        st Z+,_ACCALO
        st Z+,_ACCAHI

        ret

;--------------------------------------------------------------------
; DIV32_512 Z(dword)=X (dword) / 512  Y (dword)=REST
;--------------------------------------------------------------------
DIV32_BY512_INDIREKT:
        ld _ACCB,X+
        ld _ACCA,X+
        ld _ACCALO,X+
        ld _ACCAHI,X+

        st Y+,_ACCB                     ; untere 8 Bit sofort abspeichern

        mov _ACCDLO,_ACCA
        andi _ACCDLO,$01                ; von ober 8 Bit nur ein Bit behalten
        st Y+,_ACCDLO

        clr _ACCDLO
        st Y+,_ACCDLO                   ; andere 2 Bytes lschen
        st Y+,_ACCDLO

        ldi _ACCDLO,9

DIV32_BY512_INDIREKT_1:
        clc                             ; Carry lschen
        lsr _ACCAHI                     ; Hibyte von Hi-Word nach rechts
        ror _ACCALO                     ; Carry weiterschieben nach lo-byte
        ror _ACCA                       ; Carry weiterschieben nach Hi-Byte
        ror _ACCB                       ; Carry weiterschieben nach Lo-Byte

        dec _ACCDLO
        brne DIV32_BY512_INDIREKT_1

        st Z+,_ACCB
        st Z+,_ACCA
        st Z+,_ACCALO
        st Z+,_ACCAHI

        ret

;--------------------------------------------------------------------
; MUL32_4  z(dword)=x(dword)*4     (32bit 2 bit nach links schieben)
;--------------------------------------------------------------------
MUL32_BY4_INDIREKT:
        ld _ACCB,X+
        ld _ACCA,X+
        ld _ACCALO,X+
        ld _ACCAHI,X+

        lsl _ACCB                       ; Lobyte nach links schieben
        rol _ACCA                       ; Carry rberschieben
        rol _ACCALO
        rol _ACCAHI

        lsl _ACCB                       ; Lobyte nach links schieben
        rol _ACCA                       ; Carry rberschieben
        rol _ACCALO
        rol _ACCAHI

        st Z+,_ACCB
        st Z+,_ACCA
        st Z+,_ACCALO
        st Z+,_ACCAHI

        ret

;--------------------------------------------------------------------
; MUL32_INDIREKT     Z (dword)=X (dword)*Y (dword)
;--------------------------------------------------------------------
MUL32_INDIREKT:
        ld _ACCDLO,X+
        ld _ACCDHI,X+
        ld r16,X+
        ld r17,X+
        mov _ACCELO,r16
        mov _ACCEHI,r17

        ld _ACCBLO,Y+
        ld _ACCBHI,Y+
        ld _ACCCLO,Y+
        ld _ACCCHI,Y+
        CLT
        BLD       Flags, _SIGN                 ;unsigned
        rcall MUL32
        st Z+,_ACCB
        st Z+,_ACCA
        st Z+,_ACCALO
        st Z+,_ACCAHI
        ret

;--------------------------------------------------------------------
;  Multiply-Routine     32*32=32
;
;       use of routine:
;
; A= MULTI1*MULTI2
;
;                LDS       _ACCEHI, MULTI1
;                LDS       _ACCELO, MULTI1+1
;                LDS       _ACCDHI, MULTI1+2
;                LDS       _ACCDLO, MULTI1+3
;                LDS       _ACCBLO, MULTI2
;                LDS       _ACCBHI, MULTI2+1
;                LDS       _ACCCLO, MULTI2+2
;                LDS       _ACCCHI, MULTI2+3
;                CLT
;                BLD       Flags, _SIGN                 ;unsigned
;                CALL      MUL32
;                STS       A, _ACCB
;                STS       A+1, _ACCA
;                STS       A+2, _ACCALO
;                STS       A+3, _ACCAHI
;
;--------------------------------------------------------------------

MUL32:
                RJMP      MUL32_1
MUL32_1:
                BST       Flags, _SIGN
                BRTC      MUL32_2
                MOV       _ACCFLO, _ACCCHI
                EOR       _ACCFLO, _ACCEHI
                CLT
                SBRS      _ACCFLO, 7
                BLD       Flags, _SIGN
                SBRS      _ACCCHI, 7
                RJMP      MUL32_4
                COM       _ACCBLO
                COM       _ACCBHI
                COM       _ACCCLO
                COM       _ACCCHI
                SUBI      _ACCBLO, $ff
                SBCI      _ACCBHI, $ff
                SBCI      _ACCCLO, $ff
                SBCI      _ACCCHI, $ff
MUL32_4:
                SBRS      _ACCEHI, 7
                RJMP      MUL32_2
                COM       _ACCDLO
                COM       _ACCDHI
                COM       _ACCELO
                COM       _ACCEHI
                SUBI      _ACCDLO, $ff
                SBCI      _ACCDHI, $ff
                SBCI      _ACCELO, $ff
                SBCI      _ACCEHI, $ff
MUL32_2:
                CLR       _ACCFHI
                CLR       _ACCFLO
                CLR       _ACCGHI
                CLR       _ACCGLO
                LDI       _ACCA, 32
                LSR       _ACCEHI
                ROR       _ACCELO
                ROR       _ACCDHI
                ROR       _ACCDLO
MUL32_6:
                BRCC      MUL32_5
                ADD       _ACCFLO, _ACCBLO
                ADC       _ACCFHI, _ACCBHI
                ADC       _ACCGLO, _ACCCLO
                ADC       _ACCGHI, _ACCCHI
MUL32_5:
                ROR       _ACCGHI
                ROR       _ACCGLO
                ROR       _ACCFHI
                ROR       _ACCFLO
                ROR       _ACCEHI
                ROR       _ACCELO
                ROR       _ACCDHI
                ROR       _ACCDLO
                DEC       _ACCA
                BRNE      MUL32_6
                MOV       _ACCB, _ACCDLO
                MOV       _ACCA, _ACCDHI
                MOV       _ACCALO, _ACCELO
                MOV       _ACCAHI, _ACCEHI
                BST       Flags, _SIGN
                BRTC      MUL32_3
                SUBI      _ACCB, $01
                SBCI      _ACCA, $00
                SBCI      _ACCALO, $00
                SBCI      _ACCAHI, $00
                COM       _ACCALO
                COM       _ACCAHI
                COM       _ACCA
                COM       _ACCB
MUL32_3:
                RET

;--------------------------------------------------------------------
; DIV32_indirekt        Z=Z div X       Rest in Y
;--------------------------------------------------------------------
DIV32_INDIREKT:
        push zl
        push zh

        ld _ACCBLO,x+
        ld _ACCBHI,x+
        ld _ACCCLO,x+
        ld _ACCCHI,x+

        ld _ACCDLO,z+
        ld _ACCDHI,z+
        ld _ACCELO,z+
        ld _ACCEHI,z+

        CLT
        BLD       Flags, _SIGN
        CALL      _DIV32

        pop zh
        pop zl

        st Z+,_ACCB
        st Z+,_ACCA
        st Z+,_ACCALO
        st Z+,_ACCAHI

        st Y+,_ACCFLO
        st Y+,_ACCFHI
        st Y+,_ACCGLO
        st Y+,_ACCGHI

        ret


_DIV32:
_DIV32_R:
                CLR       _ACCA
                BST       Flags, _SIGN
                BRTC      _DIV32_U
                MOV       _ACCA, _ACCEHI
                MOV       _ACCFLO, _ACCCHI
                EOR       _ACCFLO, _ACCEHI
                CLT
                SBRS      _ACCFLO, 7
                BLD       Flags, _SIGN
                SBRS      _ACCCHI, 7
                RJMP      __L0020
                COM       _ACCBLO
                COM       _ACCBHI
                COM       _ACCCLO
                COM       _ACCCHI
                SUBI      _ACCBLO, $ff
                SBCI      _ACCBHI, $ff
                SBCI      _ACCCLO, $ff
                SBCI      _ACCCHI, $ff
__L0020:
                SBRS      _ACCEHI, 7
                RJMP      _DIV32_U
                COM       _ACCDLO
                COM       _ACCDHI
                COM       _ACCELO
                COM       _ACCEHI
                SUBI      _ACCDLO, $ff
                SBCI      _ACCDHI, $ff
                SBCI      _ACCELO, $ff
                SBCI      _ACCEHI, $ff
_DIV32_U:
                PUSH      _ACCA
                CLR       _ACCFLO
                CLR       _ACCFHI
                CLR       _ACCGLO
                CLR       _ACCGHI
                LDI       _ACCA, 33
__L0022:
                ROL       _ACCDLO
                ROL       _ACCDHI
                ROL       _ACCELO
                ROL       _ACCEHI
                DEC       _ACCA
                BRNE      __L0021
                MOV       _ACCB, _ACCDLO
                MOV       _ACCA, _ACCDHI
                MOV       _ACCALO, _ACCELO
                MOV       _ACCAHI, _ACCEHI
                BST       Flags, _SIGN
                BRTC      __L0024
                SUBI      _ACCB, 01
                SBCI      _ACCA, 00
                SBCI      _ACCALO, 00
                SBCI      _ACCAHI, 00
                COM       _ACCALO
                COM       _ACCAHI
                COM       _ACCA
                COM       _ACCB
__L0024:
                POP       _ACCDHI
                RET
__L0021:
                ROL       _ACCFLO
                ROL       _ACCFHI
                ROL       _ACCGLO
                ROL       _ACCGHI
                SUB       _ACCFLO, _ACCBLO
                SBC       _ACCFHI, _ACCBHI
                SBC       _ACCGLO, _ACCCLO
                SBC       _ACCGHI, _ACCCHI
                BRCC      __L0023
                ADD       _ACCFLO, _ACCBLO
                ADC       _ACCFHI, _ACCBHI
                ADC       _ACCGLO, _ACCCLO
                ADC       _ACCGHI, _ACCCHI
                CLC
                RJMP      __L0022
__L0023:
                SEC
                RJMP      __L0022




