;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; Includefile fr MEGA1.ASM     Balken anzeigen
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; RECT_PAINT      r16:Xpos R17:YPOS, R18:Width, r19:height, Y=ADP
;--------------------------------------------------------------------
RECT_PAINT_SUB1:
        push r16
        push r17
        mov r17,r18
RECT_PAINT_SUB1_1:
        and r17,r17                     ; Breite schon 0?
        breq RECT_PAINT_SUB1_END
        ldi r16,$ff
        call LCD240_OutChar
        dec r17
        rjmp RECT_PAINT_SUB1_1
RECT_PAINT_SUB1_END:
        pop r17
        pop r16
        ret

RECT_PAINT:
        push r16
        push r17
        push r18
        push r19
        push r20
        push yl
        push yh

RECT_PAINT_1:
        and r17,r17
        breq RECT_PAINT_2

        dec r17
        adiw yl,40                      ; Y=Y+r17*40
        rjmp RECT_PAINT_1

RECT_PAINT_2:
        ldi r17,0
        add yl,r16
        adc yh,r17                      ; Y=Y+R16

        call LCD240_setADP
        call RECT_PAINT_SUB1

        mov r17,r19
RECT_PAINT_4:
        adiw yl,40                      ; nchste Zeile bearbeiten
        call LCD240_setADP
RECT_PAINT_5:
        and r17,r17
        breq RECT_PAINT_6

        ldi r16,$20
        call LCD240_Outchar


        ldi r20,$02
        cp r20,r18                     ; berhaupt>2??
        brsh RECT_PAINT_9

        mov r20,r18
        dec r20
        dec r20
RECT_PAINT_8:
        and r20,r20
        breq RECT_PAINT_9

        dec r20
        ldi r16,0
        call LCD240_OutChar
        rjmp RECT_PAINT_8

RECT_PAINT_9:
        ldi r16,$01
        call LCD240_OutChar
        dec r17
        rjmp RECT_PAINT_4

RECT_PAINT_6:
        call LCD240_setADP

        call RECT_PAINT_SUB1

        pop yh
        pop yl
        pop r20
        pop r19
        pop r18
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; CHARRECT_PAINT   r16(xpos) r17(ypos) r18(breite) r19(Hhe) r20(o/u)
;--------------------------------------------------------------------
CHARRECT_PAINT_LINE_OBEN:
        push r16
        push r18

        sbrs r20,0                      ; Bit 0 gesetzt?
        ldi r16,$c0                     ; Ecke links unten
        sbrc r20,0
        ldi r16,$da                     ; Ecke links oben
        call LCD240_OutAscii

CHARRECT_PAINT_LINE_OBEN_1:
        and r18,r18
        breq CHARRECT_PAINT_LINE_OBEN_2

        ldi r16,$c4
        call LCD240_OutAscii

        dec r18
        rjmp CHARRECT_PAINT_LINE_OBEN_1

CHARRECT_PAINT_LINE_OBEN_2:
        sbrs r20,0
        ldi r16,$d9                     ; Ecke rechts unten
        sbrc r20,0
        ldi r16,$bf                     ; Ecke rechts oben
        call LCD240_OutAscii

CHARRECT_PAINT_LINE_OBEN_END:
        pop r18
        pop r16
        ret


CHARRECT_PAINT_LINE_SIDE:
        push r16
        push r17
        push r18
        push r19

CHARRECT_PAINT_LINE_SIDE_1:
        inc r17                         ; Y-Pos inkrementieren
        call LCD240_SetCursor

        and r19,r19                     ; Hhe=0?
        breq CHARRECT_PAINT_LINE_SIDE_2

        push r16
        ldi r16,$b3
        call LCD240_OutAscii            ; Balken links ausgeben
        pop r16

        push r18                        ; R18 retten

CHARRECT_PAINT_LINE_SIDE_4:

        and r18,r18                     ; R18 = 0?
        breq CHARRECT_PAINT_LINE_SIDE_3 ; Ja: Schleife verlassen

        push r16                        ; R16 retten (XPOS)
        ldi r16,' '                     ; ' ' auf Display ausgeben
        call LCD240_OutAscii
        pop r16

        dec r18                         ; Breite dekrement
        rjmp CHARRECT_PAINT_LINE_SIDE_4 ; Und nocheinmal Schleife bearbeiten

CHARRECT_PAINT_LINE_SIDE_3:
        pop r18                         ; Breite zurckholen

        push r16
        ldi r16,$b3                     ; Balken rechts ausgeben
        call LCD240_OutAscii
        pop r16

        dec r19                         ; Hhe abgearbeitet?
        rjmp CHARRECT_PAINT_LINE_SIDE_1

CHARRECT_PAINT_LINE_SIDE_2:
        pop r19
        pop r18
        pop r17
        pop r16
        ret


CHARRECT_PAINT:
        push r20
        call LCD240_SetCursor           ; Cursor an Position setzen

        ldi r20,1                       ; Oben
        rcall CHARRECT_PAINT_LINE_OBEN
        rcall CHARRECT_PAINT_LINE_SIDE

        ldi r20,0                       ; Unten
        rcall CHARRECT_PAINT_LINE_OBEN

        pop r20
        ret

;--------------------------------------------------------------------
; BAR_CALCULATE_ADP
;--------------------------------------------------------------------
BAR_CALCULATE_ADP:
        push r18
        call LCD240_GetGraphHomeAdr
        call LCD240_SetADP

        lds r18,IRAM_MENU_YPOS

BAR_CALCULATE_ADP_1:
        and r18,r18
        breq BAR_CALCULATE_ADP_2
        adiw yl,63
        adiw yl,63
        adiw yl,63
        adiw yl,63
        adiw yl,63
        adiw yl,$05                     ; Y=Y+320

        dec r18
        jmp BAR_CALCULATE_ADP_1

BAR_CALCULATE_ADP_2:
        pop r18
        ret

;--------------------------------------------------------------------
; BAR_DISPLAY   (YPOS in IRAM_MENU_YPOS)
;--------------------------------------------------------------------
BAR_DISPLAY:
        push r16
        push xl
        push xh
        push yl
        push yh
        ldi xl,$40
        ldi xh,$01

        call BAR_CALCULATE_ADP
;        call LCD240_GetGraphHomeAdr
;        ldi yl,$00                      ; Adresse von Anfang von Graph
;        ldi yh,$0e                      ; Area laden

        call LCD240_SetADP

        call LCD240_AutoModeOn
BAR_DISPLAY_1:
        ldi r16,$ff
        call LCD240_WriteData
        call LCD240_INKREMENT_ADP

        sbiw xl,$01
        brne BAR_DISPLAY_1

        call LCD240_AutoModeOff

        pop yh
        pop yl
        pop xh
        pop xl
        pop r16
        ret

;--------------------------------------------------------------------
; BAR_DISPLAY   (YPOS in IRAM_MENU_YPOS)
;--------------------------------------------------------------------
BAR_CLEAR:
        push r16
        push xl
        push xh
        push yl
        push yh

        ldi xl,$40
        ldi xh,$01

        call BAR_CALCULATE_ADP
        call LCD240_SetADP

        call LCD240_AutoModeOn
BAR_CLEAR_1:
        ldi r16,$00
        call LCD240_WriteData
        call LCD240_INKREMENT_ADP

        sbiw xl,$01
        brne BAR_CLEAR_1

        call LCD240_AutoModeOff

        pop yh
        pop yl
        pop xh
        pop xl
        pop r16
        ret

