;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; Includefile fr BCD-Operationen
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; bin2BCD16     lobyte in r16/hibyte in r17 BCD-Zahl in tBCD0-2
;--------------------------------------------------------------------
.equ    AtBCD0  = 7                     ; address of tBCD0
.equ    AtBCD2  = 9                     ; address of tBCD1

bin2BCD16:
        push r18
        push r19
        push zl
        push zh
        ldi r18,16                      ; Init loop counter
        clr tBCD2                       ; clear result (3 bytes)
        clr tBCD1
        clr tBCD0
        clr ZH                          ; clear ZH (not needed for AT90Sxx0x)

bin2BCD16_1:
        lsl r16                         ; shift input value
        rol r17                         ; through all bytes
        rol tBCD0
        rol tBCD1
        rol tBCD2
        dec r18                         ; decrement loop counter
        brne bin2BCD16_2                ; if counter not zero
        pop zh
        pop zl
        pop r19
        pop r18
        ret                             ; return

bin2BCD16_2:
        ldi zl,AtBCD2+1                 ; Z points to result MSB + 1
bin2BCD16_3:
        ld r19,-Z                       ; get (Z) with pre-decrement
        subi r19,-$03                   ; add 0x03
        sbrc r19,3                      ; if bit 3 not clear
        st Z,r19                        ; store back
        ld r19,Z                        ; get (Z)
        subi r19,-$30                   ; add 0x30
        sbrc r19,7                      ; if bit 7 not clear
        st Z,r19                        ; store back
        cpi ZL,AtBCD0                   ; done all three?
        brne bin2BCD16_3                ; loop again if not
        rjmp bin2BCD16_1

;--------------------------------------------------------------------
; BIN2BCD8
;--------------------------------------------------------------------
bin2bcd8:
        clr     tBCD1                   ; clear result MSD
bin2bcd8_1:
        subi    r16,10                  ; input = input - 10
        brcs    bin2bcd8_2              ; abort if carry set

        push r16
        mov r16,tBCD1
        subi r16,-$10
        mov tBCD1,r16
        pop r16

        rjmp    bin2bcd8_1              ; loop again
bin2bcd8_2:
        subi    r16,-10                 ; compensate extra subtraction
        add     r16,tBCD1
        mov tBCD0,r16
        ret


