;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; Includefile fr die Buttons am Display-Bottom
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; Button_InitPlayBar
;--------------------------------------------------------------------
Button_InitPlayBar:
        push r16
        push r17
        push r19
        call LCD240_ClearGraph
        call LCD240_ClearText
        call Button_ClearTable
        ldi r16,$00
        ldi r17,Button_FRewind
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$01
        ldi r17,Button_Play
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$02
        ldi r17,Button_FForward
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$03
        ldi r17,Button_Stop
        ldi r19,$00
        call Button_DisplaySingle

        ldi r16,$05
        ldi r17,Button_Cdir
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$06
        ldi r17,Button_Func
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$07
        ldi r17,Button_Aud
        ldi r19,$00
        call Button_DisplaySingle
        pop r19
        pop r17
        pop r16
        ret


;--------------------------------------------------------------------
; BUTTON_DISPLAYSINGLE      (r16:Pos,r17:Nr,r19:invers=1)
;--------------------------------------------------------------------
BUTTON_DISPLAYSINGLE:
        push zl
        push zh
        push r16
        push r17
        push r18
        push r19

        ldi zl,low(IRAM_ButtonAdr)
        ldi zh,high(IRAM_ButtonAdr)
        add zl,r16
        st Z,r17

        ldi zl,low(2*DATA_BUTTON0)
        ldi zh,high(2*DATA_BUTTON0)

        mov r18,r17
BUTTON_DisplaySingle_4:
        and r18,r18
        breq BUTTON_DisplaySingle_5
        adiw zl,41
        adiw zl,41
        dec r18
        rjmp BUTTON_DisplaySingle_4

Button_Displaysingle_5:

        ldi r18,$00
        ldi r17,$05

Button_Display_Single_7:
        and r16,r16
        breq Button_Display_single_6

        add r18,r17
        dec r16
        rjmp Button_Display_Single_7

button_Display_Single_6:
        mov r16,r18
        ldi r17,48                      ; 56. Zeile

        pop r19
        call LCD240_PutImage

        pop r18
        pop r17
        pop r16
        pop zh
        pop zl
        ret

;--------------------------------------------------------------------
; BUTTON_CLEARTABLE
;--------------------------------------------------------------------
Button_ClearTable:
        push r16
        push r17
        push xl
        push xh
        ldi xl,low(IRAM_ButtonAdr)
        ldi xh,high(IRAM_ButtonAdr)
        ldi r17,8
        ldi r16,Button_Blank

Button_ClearTable_2:
        st X+,r16
        dec r17
        brne Button_ClearTable_2

        pop xh
        pop xl
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; BUTTON_CheckKeyboard  in r17= Nummer
;--------------------------------------------------------------------
Button_CheckKeyboard:
        push r16
        com r16                         ; r16 umdrehen
        clr r17

Button_CheckKeyboard_2:
        push r16
        andi r16,$80
        pop r16
        brne Button_CheckKeyboard_found
        lsl r16                         ; r16 um 1 nach links rotieren
        clc                             ; und Carry lschen
        inc r17
        cpi r17,$08                     ; NotHaltpunkt!!!
        breq Button_CheckKeyboard_found
        rjmp Button_CheckKeyboard_2

Button_CheckKeyboard_found:
        pop r16
        ret

;--------------------------------------------------------------------
; BUTTON_DisplayTable
;--------------------------------------------------------------------
Button_DisplayTable:
        push r16
        push r17
        push r19
        push xl
        push xh
        ldi xl,low(IRAM_ButtonAdr)
        ldi xh,high(IRAM_ButtonAdr)

        ldi r17,0

Button_DisplayTable_2:
        ld r16,X+
        clr r19
        call Button_DisplaySingle
        inc r17
        cpi r17,$07
        brne Button_DisplayTable_2

        pop xh
        pop xl
        pop r19
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; BUTTON_GetNumber  r17:Pos     Ergebnis in r17
;--------------------------------------------------------------------
BUTTON_GetNumber:
        push yl
        push yh

        ldi yl,low(IRAM_ButtonAdr)
        ldi yh,high(IRAM_ButtonAdr)
        add yl,r17
        ld r17,Y
        pop yh
        pop yl
        ret

;--------------------------------------------------------------------
; BUTTON_DISPLAYNormal      r16:Pos
;--------------------------------------------------------------------
BUTTON_DISPLAYNormal:
        push r19
        PUSH r16
        push r17
        mov r16,r17
        call Button_GetNumber
        clr r19
        call Button_DisplaySingle
        pop r17
        pop r16
        pop r19
        ret

;--------------------------------------------------------------------
; BUTTON_DISPLAYNormal      r16:Pos
;--------------------------------------------------------------------
BUTTON_DISPLAYInverse:
        push r19
        push r16
        push r17
        mov r16,r17
        call Button_GetNumber
        ldi r19,$01
        call Button_DisplaySingle
        pop r17
        pop r16
        pop r19
        ret

;--------------------------------------------------------------------
; Button_DisplayInverseViaText   r16:pos, r17:invers/-normal
;--------------------------------------------------------------------
Button_DidplayInvViaText_SUB1:
        push r16
        push r17
        push r18

        ldi r19,5

        ldi r16,32                      ; Leerzeichen
        sbrc r18,0                      ; Wenn r18=0 dann Leerzeichen
        ldi r16,$cc

Button_DidplayInvViaText_SUB1_1:
        call lcd240_OutAscii
        dec r19
        brne Button_DidplayInvViaText_SUB1_1

        pop r18
        pop r17
        pop r16
        ret

;Button_DisplayInverseViaText:
        push r16
        push r17
        push r18
        push r19

        mov r18,r17
        mov r19,r16

        clr r16

Button_DisplayInverseViaText_1:
        and r19,r19
        breq Button_DisplayInverseViaText_2

        push r17
        ldi r17,5
        add r16,r17
        pop r17
        dec r19

        rjmp Button_DisplayInverseViaText_1

Button_DisplayInverseViaText_2:
        ldi r17,6
        call lcd240_setcursor

        call Button_DidplayInvViaText_SUB1

        inc r17
        call lcd240_setcursor

        call Button_DidplayInvViaText_SUB1

        pop r19
        pop r18
        pop r17
        pop r16
        ret


;--------------------------------------------------------------------
; KeyBoard_Check  in r16 gedrckte taste FF= keine dedrckt,r17=Number(0-7)
;--------------------------------------------------------------------
KEYBOARD_CHECK:
        push xl
        push xh
        ldi r17,KEY_NONE                ; Keine Taste
KEYBOARD_CHECK_WAIT:
        in r16,PINF
        cpi r16,$ff
        breq KEYBOARD_CHECK_END         ; war _END

        call Button_CheckKeyboard
        call Button_displayInverse

        push r16
        ldi r16,200                     ; 200ms warten (Tastenenprellung)
        call waitr16

        ldi xl,low(LONGPRESS_DELAY)
        ldi xh,high(LONGPRESS_DELAY)

        call LPTIMER_LOAD               ; Longpress-Timer-laden

KEYBOARD_CHECK_1:
        in r16,PINF

        call BOOL_CheckLongPress        ; Taste lange gedrckt?
        breq KEYBOARD_CHECK_LP

        cpi r16,$ff                     ; Taste wieder losgelassen?
        brne Keyboard_Check_1

        pop r16
        call Button_displayNormal
KEYBOARD_CHECK_END:
        pop xh
        pop xl
        ret


KEYBOARD_CHECK_LP:
        call LPTIMER_STOP               ; long-press-timer anhalten
        pop r16
        call Button_displayNormal

        ori r17,$10                     ; Bit7 setzen fr LongPressKey
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; Button_InitToneCTRLBar
;--------------------------------------------------------------------
Button_InitToneCtrlBar:
        push r16
        push r17
        push r19
        call LCD240_ClearGraph
        call LCD240_ClearText                  ; initialisieren
        call Button_ClearTable
        ldi r16,$00
        ldi r17,Button_Up
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$01
        ldi r17,Button_Down
        ldi r19,$00
        call Button_DisplaySingle
;        ldi r16,$06
;        ldi r17,Button_OK
;        ldi r19,$00
;        call Button_DisplaySingle
        ldi r16,$07
        ldi r17,Button_AUD
        ldi r19,$00
        call Button_DisplaySingle

        call Tone_DrawBar
        pop r19
        pop r17
        pop r16
        ret


;--------------------------------------------------------------------
; Button_InitChangeDirCTRLBar
;--------------------------------------------------------------------
Button_InitChangeDirCtrlBar:
        push r16
        push r17
        push r19
        call LCD240_ClearGraph
        call LCD240_ClearText                  ; initialisieren
        call Button_ClearTable
        ldi r16,$00
        ldi r17,Button_Up
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$01
        ldi r17,Button_Down
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$02
        ldi r17,Button_PageUp
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$03
        ldi r17,Button_PageDown
        ldi r19,$00
        call Button_DisplaySingle
        ldi r16,$06
        ldi r17,Button_Ret
        ldi r19,$00
        call Button_DisplaySingle

        ldi r16,$07
        ldi r17,Button_OK
        ldi r19,$00
        call Button_DisplaySingle

        pop r19
        pop r17
        pop r16
        ret

