;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; Includefile fr die Change-Directory-Function
;--------------------------------------------------------------------


;--------------------------------------------------------------------
; DIR_FIND_FIRST                Zeroflag: kein Lied
;--------------------------------------------------------------------
DIR_FIND_FIRST:
        push xl
        push xh
        push r16
        ldi xl,low(ERAM_DIRBUFFER)
        ldi xh,high(ERAM_DIRBUFFER)
        sbiw xl,50
        sts IRAM_FIND_ADR,xl
        sts IRAM_FIND_ADR+1,xh
        ldi r16,$ff
        sts IRAM_FIND_NUMBER,r16        ; in FIND_NUMBER $ffff kopieren
        sts IRAM_FIND_NUMBER+1,r16
        call DIR_FIND_NEXT

        set
        breq DIR_FIND_FIRST_END

        clt

DIR_FIND_FIRST_END:
        bld MISC_FLAGS,MISCF_NOFiletoPlay
        pop r16
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; DIR_FIND_LAST:        Z gesetzt wenn nichts gefunden
;--------------------------------------------------------------------
DIR_FIND_NEXT:
        push r17
        push r16
        push xl
        push xh
        push yl
        push yh
        push zl
        push zh

        lds xl,IRAM_FIND_NUMBER
        lds xh,IRAM_FIND_NUMBER+1

        lds yl,IRAM_FIND_ADR
        lds yh,IRAM_FIND_ADR+1

        lds r17,IRAM_FIND_ATTR          ; zu vergleichenden Attribut holen

DIR_FIND_NEXT_0:
        lds zl,IRAM_MENU_MAX_ENTRIES
        lds zh,IRAM_MENU_MAX_ENTRIES+1
        sbiw zl,$01
        cp zl,xl                        ; lo-byte von pos gleich
        brne DIR_FIND_NEXT_1
        cp zh,xh
        brne DIR_FIND_NEXT_1

        lds xl,IRAM_FIND_NUMBER
        lds xh,IRAM_FIND_NUMBER+1
        lds yl,IRAM_FIND_ADR
        lds yh,IRAM_FIND_ADR+1

;        call PLAYINT_STOP               ; anhalten neu!
        jmp DIR_FIND_NEXT_NOTFOUND      ; und Resultat bergeben

DIR_FIND_NEXT_1:
        adiw xl,$01                     ; Position in DIRFILE inkrementieren
        adiw yl,50                      ; Adresse auf nchsten Eintrag
        clc

        push yl
        push yh
        adiw yl,48                      ; Pointer auf Attribute setzen
        ld r16,Y                        ; Attribut nach r16 laden
        and r16,r17                     ; r16 mit Maske undverknpfen
        pop yh
        pop yl
        brne DIR_FIND_NEXT_FOUND        ; war breq!!

        jmp DIR_FIND_NEXT_0

DIR_FIND_NEXT_FOUND:
        clr r16
        sts IRAM_MP3HEADER_FREQUENCY,r16
        sts IRAM_MP3HEADER_BitRate,r16  ; Keine information ber Samplingrate

        clt                             ; FAT nicht gescannt!
        bld MISC_FLAGS,MISCF_FATSCANNED
        bld MISC_FLAGS,MISCF_ID3AVAILABLE

        clz
DIR_FIND_NEXT_END:
        sts IRAM_FIND_NUMBER,xl
        sts IRAM_FIND_NUMBER+1,xh       ; Aktuelle Nummer abspeichern

        sts IRAM_FIND_ADR,yl            ; Adresse von nchsten Eintrag
        sts IRAM_FIND_ADR+1,yh          ; abspeichern

        pop zh
        pop zl
        pop yh
        pop yl
        pop xh
        pop xl
        pop r16
        pop r17
        ret

DIR_FIND_NEXT_NOTFOUND:
        sez                             ; Zero setzen
        rjmp DIR_FIND_NEXT_END


;--------------------------------------------------------------------
; DIR_FIND_LAST:
;--------------------------------------------------------------------
DIR_FIND_LAST:
        push r17
        push r16
        push xl
        push xh
        push yl
        push yh
        push zl
        push zh

;        clt                             ; FAT nicht gescannt!
;        bld MISC_FLAGS,MISCF_FATSCANNED

        lds xl,IRAM_FIND_NUMBER
        lds xh,IRAM_FIND_NUMBER+1

        lds yl,IRAM_FIND_ADR
        lds yh,IRAM_FIND_ADR+1

        lds r17,IRAM_FIND_ATTR          ; zu vergleichenden Attribut holen
;        andi r17,$f0                    ; untere Bits nicht interessant

DIR_FIND_LAST_0:
        adiw xl,$00                     ; 0 zu Position adieren
        breq DIR_FIND_LAST_NOCHANGE     ; Keine nderung

        sbiw xl,$01                     ; Position in DIRFILE dekrementieren
        sbiw yl,50                      ; Adresse auf letzten Eintrag
        clc

        push yl
        push yh
        adiw yl,48                      ; Pointer auf Attribute setzen
        ld r16,Y                        ; Attribut nach r16 laden
        and r16,r17
        pop yh
        pop yl
        brne DIR_FIND_LAST_FOUND

        jmp DIR_FIND_LAST_0            ; Und nocheinmal in der Schleife

DIR_FIND_LAST_NOCHANGE:
        lds xl,IRAM_FIND_NUMBER
        lds xh,IRAM_FIND_NUMBER+1
        lds yl,IRAM_FIND_ADR
        lds yh,IRAM_FIND_ADR+1

        rjmp DIR_FIND_LAST_NOTFOUND
;        call PLAYINT_STOP               ; anhalten

DIR_FIND_LAST_FOUND:
        clr r16
        sts IRAM_MP3HEADER_FREQUENCY,r16
        sts IRAM_MP3HEADER_BitRate,r16  ; Keine information ber Samplingrate

        clt                             ; FAT nicht gescannt!
        bld MISC_FLAGS,MISCF_ID3AVAILABLE
        bld MISC_FLAGS,MISCF_FATSCANNED

        clz

DIR_FIND_LAST_END:
        sts IRAM_FIND_NUMBER,xl
        sts IRAM_FIND_NUMBER+1,xh       ; Aktuelle Nummer abspeichern

        sts IRAM_FIND_ADR,yl            ; Adresse von nchsten Eintrag
        sts IRAM_FIND_ADR+1,yh          ; abspeichern

        pop zh
        pop zl
        pop yh
        pop yl
        pop xh
        pop xl
        pop r16
        pop r17
        ret

DIR_FIND_LAST_NOTFOUND:
        sez
        rjmp DIR_FIND_LAST_END


;--------------------------------------------------------------------
;       FAT32_ReadDIR  (Cluster von Directory)
;--------------------------------------------------------------------
DIR_Read:
        ldi xl,low(IRAM_CLUSTER)
        ldi xh,high(IRAM_CLUSTER)
        ldi zl,low(IRAM_LAST_DIR_CLUSTER)
        ldi zh,high(IRAM_LAST_DIR_CLUSTER)
        call copy32_indirekt

        clt
        bld MISC_FLAGS,MISCF_LAST_LFN

        ldi yl,low(eram_DIRBUFFER)
        ldi yh,high(ERAM_DIRBUFFER)

DIR_Read_1:
        push yl
        push yh
        call FAT32_Get_First_sector_of_Clus    ; Sector von Cluster holen

        ldi zl,low(IRAM_LBA)
        ldi zh,high(IRAM_LBA)
        ldi xl,low(IRAM_FIRST_SEC_OF_CLUS)
        ldi xh,high(IRAM_FIRST_SEC_OF_CLUS)
        call COPY32_INDIREKT                   ; FirstSector in LBA kopieren

        lds r17,IRAM_AR_SPC                    ; SPC-Sektoren pro Cluster

        pop yh
        pop yl
DIR_READ_2:
        push r17
        push yl
        push yh
        ldi xl,low(IRAM_DIRBUFFER)
        ldi xh,high(IRAM_DIRBUFFER)
        ldi r16,$01                     ; einen Sektor laden
        call IDE_READ_LBA              ; Sectoren in RAM laden
        call IDE_INKREMENT_SEKTOR

        pop yh
        pop yl
        call DIR_SCAN_DIRSECTOR

        pop r17
        dec r17
        brne DIR_READ_2

        push xh
        push xl
        push yl
        push yh
        push zl
        push zh
        call FAT32_Get_Next_Cluster
        call FAT32_Check_Cluster       ; Ein EOF-Cluster???
        pop zh
        pop zl
        pop yh
        pop yl
        pop xl
        pop xh

        breq DIR_Read_END

        rjmp DIR_READ_1

DIR_READ_END:
        ret

;--------------------------------------------------------------------
;       DIR_SCAN_DIRSECTOR
;--------------------------------------------------------------------
DIR_SCAN_DIRSECTOR:

        ldi xl,low(IRAM_DIRBUFFER)
        ldi xh,high(IRAM_DIRBUFFER)

DIR_SCAN_DIRSECTOR_0:
        ld r16,X
        cpi r16,$e5                     ; gelscht???
        breq DIR_SCAN_DIRSECTOR_2       ; Ja: ignorieren

        cpi r16,$00                     ; Eintrag leer?
        breq DIR_SCAN_DIRSECTOR_2       ; Ja: ignorieren
        push zl
        push zh
        ldi zl,$c0
        ldi zh,$7f                       ; > als 74c0???
        call DIR_CHECK_YREG_POS
        pop zh
        pop zl
        brcs DIR_SCAN_DIRSECTOR_2       ; Ja: Ignorieren

        push xl
        push xh
        adiw xl,11                      ; offset auf Attrib stellen
        ld r16,X                        ; Attrib holen
        pop xh
        pop xl

        cpi r16,$0f                     ; Long filename???
        brne DIR_SCAN_DIRSECTOR_1

        call DIR_SCAN_DIRSECTOR_LFN    ; Longfilename einlesen
        jmp DIR_SCAN_DIRSECTOR_2

DIR_SCAN_DIRSECTOR_1:
        call DIR_SCAN_DIRSECTOR_NORMAL

DIR_SCAN_DIRSECTOR_2:
        adiw xl,32                      ; um 32 inkrementieren

        cpi xl,$00
        brne DIR_SCAN_DIRSECTOR_0
        cpi xh,$04                      ; Adresse $0200+$0200 erreicht?
        brne DIR_SCAN_DIRSECTOR_0       ; Nein: Dann noch eine Runde

        ret

;--------------------------------------------------------------------
;       DIR_SCAN_DIRSECTOR_NORMAL
;--------------------------------------------------------------------
DIR_SCAN_DIRSECTOR_NORMAL:
        sbrc MISC_FLAGS,MISCF_LAST_LFN
        rjmp DIR_SCAN_DIRSECTOR_NORMAL_2

        push yl
        push yh
        push xl
        push xh
        ldi r18,11                      ; 11 Zeichen kopieren
DIR_SCAN_DIRSECTOR_NORMAL_1:
        ld r16,X+                       ; Zeichen holen und
        st Y+,r16
        dec r18                         ; in DIRBUFFER abspeichern
        brne DIR_SCAN_DIRSECTOR_NORMAL_1

        pop xh
        pop xl
        pop yh
        pop yl

DIR_SCAN_DIRSECTOR_NORMAL_2:
        push yl
        push yh
        push xl
        push xh

        adiw yl,23
        adiw yl,19                      ; 82 dazuzhlen

        adiw xl,20                      ; Auf Hi-word von Cluster setzen

        ld r16,X+                       ; und unter Offset 82 abspeichern
        st Y+,r16
        ld r16,X+
        st Y+,r16

        adiw xl,4                       ; Auf lo-Word von Cluster setzen
        sbiw yl,4                       ; Y auf lo-word von Cluster
        ld r16,X+
        st Y+,r16
        ld r16,X+
        st Y+,r16

        adiw yl,2                       ; Y auf Size setzen
        ld r16,X+                       ; Gre von File reinkopieren
        st Y+,r16
        ld r16,X+
        st Y+,r16
        ld r16,X+
        st Y+,r16
        ld r16,X+
        st Y+,r16

        sbiw xl,21                      ; Auf Attribute setzen
        ld r16,X+
        st Y+,r16

        lds xl,IRAM_MENU_MAX_ENTRIES
        lds xh,IRAM_MENU_MAX_ENTRIES+1
        adiw xl,1
        sts IRAM_MENU_MAX_ENTRIES,xl
        sts IRAM_MENU_MAX_ENTRIES+1,xh

        pop xh
        pop xl
        pop yh
        pop yl

        adiw yl,25                      ; zu Y 50 dazuzhlen
        adiw yl,25

        clt
        bld MISC_FLAGS,MISCF_LAST_LFN

        ret



;--------------------------------------------------------------------
;       DIR_SCAN_DIRSECTOR_LFN
;--------------------------------------------------------------------
DIR_SCAN_DIRSECTOR_LFN_SUB1:
        ld r16,X+                       ; Zeichen 1 holen
        cpi r16,$00
        brne DIR_SCAN_DIRSECTOR_LFN_SUB1_1

        ldi r16,32

DIR_SCAN_DIRSECTOR_LFN_SUB1_1:
        cpi r16,$ff
        brne DIR_SCAN_DIRSECTOR_LFN_SUB1_2

        ldi r16,32

DIR_SCAN_DIRSECTOR_LFN_SUB1_2:

        adiw xl,1                       ; X inkrementieren und

        call DIR_CHECK_YREG_POS


        call DIR_CHECK_YREG_POS
        brcs DIR_SCAN_DIRSECTOR_LFN_SUB1_4

        st Y+,r16                       ; im Speicher abspeichern

DIR_SCAN_DIRSECTOR_LFN_SUB1_4:
        dec r18                         ; erste 5 Zeichen holen
        brne DIR_SCAN_DIRSECTOR_LFN_SUB1

        ret


DIR_SCAN_DIRSECTOR_LFN:
        push xl
        push xh
        push yl                         ; Y wird nur inkrementiert wenn letze
        push yh                         ; Sequenz
        push zl
        push zh
        mov zl,yl
        mov zh,yh
        adiw zl,40                      ; 40 Bytes als Grenze definieren

        ld r17,X+                       ; Controlbyte fr LONGNAME
        andi r17,$3f                    ; Anzahl der Long-Name-Sequenzen

        dec r17
        push r17
DIR_SCAN_DIRSECTOR_LFN_1:
        and r17,r17
        breq DIR_SCAN_DIRSECTOR_LFN_2
        dec r17                         ; Wenn
        adiw yl,13                      ; Pro Eintrag 13 Bytes!!!
        jmp DIR_SCAN_DIRSECTOR_LFN_1

DIR_SCAN_DIRSECTOR_LFN_2:
        ldi r18,$5
        call DIR_SCAN_DIRSECTOR_LFN_SUB1
        adiw xl,3                       ; 4 dazuzhlen

        ldi r18,$6
        call DIR_SCAN_DIRSECTOR_LFN_SUB1
        adiw xl,2                       ; 4 dazuzhlen

        ldi r18,$2
        call DIR_SCAN_DIRSECTOR_LFN_SUB1

        pop r17
        pop zh
        pop zl
        pop yh
        pop yl
        and r17,r17
        brne DIR_SCAN_DIRSECTOR_LFN_6

DIR_SCAN_DIRSECTOR_LFN_6:
        set
        bld MISC_FLAGS,MISCF_LAST_LFN

        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; DIR_GET_TRUE_ADR        X:word
;--------------------------------------------------------------------
DIR_GETOFS:
        push yl
        push yh
        push r18
        ldi xl,low(ERAM_DIRBUFFER)
        ldi xh,high(ERAM_DIRBUFFER)

        lds yl,IRAM_MENU_PAGE
        lds yh,IRAM_MENU_PAGE+1

DIR_GETOFS_1:
        call DIR_IS_Y_ZERO             ; Y schon 0?
        breq DIR_GETOFS_2

        adiw xl,25                      ; Zum Offset 32 dazuaddieren
        adiw xl,25

        sbiw yl,$01
        jmp DIR_GETOFS_1

DIR_GETOFS_2:
        pop r18
        pop yh
        pop yl
        ret

;--------------------------------------------------------------------
; DIR_GET_TRUE_ADR        X:word
;--------------------------------------------------------------------
DIR_GET_TRUE_ADR:
        push yl
        push yh
        push r18
        push r17
        ldi xl,low(ERAM_DIRBUFFER)
        ldi xh,high(ERAM_DIRBUFFER)

        lds yl,IRAM_MENU_PAGE
        lds yh,IRAM_MENU_PAGE+1

        lds r17,IRAM_MENU_YPOS
        clr r18

        add yl,r17                      ; YPOS dazuzhlen
        adc yh,r18

DIR_GET_TRUE_ADR_1:
        call DIR_IS_Y_ZERO             ; Y schon 0?
        breq DIR_GET_TRUE_ADR_2

        adiw xl,25                      ; Zum Offset 32 dazuaddieren
        adiw xl,25

        sbiw yl,$01
        jmp DIR_GET_TRUE_ADR_1

DIR_GET_TRUE_ADR_2:
        pop r17
        pop r18
        pop yh
        pop yl
        ret


;--------------------------------------------------------------------
; DIR_DISPLAY_BLANK
;--------------------------------------------------------------------
DIR_DISPLAY_BLANK:
        call LCD240_Automodeon

DIR_DISPLAY_BLANK_1:        
        ldi r16,0
        call LCD240_WriteData
        call LCD240_INKREMENT_ADP
        dec r18
        brne DIR_DISPLAY_BLANK_1

        call LCD240_Automodeoff
        ret

;--------------------------------------------------------------------
;       DIR_DISPLAY
;--------------------------------------------------------------------
DIR_DISPLAY:
        call DIR_GETOFS

        ldi r19,6

DIR_DISPLAY_1:
        push xl
        push xh
        ldi r16,0
        ldi r17,6
        sub r17,r19
        call LCD240_SetCursor

        pop xh
        pop xl

        ldi r18,40

        ld r16,X
        cpi r16,0                       ; ist ein 0-Byte am Anfang?
        brne DIR_DISPLAY_2

        call DIR_DISPLAY_BLANK
        jmp DIR_DISPLAY_3

DIR_DISPLAY_2:

        call LCD240_OutString_IRAM

DIR_DISPLAY_3:
        adiw xl,25
        adiw xl,23                      ; um 48 inkrementieren

        ld r16,X+
        adiw xl,$01

        dec r19
        brne DIR_DISPLAY_1
        call BAR_DISPLAY

        call DIR_GETOFS

        ret

;--------------------------------------------------------------------
;  DIR_PAGE_UP
;--------------------------------------------------------------------
DIR_DEKREMENT_YPOS:
        push r18
        push yl
        push yh
        lds r16,IRAM_MENU_YPOS
        cpi r16,0                       ; Ypos von Balken holen
        breq DIR_DEKREMENT_YPOS_1       ; Wenn oben dann PAGE dekrement

        call BAR_CLEAR                  ; Balken lschen
        dec r16                         ; Wenn nicht dann dekrementieren
        sts IRAM_MENU_YPOS,r16
        call BAR_DISPLAY                ; und neuen Balken darstellen
        jmp DIR_DEKREMENT_YPOS_END     ; und beenden

DIR_DEKREMENT_YPOS_1:
        lds yl,IRAM_MENU_PAGE
        lds yh,IRAM_MENU_PAGE+1

        call DIR_IS_Y_ZERO
        breq DIR_DEKREMENT_YPOS_END

        sbiw yl,$01                     ; Y=Y-1

        sts IRAM_MENU_PAGE,yl
        sts IRAM_MENU_PAGE+1,yh
        call DIR_DISPLAY

DIR_DEKREMENT_YPOS_END:
        pop yh
        pop yl
        pop r18
        ldi r17,8
        ret

;--------------------------------------------------------------------
;  DIR_PAGE_UP
;--------------------------------------------------------------------
DIR_INKREMENT_YPOS_SUB1:
        lds yl,IRAM_MENU_PAGE
        lds yh,IRAM_MENU_PAGE+1
        push yl
        push yh

        lds zl,IRAM_MENU_YPOS
        lds zh,IRAM_MENU_YPOS+1

        add yl,zl                      ; YPOS dazuzhlen
        adc yh,zh

        lds zl,IRAM_MENU_MAX_ENTRIES
        lds zh,IRAM_MENU_MAX_ENTRIES+1

        adiw yl,$01

        call DIR_COMPARE_Y_Z           ; Grer als erlaubt???
        pop yh
        pop yl
        ret

DIR_INKREMENT_YPOS:
        push r18
        push zl
        push zh

        call DIR_INKREMENT_YPOS_SUB1
        breq DIR_INKREMENT_YPOS_END

        lds r16,IRAM_MENU_YPOS
        cpi r16,5                       ; Ypos von Balken holen
        breq DIR_INKREMENT_YPOS_1       ; Wenn oben dann PAGE dekrement

        call BAR_CLEAR                 ; Balken lschen
        inc r16                         ; Wenn nicht dann dekrementieren
        sts IRAM_MENU_YPOS,r16
        call BAR_DISPLAY               ; und neuen Balken darstellen
        jmp DIR_INKREMENT_YPOS_END     ; und beenden

DIR_INKREMENT_YPOS_1:
        call DIR_INKREMENT_YPOS_SUB1
        breq DIR_INKREMENT_YPOS_END


        adiw yl,$01                     ; Y=Y+1


        sts IRAM_MENU_PAGE,yl
        sts IRAM_MENU_PAGE+1,yh
        call DIR_DISPLAY

DIR_INKREMENT_YPOS_END:
        pop zh
        pop zl
        pop r18
        ldi r17,8
        ret


;--------------------------------------------------------------------
;       DIR_CHECK_FOR_ROOT      Wenn Cluster 0 dann cluster 2!
;--------------------------------------------------------------------
DIR_CHECK_FOR_ROOT:
        lds r16,IRAM_CLUSTER
        and r16,r16
        brne DIR_CHECK_FOR_ROOT_1

        lds r16,IRAM_CLUSTER+1
        and r16,r16
        brne DIR_CHECK_FOR_ROOT_1

        lds r16,IRAM_CLUSTER+2
        and r16,r16
        brne DIR_CHECK_FOR_ROOT_1

        lds r16,IRAM_CLUSTER+3
        and r16,r16
        brne DIR_CHECK_FOR_ROOT_1

        lds r16,IRAM_ROOTCLUSTER
        sts IRAM_CLUSTER,R16
        lds r16,IRAM_ROOTCLUSTER+1
        sts IRAM_CLUSTER+1,R16
        lds r16,IRAM_ROOTCLUSTER+2
        sts IRAM_CLUSTER+2,R16
        lds r16,IRAM_ROOTCLUSTER+3
        sts IRAM_CLUSTER+3,R16

;        ldi r16,$02
;        sts IRAM_CLUSTER,r16

DIR_CHECK_FOR_ROOT_1:
        ret

;--------------------------------------------------------------------
;       DIR_CHANGE_FROM_DIR
;--------------------------------------------------------------------
DIR_CHANGE_FROM_DIR:

        call DIR_GET_TRUE_ADR                ; offset fr aktuellen Eintrag
        adiw xl,23
        adiw xl,17
        ld r16,X+
        sts IRAM_CLUSTER,r16
        ld r16,X+
        sts IRAM_CLUSTER+1,r16
        ld r16,X+
        sts IRAM_CLUSTER+2,r16
        ld r16,X+
        sts IRAM_CLUSTER+3,r16

        call DIR_CHECK_FOR_ROOT

        CLR R16
        sts IRAM_MENU_YPOS,r16
        sts IRAM_MENU_YPOS+1,r16
        sts IRAM_MENU_PAGE,r16
        sts IRAM_MENU_PAGE+1,r16

        ret

;--------------------------------------------------------------------
;       DIR_GET_CLUSTER_FROM_FIND
;--------------------------------------------------------------------
DIR_GET_CLUSTER_FROM_FIND:
        push xl
        push xh
;        call DIR_GET_TRUE_ADR                ; offset fr aktuellen Eintrag

        lds xl,IRAM_FIND_ADR
        lds xh,IRAM_FIND_ADR+1

        adiw xl,23
        adiw xl,17
        ld r16,X+
        sts IRAM_CLUSTER,r16
        ld r16,X+
        sts IRAM_CLUSTER+1,r16
        ld r16,X+
        sts IRAM_CLUSTER+2,r16
        ld r16,X+
        sts IRAM_CLUSTER+3,r16

;        call DIR_CHECK_FOR_ROOT

        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
;       DIR_GET_FILESIZE_FROM_FIND
;--------------------------------------------------------------------
DIR_GET_FILESIZE_FROM_FIND:
        push xl
        push xh
        push r16
;        call DIR_GET_TRUE_ADR                ; offset fr aktuellen Eintrag

        lds xl,IRAM_FIND_ADR
        lds xh,IRAM_FIND_ADR+1

        adiw xl,23
        adiw xl,21
        ld r16,X+
        sts IRAM_FILESIZE,r16
        ld r16,X+
        sts IRAM_FILESIZE+1,r16
        ld r16,X+
        sts IRAM_FILESIZE+2,r16
        ld r16,X+
        sts IRAM_FILESIZE+3,r16

;        call DIR_CHECK_FOR_ROOT

        pop r16
        pop xh
        pop xl
        ret



;--------------------------------------------------------------------
;       DIR_CLEAR
;--------------------------------------------------------------------
DIR_CLEAR:
        clr r16
;        sts IRAM_MENU_YPOS,r16
;        sts IRAM_MENU_YPOS+1,r16
;        sts IRAM_MENU_PAGE,r16
;        sts IRAM_MENU_PAGE+1,r16
        sts IRAM_MENU_MAX_ENTRIES,r16
        sts IRAM_MENU_MAX_ENTRIES+1,r16
        ldi xl,low(ERAM_DIRBUFFER)
        ldi xh,high(ERAM_DIRBUFFER)

        ldi yl,$ff
        ldi yh,$6f

        ldi r16,32
DIR_CLEAR_1:
        st X+,r16
        sbiw yl,$01
        brne DIR_CLEAR_1

        ret

;--------------------------------------------------------------------
; PLAY_FROM_DIR
;--------------------------------------------------------------------
PLAY_FROM_DIR:
        call DIR_GET_TRUE_ADR
        sts IRAM_FIND_ADR,xl
        sts IRAM_FIND_ADR+1,xh

        lds yl,IRAM_MENU_PAGE
        lds yh,IRAM_MENU_PAGE+1

        lds r17,IRAM_MENU_YPOS
        clr r18

        add yl,r17                      ; YPOS dazuzhlen
        adc yh,r18

        sts IRAM_FIND_NUMBER,yl
        sts IRAM_FIND_NUMBER+1,yh

        clr r16
        sts IRAM_MP3HEADER_FREQUENCY,r16
        sts IRAM_MP3HEADER_BitRate,r16  ; Keine information ber Samplingrate

        clt
        bld MISC_FLAGS,MISCF_NoFileToPlay
        bld MISC_FLAGS,MISCF_ID3AVAILABLE
        bld MISC_FLAGS,MISCF_FATSCANNED

        ret

;--------------------------------------------------------------------
; DIR_INIT
;--------------------------------------------------------------------
DIR_INIT:
        ldi r16,$02
        sts IRAM_LAST_DIR_CLUSTER,r16
        clr r16
        sts IRAM_LAST_DIR_CLUSTER+1,r16
        sts IRAM_LAST_DIR_CLUSTER+2,r16
        sts IRAM_LAST_DIR_CLUSTER+3,r16
        ret

;--------------------------------------------------------------------
;  DIR_CHANGE_DIR
;--------------------------------------------------------------------
DIR_CHANGE:

        ldi r17,$ff
        call waitlong

        call MP3DEC_WAIT_FOR_DEMAND

        ldi r17,$ff
        call waitlong

        call IDE_CLEARBUFFER

        call Button_InitChangeDirCtrlBar

        ldi zl,low(IRAM_CLUSTER)
        ldi zh,high(IRAM_CLUSTER)
        ldi xl,low(IRAM_LAST_DIR_CLUSTER)
        ldi xh,high(IRAM_LAST_DIR_CLUSTER)
        call copy32_indirekt

        call LCD240_ClearText

DIR_CHANGE_READAGAIN:
        call DIR_CLEAR
        call DIR_READ                   ; Directory einlesen

        call DIR_DISPLAY                ; Directory anzeigen

DIR_CASE:
        call Keyboard_check
;        ldi r17,$08

DIR_CASE_0:
        cpi r17,$00
        brne DIR_CASE_1

        call DIR_DEKREMENT_YPOS         ; Tone-Control ausgewhlt

DIR_CASE_1:
        cpi r17,$01
        brne DIR_CASE_2

        call DIR_INKREMENT_YPOS

DIR_CASE_2:
        cpi r17,$02
        brne DIR_CASE_3

        ldi r18,5
DIR_CASE_2_1:
        call DIR_deKREMENT_YPOS
        dec r18
        brne DIR_CASE_2_1

DIR_CASE_3:

        cpi r17,$03
        brne DIR_CASE_4

        ldi r18,5

DIR_CASE_3_1:
        call DIR_INKREMENT_YPOS
        dec r18
        brne DIR_CASE_3_1
        
DIR_CASE_4:

        cpi r17,$06
        brne DIR_CASE_5

        call DIR_GET_TRUE_ADR
        adiw xl,48                      ; Attribute in R16 laden
        ld r16,X

        andi r16,$10                    ; Directory?
        brne DIR_CASE_4_1               ; nein: Dann nicht wechseln TEST!!! DIR_CASE_5
        jmp DIR_CASE_PLAY_FILE

DIR_CASE_4_1:
        lds r16,IRAM_MENU_YPOS
        call BAR_CLEAR

        call DIR_CHANGE_FROM_DIR
        jmp DIR_CHANGE_READAGAIN

DIR_CASE_5:

        cpi r17,$07
        brne DIR_CASE_6

DIR_CASE_END:

        call BUTTON_InitPlayBar

        call DIR_FIND_FIRST             ; Erstes File suchen
;        call DISPLAY_PLAYSCREEN
DIR_CASE_END_2:
        call PLAYINT_STOP               ; Anhalten sonst Konflikt
        call PLAY_INIT                  ; Song initialisieren und

        ldi r17,$08
        ret                             ; ChangeDir funktion beenden

DIR_CASE_6:
        jmp DIR_CASE


DIR_CASE_PLAY_FILE:
        call BUTTON_InitPlayBar
        call PLAY_FROM_DIR              ; Informationen laden und file
        call PLAY_INIT

        set
        bld MISC_Flags,MISCF_PLAYSCREEN ; Vortschritt bei Scanning erlauben

        call PLAYINT_START              ; abspielen

        clt
        bld MISC_Flags,MISCF_PLAYSCREEN ; Und wieder abschalten

        ldi r17,KEY_NONE
        ret
