;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;               Includefile for FAT32 implementation
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; FAT32_CHECK_BPS
;--------------------------------------------------------------------
FAT32_CHECK_BPS:
        ldi xl,low(IRAM_FAT32_BPS+1)
        ldi xh,high(IRAM_FAT32_BPS+1)
        ld r16,X+
        cpi r16,$02                     ; 512 Bytes per Sec???
        breq FAT32_CHECK_BPS_1          ; Ja: Keinen Fehler ausgeben!

        ldi zl,low(2*MSG_illegal_BPS)
        ldi zh,high(2*MSG_illegal_BPS)
        call SYSTEM_HALT               ; System anhalten!

FAT32_CHECK_BPS_1:
        ret

;--------------------------------------------------------------------
;       FAT32_DISPLAY_OEMNAME
;--------------------------------------------------------------------
FAT32_DISPLAY_OEMNAME:
        clr r16
        clr r17
        ldi zl,low(2*MSG_OEMNAME)
        ldi zh,high(2*MSG_OEMNAME)
        call LCD240_OutStringXY

        ldi xl,low(IRAM_FAT32_OEMNAME)
        ldi xh,high(IRAM_FAT32_OEMNAME)
        ldi r18,8
        call lCD240_OUTSTRING_IRAM
        ret

;--------------------------------------------------------------------
;       FAT32_DISPLAY_SPC
;--------------------------------------------------------------------
FAT32_DISPLAY_SPC:
        clr r16
        ldi r17,2
        ldi zl,low(2*MSG_SPC)
        ldi zh,high(2*MSG_SPC)
        call LCD240_OutStringXY

        ldi xl,low(IRAM_FAT32_SPC)
        ldi xh,high(IRAM_FAT32_SPC)
        ldi r17,$00
        ld r16,X+

        call bin2bcd16                 ; in Dezimal konvertieren

        mov r16,tBCD1
        call LCD240_OutVal
        mov r16,tBCD0
        call LCD240_OutVal

        ret

;--------------------------------------------------------------------
;       FAT32_Copy_SPC
;--------------------------------------------------------------------
FAT32_COPY_SPC:
        ldi xl,low(IRAM_AR_SPC)
        ldi xh,high(IRAM_AR_SPC)

        lds r16,IRAM_FAT32_SPC         ; Lo-Byte abspeichern
        sts IRAM_AR_SPC,r16
        clr r16
        sts IRAM_AR_SPC+1,r16
        sts IRAM_AR_SPC+2,r16
        sts IRAM_AR_SPC+3,r16

        ret

;--------------------------------------------------------------------
;       FAT32_DISPLAY_SPC
;--------------------------------------------------------------------
FAT32_DISPLAY_ROOTCLUSTER:
        clr r16
        ldi r17,3
        ldi zl,low(2*MSG_ROOTCLUSTER)
        ldi zh,high(2*MSG_ROOTCLUSTER)
        call LCD240_OutStringXY

        ldi xl,low(IRAM_FAT32_ROOTCLUSTER)
        ldi xh,high(IRAM_FAT32_ROOTCLUSTER)
        ldi r17,$00
        ld r16,X+

        call bin2bcd16                 ; in Dezimal konvertieren

        mov r16,tBCD2
        call LCD240_OutVal
        mov r16,tBCD1
        call LCD240_OutVal
        mov r16,tBCD0
        call LCD240_OutVal

        ret


;--------------------------------------------------------------------
;       FAT32_Copy_RsvdSecCnt
;--------------------------------------------------------------------
FAT32_COPY_RSVDSECCNT:
        ldi xl,low(IRAM_AR_RsvdSecCnt)
        ldi xh,high(IRAM_AR_RsvdSecCnt)

        lds r16,IRAM_FAT32_RsvdSecCnt   ; Lo-Byte abspeichern
        st X+,r16

        lds r16,IRAM_FAT32_RsvdSecCnt+1 ; Hi-Byte abspeichern
        st X+,r16

        clr r16
        st X+,r16
        st X+,r16
        ret

;--------------------------------------------------------------------
;       FAT32_Copy_NumOfFats
;--------------------------------------------------------------------
FAT32_COPY_NumOfFats:
        ldi xl,low(IRAM_AR_NumofFats)
        ldi xh,high(IRAM_AR_NumOfFats)

        lds r16,IRAM_FAT32_NUMOfFats   ; Lo-Byte abspeichern
        st X+,r16

        clr r16
        st X+,r16
        st X+,r16
        st X+,r16
        ret

;--------------------------------------------------------------------
;       FAT32_Copy_RootClus
;--------------------------------------------------------------------
FAT32_Copy_RootClus:
        ldi xl,low(IRAM_FAT32_ROOTCLUSTER)
        ldi xh,high(IRAM_FAT32_ROOTCLUSTER)

        ldi yl,low(IRAM_ROOTCLUSTER)
        ldi yh,high(IRAM_ROOTCLUSTER)

        ld r16,X+
        st Y+,r16
        ld r16,X+
        st Y+,r16
        ld r16,X+
        st Y+,r16
        ld r16,X+
        st Y+,r16

        ret


;--------------------------------------------------------------------
;       FAT32_Copy_FatSize
;--------------------------------------------------------------------
FAT32_COPY_FatSize:
        ldi xl,low(IRAM_AR_FatSize)
        ldi xh,high(IRAM_AR_FatSize)

        lds r16,IRAM_FAT32_Fatsize   ; Lo-Byte abspeichern
        st X+,r16
        lds r16,IRAM_FAT32_Fatsize+1   ; Lo-Byte abspeichern
        st X+,r16
        lds r16,IRAM_FAT32_Fatsize+2   ; Lo-Byte abspeichern
        st X+,r16
        lds r16,IRAM_FAT32_Fatsize+3   ; Lo-Byte abspeichern
        st X+,r16

        ret

;--------------------------------------------------------------------
; FAT32_Get_First_Data_Sec
;
; FirsDataSector=(NumberOfFat * FatSize) + ResvdSecCnt + 63
;--------------------------------------------------------------------
FAT32_Get_First_Data_Sec:
        ldi zl,low(IRAM_AR_FIRSTDSECTOR)     ; Ergebnis in FirstDataSector
        ldi zh,high(IRAM_AR_FIRSTDSECTOR)

        ldi xl,low(IRAM_AR_NUMOFFATS)
        ldi xh,high(IRAM_AR_NUMOFFATS)

        ldi yl,low(IRAM_AR_FATSIZE)
        ldi yh,high(IRAM_AR_FATSIZE)

        call MUL32_INDIREKT                 ; Ergebnis Multiplizieren

        ldi zl,low(IRAM_AR_FirstDSector)     ; Ergebnis wieder in FDS
        ldi zh,high(IRAM_AR_FirstDSector)
        mov yl,zl
        mov yh,zh

        ldi xl,low(IRAM_AR_RsvdSecCnt)
        ldi xh,high(IRAM_AR_RsvdSecCnt)

        call ADD32_INDIREKT

        ldi r16,63
        sts IRAM_AR_RESULT1,r16
        clr r16
        sts IRAM_AR_RESULT1+1,r16
        sts IRAM_AR_RESULT1+2,r16
        sts IRAM_AR_RESULT1+3,r16

        ldi xl,low(IRAM_AR_RESULT1)             ; hilfswert 63 abspeichern
        ldi xh,high(IRAM_AR_RESULT1)

        ldi zl,low(IRAM_AR_FirstDSector)     ; Ergebnis wieder in FDS
        ldi zh,high(IRAM_AR_FirstDSector)
        mov yl,zl
        mov yh,zh

        call ADD32_INDIREKT

        ret

;--------------------------------------------------------------------
; FAT32_Get_First_Sector_of_Cluster
;
; First-Sec-Of-Clus, Cluster in Cluster
;
; IRAM_First_Sec_Of_Clus= ((N-2)*BPB_SecPerClus) + FirstDataSector
;--------------------------------------------------------------------
FAT32_Get_First_Sector_of_Clus:
        ldi xl,low(IRAM_CLUSTER)
        ldi xh,high(IRAM_CLUSTER)

        ldi r16,2
        sts IRAM_AR_RESULT1,r16
        clr r16
        sts IRAM_AR_RESULT1+1,r16
        sts IRAM_AR_RESULT1+2,r16
        sts IRAM_AR_RESULT1+3,r16

        ldi yl,low(IRAM_AR_RESULT1)
        ldi yh,high(IRAM_AR_RESULT1)

        ldi zl,low(IRAM_FIRST_SEC_OF_CLUS)
        ldi zh,high(IRAM_FIRST_SEC_OF_CLUS)

        call SUB32_INDIREKT            ; von cluster 2 abziehen

        mov yl,zl
        mov yh,zh


        ldi yl,low(IRAM_FIRST_SEC_OF_CLUS)
        ldi yh,high(IRAM_FIRST_SEC_OF_CLUS)
        mov zl,yl
        mov zh,yh

        ldi xl,low(IRAM_AR_SPC)
        ldi xh,high(IRAM_AR_SPC)

        call MUL32_INDIREKT            ; * Sectorper Cluster multiplizieren

        ldi zl,low(IRAM_FIRST_SEC_OF_CLUS)
        ldi zh,high(IRAM_FIRST_SEC_OF_CLUS)
        mov yl,zl
        mov yh,zh

        ldi xl,low(IRAM_AR_FIRSTDSECTOR)
        ldi xh,high(IRAM_AR_FIRSTDSECTOR)

        call ADD32_INDIREKT            ; und ersten Datasector addieren

        ret

;--------------------------------------------------------------------
; FAT32_GET_NEXT_CLUSTER
; Holt aus der FAT den nchsten Cluster raus IRAM_NEXT_CLUSTER
; und IRAM_CLUSTER
;
; ThisFatSecNr= RsvdSecCnt+ (FatOffset / 512) + 63
; ThisFatEntOfs= Restvon (FatOffset /512) + Bufferoffset
;
;--------------------------------------------------------------------
FAT32_GET_NEXT_CLUSTER:
        ldi zl,low(IRAM_AR_RESULT1)             ; Ergebnis in RESULT1
        ldi zh,high(IRAM_AR_RESULT1)

        ldi xl,low(IRAM_CLUSTER)
        ldi xh,high(IRAM_CLUSTER)
        call mul32_by4_INDIREKT                ; mit 4 multiplizeren


        ldi zl,low(IRAM_THIS_FAT_SEC_NR)        ; Ergebnis in Z
        ldi zh,high(IRAM_THIS_FAT_SEC_NR)

        ldi yl,low(IRAM_THIS_FAT_ENT_OFS)       ; Rest von Division /512
        ldi yh,high(IRAM_THIS_FAT_ENT_OFS)

        ldi xl,low(IRAM_AR_RESULT1)
        ldi xh,high(IRAM_AR_RESULT1)

        call DIV32_By512_INDIREKT              ; Division ausfhren

        ldi zl,low(IRAM_THIS_FAT_SEC_NR)
        ldi zh,high(IRAM_THIS_FAT_SEC_NR)

        mov yl,zl
        mov yh,zh

        ldi xl,low(IRAM_AR_RsvdSecCnt)
        ldi xh,high(IRAM_AR_RsvdSecCnt)

        call ADD32_INDIREKT                    ; Zu Reserved Sectors addieren

        ldi zl,low(IRAM_THIS_FAT_SEC_NR)
        ldi zh,high(IRAM_THIS_FAT_SEC_NR)

        mov yl,zl
        mov yh,zh

        ldi r16,63
        sts IRAM_AR_RESULT1,r16
        clr r16
        sts IRAM_AR_RESULT1+1,r16
        sts IRAM_AR_RESULT1+2,r16
        sts IRAM_AR_RESULT1+3,r16

        ldi xl,low(IRAM_AR_RESULT1)
        ldi xh,high(IRAM_AR_RESULT1)

        call ADD32_INDIREKT                    ; Und nochmal 63 sektoren addieren

        ldi zl,low(IRAM_LBA)
        ldi zh,high(IRAM_LBA)

        ldi xl,low(IRAM_THIS_FAT_SEC_NR)
        ldi xh,high(IRAM_THIS_FAT_SEC_NR)

        call COPY32_INDIREKT                   ; Ergebnis nach LBA kopieren

        ldi r16,1                               ; Einen Sektor einlesen
        ldi xl,low(IRAM_FATBUFFER)
        ldi xh,high(IRAM_FATBUFFER)
        call IDE_READ_LBA                      ; Sektor einlesen


        ldi zl,low(IRAM_THIS_FAT_ENT_OFS)
        ldi zh,high(IRAM_THIS_FAT_ENT_OFS)

        mov yl,zl
        mov yh,zh

        ldi r16,low(IRAM_FATBUFFER)
        sts IRAM_AR_RESULT1,r16
        ldi r16,high(IRAM_FATBUFFER)            ; FAT-Buffer dazuzhlen
        sts IRAM_AR_RESULT1+1,r16
        clr r16
        sts IRAM_AR_RESULT1+2,r16
        sts IRAM_AR_RESULT1+3,r16

        ldi xl,low(IRAM_AR_RESULT1)
        ldi xh,high(IRAM_AR_RESULT1)

        call ADD32_INDIREKT

        lds xl,IRAM_THIS_FAT_ENT_OFS            ; Adresse nach X kopieren
        lds xh,IRAM_THIS_FAT_ENT_OFS+1

        ldi zl,low(IRAM_CLUSTER)
        ldi zh,high(IRAM_CLUSTER)               ; Cluster wird direkt berschrieben

        call COPY32_INDIREKT                   ; und clusterinfo rauskopieren

        ret

;--------------------------------------------------------------------
; FAT32_CHECK_EOF       Carry gesetzt??? Dann EOF!
;
; Carry wird gesetzt wenn CLUSTER den Wert ?FFFFFF?h beinhaltet
;--------------------------------------------------------------------
FAT32_CHECK_CLUSTER:
        clz                             ; Carry lschen
        lds r16,IRAM_CLUSTER
        andi r16,$f0
        cpi r16,$f0
        brne FAT32_CHECK_CLUSTER_END

        lds r16,IRAM_CLUSTER+1
        cpi r16,$ff
        brne FAT32_CHECK_CLUSTER_END

        lds r16,IRAM_CLUSTER+2
        cpi r16,$ff
        brne FAT32_CHECK_CLUSTER_END

        lds r16,IRAM_CLUSTER+3
        andi r16,$0f
        cpi r16,$0f
        brne FAT32_CHECK_CLUSTER_END

        sez                             ; Carry setzen wenn EOF

FAT32_CHECK_CLUSTER_END:
        ret


;--------------------------------------------------------------------
;       FAT32_ReadBPB
;--------------------------------------------------------------------
FAT32_ReadBPB:
        ldi r16,63
        sts IRAM_LBA,r16
        clr r16
        sts IRAM_LBA+1,r16
        sts IRAM_LBA+2,r16
        sts IRAM_LBA+3,r16

        ldi r16,$01                     ; einen Sektor laden
        ldi xl,low(IRAM_FAT32_BPB)
        ldi xh,high(IRAM_FAT32_BPB)

        call IDE_READ_LBA

        call FAT32_CHECK_BPS            ; Sectorgre 512 Bytes???

        call LCD240_ClearText
;        call FAT32_DISPLAY_OEMNAME
;        call FAT32_DISPLAY_SPC         ; Sectoren per Cluster anzeigen
;        call FAT32_DISPLAY_ROOTCLUSTER

        call FAT32_COPY_RSVDSECCNT      ; Zum Ausrechnen des ersten Data-
        call FAT32_COPY_NumOfFats       ; Sectors
        call FAT32_COPY_FatSize
        call FAT32_COPY_SPC
        call FAT32_Copy_RootClus        ; Root-Cluster kopieren

        call FAT32_GET_FIRST_DATA_SEC

        lds r16,IRAM_ROOTCLUSTER
        sts IRAM_CLUSTER,R16
        lds r16,IRAM_ROOTCLUSTER+1
        sts IRAM_CLUSTER+1,R16
        lds r16,IRAM_ROOTCLUSTER+2
        sts IRAM_CLUSTER+2,R16
        lds r16,IRAM_ROOTCLUSTER+3
        sts IRAM_CLUSTER+3,R16

;        ldi r16,$02                     ; RootDirectory laden
;        sts IRAM_CLUSTEr,r16
;        clr r16
;        sts IRAM_CLUSTER+1,r16
;        sts IRAM_CLUSTER+2,r16
;        sts IRAM_CLUSTER+3,r16

        call DIR_CLEAR
        call DIR_READ                   ; Directory einlesen

        lds yl,IRAM_MENU_MAX_ENTRIES
        lds yh,IRAM_MENU_MAX_ENTRIES+1

        call DIR_IS_Y_ZERO

        brne FAT32_ReadBPB_1

        ldi zl,low(2*MSG_NO_FILES_IN_ROOT)
        ldi zh,high(2*MSG_NO_FILES_IN_ROOT)
        call SYSTEM_HALT

FAT32_ReadBPB_1:
        ldi r17,$08
        ret

