;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; InkrementSektor
;--------------------------------------------------------------------
IDE_Inkrement_Sektor:
        push r16
        push r17
        push r18
        push r19
        push r20
        lds r16,IRAM_LBA
        lds r17,IRAM_LBA+1
        lds r18,IRAM_LBA+2
        lds r19,IRAM_LBA+3
        ldi r20,$01
        add r16,r20                     ; r16=r16+ r20
        clr r20
        adc r17,r20                     ; Carry dazuadieren
        adc r18,r20
        adc r19,r20
        clc

        sts IRAM_LBA,r16
        sts IRAM_LBA+1,r17
        sts IRAM_LBA+2,r18
        sts IRAM_LBA+3,r19
        pop r20
        pop r19
        pop r18
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; IDE_WaitForReady
;--------------------------------------------------------------------
IDE_WaitForReady:
        push zl
        push zh
        push r16

        ldi zl,TIDE_STATUS
        ldi zh,$90
IDE_WaitForReady_2:
        LD r16,Z
        ANDI r16,$40                    ; RDY-Bit maskieren
        BREQ IDE_WaitForReady_2          ; Gesetzt? Nein: warten

        pop r16
        pop zh
        pop zl
        ret

;--------------------------------------------------------------------
; IDE_WhileBusyDo
;--------------------------------------------------------------------
IDE_WaitWhileBusy:
        push zl
        push zh
        push r16

        ldi zl,TIDE_STATUS
        ldi zh,$90
IDE_WaitWhileBusy_2:
        LD r16,Z
        ANDI r16,$80                    ; RDY-Bit maskieren
        BRNE IDE_WaitWhileBusy_2          ; Gesetzt? Ja: warten

        pop r16
        pop zh
        pop zl
        ret

;--------------------------------------------------------------------
; Harddisk-Fehler!
;--------------------------------------------------------------------
IDE_FAILURE:
        ldi zl,low(2*msg_noanswer)
        ldi zh,high(2*msg_noanswer)
        call SYSTEM_HALT
        ret

;--------------------------------------------------------------------
; IDE_WaitForDRQ
;--------------------------------------------------------------------
;IDE_WaitForDRQ:
;        push xl
;        push xh
;        push yl
;        push yh
;        push zl
;        push zh
;        push r16
;
;        ldi xl,$ff                      ; 32-Bit TIMEOUT-Counter!!!
;        ldi xh,$ff                      ; Braucht so wenig Zeit wie mglich
;        ldi yl,$0a                      ; Deswegen XTAL-Abhngig
;        ldi yh,$00                      ; Ca. 10 Sekunden!
;
;        ldi zl,TIDE_STATUS
;        ldi zh,$90
;IDE_WaitforDRQ_2:
;        LD r16,Z
;        ANDI r16,$08                    ; DRQ-Bit maskieren
;        BRNE IDE_WaitForDRQ_3          ; Gesetzt? Nein: warten
;        BREQ IDE_WaitForDRQ_2          ; Gesetzt? Nein: warten
;
;        sbiw xl,$01
;        brne IDE_WaitForDRQ_2
;
;        sbiw yl,$01
;        brne IDE_WaitForDRQ_2
;
;        call IDE_FAILURE
;
;IDE_WaitforDRQ_3:
;        pop r16
;        pop zh
;        pop zl
;        pop yh
;        pop yl
;        pop xh
;        pop xl
;        ret

;--------------------------------------------------------------------
; IDE_WaitForDRQ
;--------------------------------------------------------------------
IDE_WaitForDRQ:
        push r16
        push zl
        push zh

        ldi zl,TIDE_STATUS
        ldi zh,$90
IDE_WaitforDRQ_2:
        LD r16,Z
        ANDI r16,$08                    ; DRQ-Bit maskieren
        BREQ IDE_WaitForDRQ_2          ; Gesetzt? Nein: warten

        pop zh
        pop zl
        pop r16
        ret


;--------------------------------------------------------------------
; IDE_WaitForInt
;--------------------------------------------------------------------
IDE_WaitForInt:
        ret

;--------------------------------------------------------------------
;       IDE_InitRegisters
;--------------------------------------------------------------------
IDE_InitRegisters:
        ldi r16,$01
        sts IRAM_LBA,r16
        clr r16
        sts IRAM_LBA+1,r16
        sts IRAM_LBA+2,r16
        sts IRAM_LBA+3,r16
        ret

;--------------------------------------------------------------------
; IDE_CheckDRQ
;--------------------------------------------------------------------
IDE_CheckDRQ:
        push zl
        push zh
        push r16
        ldi zl,TIDE_STATUS
        ldi zh,$90
        LD r16,Z
        ANDI r16,$08                    ; RDY-Bit maskieren
        pop r16
        pop zh
        pop zl
        ret

;--------------------------------------------------------------------
; IDE_STANDBY
;--------------------------------------------------------------------
IDE_STANDBY:
        rcall IDE_WaitWhileBusy
        rcall IDE_WaitForReady
        ldi zl,TIDE_DRVHEAD
        ldi zh,$90
        ldi r16,$A0
        ST Z,r16
        ldi zl,TIDE_COMMAND
        ldi r16,$e0
        ST Z,r16
        rcall IDE_WaitWhileBusy
        ret


;--------------------------------------------------------------------
; IDE_IDLE
;--------------------------------------------------------------------
IDE_IDLE:
        rcall IDE_WaitWhileBusy
        rcall IDE_WaitForReady
        ldi zl,TIDE_DRVHEAD
        ldi zh,$90
        ldi r16,$A0
        ST Z,r16
        ldi zl,TIDE_COMMAND
        ldi r16,$e1
        ST Z,r16
        rcall IDE_WaitWhileBusy
        ret

;--------------------------------------------------------------------
; IDE_Autodetect
;--------------------------------------------------------------------
IDE_Autodetect:
        rcall LCD240_ClearText

        ldi r16,5
        ldi r17,3
        ldi zl,low(2*msg_Autodetect)
        ldi zh,high(2*msg_autodetect)
        rcall LCD240_OutStringXY

        ldi zl,TIDE_DRVHEAD
        ldi zh,$90
        ldi r16,$e0
        st Z,r16

        rcall IDE_WaitWhileBusy

        rcall IDE_WaitForReady

        ldi zl,TIDE_DRVHEAD
        ldi zh,$90
        ldi r16,$e0
        st Z,r16

        ldi zl,TIDE_COMMAND
        ldi r16,$ec
        st Z,r16

        rcall IDE_WaitforDRQ

        ldi xl,low(IRAM_BUFFER)
        ldi xh,high(IRAM_BUFFER)
        clr r18

IDE_Autodetect_Loop1:

        ldi zh,$90
        ldi zl,TIDE_DATAREG
        ld r16,Z

        ldi zh,$80
        ldi zl,TIDE_DATAREG
        ld r17,Z

        cpi r18,128                     ; nur 128 bytes kopieren!!!
        brsh IDE_Autodetect_Loop2

        st X+,r16
        inc r18
        st X+,r17
        inc r18

IDE_Autodetect_LOOP2:

        rcall IDE_checkDRQ
        brne IDE_Autodetect_LOOP1

        rcall IDE_WaitWhileBusy
        rcall IDE_WaitForReady

        rcall IDE_InitRegisters
        ret

;--------------------------------------------------------------------
;       Show Config
;--------------------------------------------------------------------
IDE_DISPLAY_CONFIG_SUB1:
        push r16
        push r17
        ld r16,X+
        ld r17,X+
        rcall BIN2BCD16
        mov r16,tBCD2
        rcall LCD240_OutVal
        mov r16,tBCD1
        rcall LCD240_OutVal
        mov r16,tBCD0
        rcall LCD240_OutVal
        pop r17
        pop r16
        ret

IDE_DISPLAY_CONFIG:
        push xl
        push xh
        push r16
        push r17
        push r18
        push yl
        push yh
        rcall LCD240_ClearText

        ldi zl,low(2*MSG_Device)
        ldi zh,high(2*MSG_Device)
        ldi r16,0
        ldi r17,0
        rcall LCD240_OutStringXY

        ldi xl,low(IRAM_STRING)
        ldi xh,high(IRAM_STRING)
        ldi r18,16
IDE_DISPLAY_CONFIG_1:
        ld r17,X+
        ld r16,X+
        rcall LCD240_OutAscii
        mov r16,r17
        rcall LCD240_OutAscii
        dec r18
        brne IDE_DISPLAY_CONFIG_1

        ldi r16,0
        ldi r17,2
        ldi zl,low(2*MSG_CYLINDERs)
        ldi zh,high(2*MSG_Cylinders)
        rcall LCD240_OutStringXY

        ldi xl,low(IRAM_CYLINDER)
        ldi xh,high(IRAM_CYLINDER)
        rcall IDE_DISPLAY_CONFIG_SUB1

        ldi r16,0
        ldi r17,3
        ldi zl,low(2*MSG_Heads)
        ldi zh,high(2*MSG_Heads)
        rcall LCD240_OutStringXY

        ldi xl,low(IRAM_HEAD)
        ldi xh,high(IRAM_HEAD)
        rcall IDE_DISPLAY_CONFIG_SUB1

        ldi r16,0
        ldi r17,4
        ldi zl,low(2*MSG_sectors)
        ldi zh,high(2*MSG_sectors)
        rcall LCD240_OutStringXY

        ldi xl,low(IRAM_SECTOR)
        ldi xh,high(IRAM_SECTOR)
        rcall IDE_DISPLAY_CONFIG_SUB1

        pop yh
        pop yl
        pop r18
        pop r17
        pop r16
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; IDE_READ_LBA     r16=Anzahl der Sektoren  X=BufferAdresse
;--------------------------------------------------------------------
IDE_READ_LBA:
        push r17
        push r18
        push r16
        push r16
        rcall IDE_WaitWhileBusy
        rcall IDE_WaitForReady

        ldi zl,TIDE_SECCNT
        ldi zh,$90
        pop r16
        mov r18,r16
        ST Z,r16

        ldi zl,TIDE_SECNR
        lds r16,IRAM_LBA
        ST Z,r16

        ldi zl,TIDE_CYLLOW
        lds r16,IRAM_LBA+1
        ST Z,r16

        ldi zl,TIDE_CYLHI
        lds r16,IRAM_LBA+2
        ST Z,r16

        ldi zl,TIDE_DRVHEAD
        lds r16,IRAM_LBA+3
        ori r16,$e0
        ST Z,r16

        ldi zl,TIDE_COMMAND
        ldi r16,$20
        ST Z,r16


IDE_READ_LBA_LOOP2:
        rcall IDE_WaitforDRQ

IDE_READ_LBA_Loop1:

        ldi zh,$90
        ldi zl,TIDE_DATAREG
        ld r16,Z

        ldi zh,$80
        ldi zl,TIDE_DATAREG
        ld r17,Z

        st X+,r16
        st X+,r17

IDE_XX1:
        rcall IDE_checkDRQ
        brne IDE_READ_LBA_LOOP1

        dec r18
        brne IDE_READ_LBA_LOOP2

        rcall IDE_WaitWhileBusy
        rcall IDE_WaitForReady
        pop r16
        pop r18
        pop r17
        ret

;--------------------------------------------------------------------
; IDE_READ_LBA     r16=Anzahl der Sektoren  X=BufferAdresse
;--------------------------------------------------------------------
IDE_READ_LBA_AND_PLAY:
        push zl
        push zh
        push r17
        push r18
        push r16
        push r16
        rcall IDE_WaitWhileBusy
        rcall IDE_WaitForReady

        ldi zl,TIDE_SECCNT
        ldi zh,$90
        pop r16
        mov r18,r16
        ST Z,r16

        ldi zl,TIDE_SECNR
        lds r16,IRAM_LBA
        ST Z,r16

        ldi zl,TIDE_CYLLOW
        lds r16,IRAM_LBA+1
        ST Z,r16

        ldi zl,TIDE_CYLHI
        lds r16,IRAM_LBA+2
        ST Z,r16

        ldi zl,TIDE_DRVHEAD
        lds r16,IRAM_LBA+3
        ori r16,$e0
        ST Z,r16

        ldi zl,TIDE_COMMAND
        ldi r16,$20
        ST Z,r16


IDE_READ_LBA_AND_PLAY_LOOP2:
        rcall IDE_WaitforDRQ

IDE_READ_LBA_AND_PLAY_Loop1:

        ldi zh,$90
        ldi zl,TIDE_DATAREG
        ld r0,Z
        rcall MP3_sendByte
;        ld r16,Z

        ldi zh,$80
        ldi zl,TIDE_DATAREG
;        ld r17,Z
        ld r0,Z
        rcall MP3_sendByte


IDE_XX1_AND_PLAY:
        rcall IDE_checkDRQ
        brne IDE_READ_LBA_AND_PLAY_LOOP1
        dec r18
        brne IDE_READ_LBA_AND_PLAY_LOOP2

        rcall IDE_WaitWhileBusy
        rcall IDE_WaitForReady
        pop r16
        pop r18
        pop r17
        pop zh
        pop zl
        ret


;--------------------------------------------------------------------
; MP3_SendByte          (r0)
;--------------------------------------------------------------------
IDE_SendByte:
        push r18
        ldi r18,128                     ; R18 mit 8 laden
IDE_SendByte_Sub1_1:
        SBIS pind,MP3DEC_DEMAND         ; Demand-Bit gesetzt?
        rjmp IDE_SendByte_Sub1_1        ; Nein: nochmal testen

        SBI portd,MP3DEC_SIC            ; Set MP3DEC_SIC Bit high

        push r0                         ; R0 retten
        and r0,r18                      ; Mit R1 Und verknpfen
        pop r0                          ; r0 wieder holen
        breq IDE_SendByte_Sub1_2        ; Bit 0? Dann lschen
        SBI portd,MP3DEC_SID            ; MP3DEC_SID-Bit setzen wenn nicht 0
        rjmp IDE_SendByte_Sub1_3
IDE_SendByte_Sub1_2:
        CBI portd,MP3DEC_SID            ; MP3DEC_SID lschen
IDE_SendByte_Sub1_3:
        CBI portd,MP3DEC_SIC            ; Clr MP3DEC_SIC Bit

        LSR r18                         ; R1 um eins nach rechts schieben
        brne IDE_SendByte_Sub1_1        ; R1 0? (=alle 8bits bearbeitet)
        pop r18
        ret                             ; 16384 Bytes gespeichert


;--------------------------------------------------------------------
; IDE_CLEARBUFFER
;--------------------------------------------------------------------
IDE_CLEARBUFFER:
        push r16
        push zl
        push zh
IDE_CLEARBUFFER_1:
        rcall IDE_CHECKDRQ
        breq IDE_CLEARBUFFER_END

        ldi zh,$90
        ldi zl,TIDE_DATAREG
        ld r16,Z
        rjmp IDE_CLEARBUFFER_1

IDE_CLEARBUFFER_END:
        pop zh
        pop zl
        pop r16
        ret
