;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
.equ    IIC_WAitTime    =       250

;--------------------------------------------------------------------
; IIC_WAIT
;--------------------------------------------------------------------
IIC_WAIT:
        push r16
        ldi r16,IIC_WaitTime
        call waitr16
        pop r16
        ret

;--------------------------------------------------------------------
; IIC_SendStart
;--------------------------------------------------------------------
IIC_SENDSTART:
        sbi PortD,IIC_SCL
        sbi PortD,IIC_SDA
        call IIC_Wait
        cbi PortD,IIC_SDA
        call IIC_WAIT
        cbi PortD,IIC_SCL
        call IIC_Wait
        ret

;--------------------------------------------------------------------
; IIC_SendStop
;--------------------------------------------------------------------
IIC_SendStop:
        cbi PortD,IIC_SDA
        call IIC_WAIT
        sbi PortD,IIC_SCL
        call IIC_Wait
        sbi PortD,IIC_SDA
        call IIC_Wait
        RET

;--------------------------------------------------------------------
; IIC_SendByte
;--------------------------------------------------------------------
IIC_SendByte:
        push r17
        push r16
        ldi r17,$08
IIC_SendByte_1:
        lsl r16
        sbi PortD,IIC_SDA
        brcs IIC_SendByte_2             ; Carry gesetzt? Ja: springe
        cbi PortD,IIC_SDA
IIC_SendByte_2:
        call IIC_Wait
        sbi PortD,IIC_SCL
        call IIC_Wait
        cbi PortD,IIC_SCL
        call IIC_WAit
        dec r17
        brne IIC_SendByte_1
        pop r16
        pop r17
        ret

;--------------------------------------------------------------------
; IIC_RECEIVEBYTE
;--------------------------------------------------------------------
IIC_Receive_Byte:                       ; *** ACC: Ergebnis
        push r17
        ldi r17,8                       ; 8 Bits einlesen
        cbi DDRD,IIC_SDA                ; SDA auf eingang setzen
        sbi PortD,IIC_SDA               ; und Pullup-aktivieren
IIC_Receive_Byte_1:
        sbi PortD,IIC_SCL               ; Clockleitung setzen
        call IIC_WAIT

        clc                             ; Carry-Flag lschen
        sbic PIND,IIC_SDA                   ; SDA auf low? Dann berspringen
        sec                             ; Carry setzen wenn SDA hi

        rol r16                         ; r17 und Carry reinschieben

        cbi PortD,IIC_SCL               ; Clockleitung auf Lo

        call IIC_WAIT

        dec r17
        brne IIC_Receive_Byte_1

        cbi PortD,IIC_SDA
        sbi DDRD,IIC_SDA                ; SDA wieder als Ausgang
        pop r17
        ret

;--------------------------------------------------------------------
; IIC_ReceiveACK
;--------------------------------------------------------------------
IIC_ReceiveACK:
        cbi DDRD,IIC_SDA
        call IIC_Wait
        sbi PortD,IIC_SCL
        call IIC_Wait
IIC_ReceiveACK_1:
        sbic PIND,IIC_SDA
        rjmp IIC_ReceiveAck_1

        cbi PortD,IIC_SCL

IIC_ReceiveACK_2:
;        sbis PINB,IIC_SDA
;        rjmp IIC_ReceiveACK_2

        sbi DDRD,IIC_SDA
        ret


