;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;     Includefile for LCD-Display with 240*64 Pixel like SHARP24010
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; LCD240_WaitForReady
;--------------------------------------------------------------------
LCD240_WaitForReady:
;        cli
        push r16
        call disable_sram
        cbi PortE,LCD_CS
        sbi PortD,LCD_CD                    ; CD lschen = Datareg
        call Set_PortA_Input

LCD240_waitForReady_2:
        cbi PortE,PER_RD                    ; Status lesen

;        ldi r16,lcdwait                      ; ca. 20ms warten
;        call waitr16

        in r16,PINA

        sbi PortE,PER_RD

        andi r16,$03
        cpi r16,$03                     ; die ersten 2 Bits maskieren
        brne LCD240_waitForReady_2      ; Gesetzt? Nochmal

        call Set_PortA_Output

        sbi PortE,LCD_CS
        call enable_sram
        pop r16
;        sei
        ret
;--------------------------------------------------------------------
; LCD240_WriteByte
;--------------------------------------------------------------------
LCD240_WriteByte:
;        cli
        push r16
        push r20
        in r20,SREG
        push r20

        call disable_sram
        cbi PortE,LCD_CS
        out PortA,r16

        cbi PortE,PER_WR

;        ldi r16,lcdwait
;        call waitr16

        sbi PortE,PER_WR

;        ldi r16,lcdwait
;        call waitr16
        sbi PortE,LCD_CS
        call enable_sram

        pop r20
        out SREG,r20
        pop r20
        pop r16
;        sei
        ret

;--------------------------------------------------------------------
; LCD240_WriteData
;--------------------------------------------------------------------
LCD240_WriteData:
        push r20
        in r20,SREG
        push r20

        call LCD240_WaitForReady

        cbi PortD,LCD_CD
        call LCD240_WriteByte

        pop r20
        out SREG,r20
        pop r20
        ret

;--------------------------------------------------------------------
; LCD240_WriteCommand
;--------------------------------------------------------------------
LCD240_WriteCommand:
        push r20
        in r20,SREG
        push r20

;        cli

        call LCD240_WaitForReady

        sbi PortD,LCD_CD
        call LCD240_WriteByte

        pop r20
        out SREG,r20
        pop r20
        ret
;--------------------------------------------------------------------
; LCD240_RESET
;--------------------------------------------------------------------
LCD240_RESET:
        ldi r16,$80
        out portC,r16
        ldi r17,100
        call waitlong
        ldi r16,$00
        out portc,r16
        ret

;--------------------------------------------------------------------
; LCD240_InitLCD
;--------------------------------------------------------------------
LCD240_INITLCD:
        ldi r16,$01
        call LCD240_CombineMode

        ldi yl,$00
        ldi yh,$00
        call LCD240_SetTextHomeAdr

        ldi r16,$28
        call LCD240_TextArea

        ldi yl,$40
        ldi yh,$01
        call LCD240_SetGraphHomeAdr

        ldi r16,$28
        call LCD240_GraphArea

        ldi r16,$03                     ; CG on $1800
        call LCD240_OfsRegSet

        ldi r16,$07
        call LCD240_CrsrPatSel

        ldi r16,$05
        ldi r17,$05
        call LCD240_SetCursor

        ldi yl,$00
        ldi yh,$00
        call LCD240_SetADP

        call LCD240_ClearText

        call LCD240_ClearGraph

        ldi zl,low(2*DATA_CHAR1)
        ldi zh,high(2*DATA_CHAR1)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR2)
        ldi zh,high(2*DATA_CHAR2)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR3)
        ldi zh,high(2*DATA_CHAR3)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR4)
        ldi zh,high(2*DATA_CHAR4)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR5)
        ldi zh,high(2*DATA_CHAR5)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR7)
        ldi zh,high(2*DATA_CHAR7)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR9)
        ldi zh,high(2*DATA_CHAR9)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR10)
        ldi zh,high(2*DATA_CHAR10)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR11)
        ldi zh,high(2*DATA_CHAR11)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR12)
        ldi zh,high(2*DATA_CHAR12)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR13)
        ldi zh,high(2*DATA_CHAR13)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR14)
        ldi zh,high(2*DATA_CHAR14)
        call LCD240_LoadNewChar

        ldi zl,low(2*DATA_CHAR15)
        ldi zh,high(2*DATA_CHAR15)
        call LCD240_LoadNewChar

        ldi r16,$0c
        call LCD240_DisplayMode

        RET

;--------------------------------------------------------------------
; LCD240_Cursoroff
;--------------------------------------------------------------------
LCD240_CursorOff:
        push r16
        ldi r16,$0c
        call LCD240_DisplayMode
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_Cursoron
;--------------------------------------------------------------------
LCD240_CursorOn:
        push r16
        ldi r16,$0f
        call LCD240_DisplayMode
        pop r16
        ret


;--------------------------------------------------------------------
; LCD240_CrsrPatSel
;--------------------------------------------------------------------
LCD240_CrsrPatSel:
        push r16
        push r17
        ldi r17,$A0
        or r16,r17

        call LCD240_WriteCommand
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_TextHomeAdr
;--------------------------------------------------------------------
LCD240_SetTextHomeAdr:
        push r16
        push zl
        push zh

        ldi zl,low(IRAM_TextArea)
        ldi zh,high(IRAM_TextArea)
        st Z+,yl
        st Z+,yh

        mov r16,yl
        call LCD240_WriteData

        mov r16,yh
        call LCD240_WriteData

        ldi r16,$40
        call LCD240_WriteCommand

        pop zh
        pop zl
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_SetADP
;--------------------------------------------------------------------
LCD240_SetADP:
        push r16

        sts IRAM_LCD240_ADP,yl
        sts IRAM_LCD240_ADP+1,yh

        mov r16,yl
        call LCD240_WriteData

        mov r16,yh
        call LCD240_WriteData

        ldi r16,$24                     ; Adresspointer set
        call LCD240_WriteCommand
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_GetADP                  ADP in Y!
;--------------------------------------------------------------------
LCD240_GetADP:
        lds yl,IRAM_LCD240_ADP
        lds yh,IRAM_LCD240_ADP+1
        ret

;--------------------------------------------------------------------
; LCD240_OfsRegSet
;--------------------------------------------------------------------
LCD240_OfsRegSet:
        push r16
        call LCD240_WriteData

        clr r16
        call LCD240_WriteData

        ldi r16,$22                     ; Adresspointer set
        call LCD240_WriteCommand
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_GraphHomeAdr
;--------------------------------------------------------------------
LCD240_SetGraphHomeAdr:
        push r16

        sts IRAM_GRAPHAREA,yl
        sts IRAM_GRAPHAREA+1,yh

        mov r16,yl
        call LCD240_WriteData

        mov r16,yh
        call LCD240_WriteData

        ldi r16,$42
        call LCD240_WriteCommand

        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_GetGraphHomeAdr
;--------------------------------------------------------------------
LCD240_GetGraphHomeAdr:
        lds yl,IRAM_GRAPHAREA
        lds yh,IRAM_GRAPHAREA+1
        ret

;--------------------------------------------------------------------
; LCD240_GetTextHomeAdr
;--------------------------------------------------------------------
LCD240_GetTextHomeAdr:
        push zh
        push zl

        ldi zl,low(IRAM_TextArea)
        ldi zh,high(IRAM_TextArea)
        ld Yl,Z+
        ld Yh,Z+

        pop zl
        pop zh
        ret

;--------------------------------------------------------------------
; LCD240_TextArea
;--------------------------------------------------------------------
LCD240_TextArea:
        push r16
        call LCD240_WriteData

        ldi r16,$00
        call LCD240_WriteData

        ldi r16,$41
        call LCD240_WriteCommand


        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_GraphArea
;--------------------------------------------------------------------
LCD240_GraphArea:
        push r16
        call LCD240_WriteData

        ldi r16,$00
        call LCD240_WriteData

        ldi r16,$43
        call LCD240_WriteCommand

        pop r16
        ret


;--------------------------------------------------------------------
; LCD240_DisplayMode
;--------------------------------------------------------------------
LCD240_DisplayMode:
        push r16
        push r17
        ldi r17,$90
        or r16,r17

        call LCD240_WriteCommand
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_AutoModeOn
;--------------------------------------------------------------------
LCD240_AutoModeOn:
        push r16
        ldi r16,$b0
        call LCD240_WriteCommand
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_AutoModeOff
;--------------------------------------------------------------------
LCD240_AutoModeOff:
        push r16
        ldi r16,$b2
        call LCD240_WriteCommand
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_CombineMode
;--------------------------------------------------------------------
LCD240_CombineMode:
        push r16
        push r17
        ldi r17,$80
        or r16,r17

        call LCD240_WriteCommand
        pop r17
        pop r16
        ret


;--------------------------------------------------------------------
; LCD240_SetCursor
;--------------------------------------------------------------------
LCD240_SetCursor:
        push yl
        push yh

        push r16
        push r17
        call LCD240_WriteData

        push r16
        mov r16,r17
        call LCD240_WriteData

        ldi r16,$21
        call LCD240_Writecommand

        pop r16

        call LCD240_GetTextHomeAdr

LCD240_SetCursor_2:
        and r17,r17
        breq LCD240_SetCursor_3

        adiw yl,40                      ; 40 dazuzhlen
        dec r17
        jmp LCD240_SetCursor_2

LCD240_SetCursor_3:

        add yl,r16
        clr r17
        adc yh,r17

        call LCD240_SetADP

        pop r17
        pop r16

        pop yh
        pop yl
        ret


;--------------------------------------------------------------------
; LCD240_ClearText
;--------------------------------------------------------------------
LCD240_ClearText:
        push r16
        push yl
        push yh
        push xl
        push xh
        set
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE

        call LCD240_GetTextHomeAdr
        call LCD240_SetADP

        call LCD240_AutoModeon

        ldi xl,$40
        ldi xh,$01
LCD240_CleaRText_2:
        ldi r16,$00
        call LCD240_WriteData
        call LCD240_INKREMENT_ADP
        sbiw xl,$01
        brne LCD240_CleaRText_2

        call LCD240_AutoModeoff

        call LCD240_GetTextHomeAdr
        call LCD240_SetADP

        clt
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE

        pop xh
        pop xl
        pop yh
        pop yl
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_ClearGraph
;--------------------------------------------------------------------
LCD240_ClearGraph:
        push r16
        push yl
        push yh
        push xl
        push xh
        set
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE

        call LCD240_GetGraphHomeAdr
        call LCD240_SetADP

        call LCD240_AutoModeon

        ldi xl,$00
        ldi xh,$0A
LCD240_CleaRGraph_2:
        ldi r16,$00
        call LCD240_WriteData
        call LCD240_INKREMENT_ADP
        sbiw xl,$01
        brne LCD240_CleaRGraph_2

        call LCD240_Automodeoff

        call LCD240_GetTextHomeAdr
        call LCD240_SetADP

        clt
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE

        pop xh
        pop xl
        pop yh
        pop yl
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_INKREMENT_ADP
;--------------------------------------------------------------------
LCD240_INKREMENT_ADP:
        push xl
        push xh
        lds xl,IRAM_LCD240_ADP
        lds xh,IRAM_LCD240_ADP+1
        adiw xl,$01
        sts IRAM_LCD240_ADP,xl
        sts IRAM_LCD240_ADP+1,xh
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; LCD240_OutChar
;--------------------------------------------------------------------
LCD240_OutChar:
        push r16

        call LCD240_INKREMENT_ADP

        call LCD240_WriteData

        ldi r16,$c0
        call LCD240_Writecommand

        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_OutBin    r16 (ASCII)
;--------------------------------------------------------------------
LCD240_Outbin:
        push r16
        push r17
        push r18

        mov r18,r16

        ldi r17,$08

LCD240_Outbin_1:
        ldi r16,'1'                     ; initialisieren mit 1
        sbrs r18,7                      ; MSB gesetzt?
        ldi r16,'0'                     ; Nein: Dann 0 ausgeben
        call LCD240_OutAscii

        clc
        rol r18

        dec r17
        brne LCD240_OutBin_1

        pop r18
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_OutVal    r16 (ASCII)
;--------------------------------------------------------------------
LCD240_OutVal_Sub1:
        mov r17,r16
        andi r17,$0f                    ; Hi-Nibble maskieren
        mov r16,r17

        cpi r17,10                      ; Wert > 10?
        brlo LCD240_OutVal_Sub1_1       ; Nein: nur 48 dazuzhlen sonst

        ldi r17,55                      ; 55 Dazuzhlen
        jmp LCD240_OutVal_Sub1_2
LCD240_OutVal_Sub1_1:
        ldi r17,48                      ; 48 Dazuzhlen
LCD240_OutVal_Sub1_2:

        add r16,r17
        mov r17,r16
        call LCD240_outascii           ; Zeichen ausgeben
        ret

LCD240_OutVal:
        push r17
        push r16
        push r16
        swap r16                        ; Swap Nibbles
        call LCD240_OutVal_Sub1        ; Hi-Nibble ausgeben

        pop r16
        call LCD240_OutVal_Sub1        ; Lo-Nibble ausgeben
        pop r16
        pop r17
        ret

;--------------------------------------------------------------------
;       LCD240_OutVAL_32BIT  X=Adresse
;--------------------------------------------------------------------
LCD240_OutVal_32Bit:
        push r16
        adiw Xl,$04
        ld r16,-X
        call LCD240_OutVal
        ld r16,-X
        call LCD240_OutVal
        ld r16,-X
        call LCD240_OutVal
        ld r16,-X
        call LCD240_OutVal
        ldi r16,'h'
        call LCD240_OutAscii
        pop r16
        ret


;--------------------------------------------------------------------
; LCD240_OutLargeVal    r16 (xpos), r17 (ypos), r18: VAL
;--------------------------------------------------------------------
LCD240_OutLargeVal_Sub1:
        push r18
        push r19
        push zl
        push zh
        push xl
        push xh
        push r0
        andi r18,$0f

        ldi zl,low(2*DATA_BitMapNumTable)
        ldi zh,high(2*DATA_BitMapNumTable)
        lsl r18                         ; r18 =r18*2
        clr r19                         ; r19 zur Carrycorretur

        add zl,r18                      ; zl und r18 addieren
        adc zh,r19                      ; Carry und zh addieren

        lpm                             ; Adresse aus Programmemory holen
        mov xl,r0
        adiw zl,$01
        lpm
        mov xh,r0
        adiw zl,$01

        mov zl,xl
        mov zh,xh
        clr r19
        call LCD240_PutImage

        pop r0
        pop xh
        pop xl
        pop zh
        pop zl
        pop r19
        pop r18
        ret

LCD240_OutLargeVal:
        push r16
        push r19

        swap r18                        ; Oberes Nibble nach unten kopieren
        rcall LCD240_OutLargeVal_Sub1
        ldi r19,2
        add r16,r19                     ; r16=r16+12
        swap r18
        rcall LCD240_OutLargeVal_Sub1

        pop r19
        pop r16
        ret


;--------------------------------------------------------------------
;       LCD240_OutVAL_32BIT  X=Adresse
;--------------------------------------------------------------------
LCD240_OutVal_32Bit_HI:
        push r16

        adiw Xl,$04

        sbi PortD,MCU_A16
        ld r16,-X
        cbi PortD,MCU_A16

        call LCD240_OutVal

        sbi PortD,MCU_A16
        ld r16,-X
        cbi PortD,MCU_A16

        call LCD240_OutVal

        sbi PortD,MCU_A16
        ld r16,-X
        cbi PortD,MCU_A16

        call LCD240_OutVal

        sbi PortD,MCU_A16
        ld r16,-X
        cbi PortD,MCU_A16

        call LCD240_OutVal

        ldi r16,'h'
        call LCD240_OutAscii

        pop r16
        ret


;--------------------------------------------------------------------
; LCD240_OutAscii
;--------------------------------------------------------------------
LCD240_OutAscii:
        push r16
        push r18
        clc
        ldi r18,$20
        sub r16,r18
        call LCD240_OUTCHAR
        pop r18
        pop r16
        ret


;--------------------------------------------------------------------
; LCD240_OutString
;--------------------------------------------------------------------
LCD240_OutString:
        push zl
        push zh
        push r0
        push r16

LCD240_OutString_1:
        lpm
        and r0,r0
        breq LCD240_OutString_End
        mov r16,r0
        call LCD240_OutAscii
        adiw zl,$01
        jmp LCD240_OutString_1

LCD240_OutString_End:
        pop r16
        pop r0
        pop zh
        pop zl
        ret

;--------------------------------------------------------------------
; LCD240_OutStringXY    r16:XPOS r17:YPOS
;--------------------------------------------------------------------
LCD240_OutStringxy:
        push zl
        push zh
        push r0
        push r16
        call LCD240_SetCursor

LCD240_OutStringxy_1:
        lpm
        and r0,r0
        breq LCD240_OutStringxy_End
        mov r16,r0
        call LCD240_OutAscii
        adiw zl,$01
        jmp LCD240_OutStringxy_1

LCD240_OutStringxy_End:
        pop r16
        pop r0
        pop zh
        pop zl
        ret


;--------------------------------------------------------------------
; LCD240_OutString_IRAM    r18:NumberofBytes  X=Adresse
;--------------------------------------------------------------------
LCD240_OutString_IRAM:
        push xl
        push xh
        push r16
        push r18
LCD240_OutString_IRAM_1:
        ld r16,X+
        call LCD240_OutAscii
        dec r18
        brne LCD240_OutString_IRAM_1
        pop r18
        pop r16
        pop xh
        pop xl
        ret


;--------------------------------------------------------------------
; LCD240_OutStringXY_IRAM  r16:xpos, r17:ypos r18:NumberofBytes  X=Adresse
;--------------------------------------------------------------------
LCD240_OutStringXY_IRAM:
        push r16
        push r18
        call LCD240_SetCursor
LCD240_OutStringXY_IRAM_1:
        ld r16,X+
        call LCD240_OutAscii
        dec r18
        brne LCD240_OutStringXY_IRAM_1
        pop r18
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_LoadNewChar    (zl,zh=adresse)
;--------------------------------------------------------------------
LCD240_LoadNewChar:
        push r16
        push r17
        push yl
        push yh
        lpm                             ; erstes Byte holen
        adiw zl,$01
        mov r16,r0

        ldi yh,$18
        ldi yl,$00

LCD240_LoadNewChar_1:
        and r16,r16                     ; r16 mitsichselber AND verkn.
        breq LCD240_LoadNewChar_2       ; Zero gesetzt? Ja: R16 abgelaufen

        adiw yl,$08                     ; 8 dazuzhlen zu X
        dec r16
        jmp LCD240_LoadNewChar_1

LCD240_LoadNewChar_2:
        ldi r17,$08

        call LCD240_SetADP             ; Adresspointer auf Adresse setzen
        call LCD240_AutoModeOn      ; Automode anschalten

LCD240_LoadNewChar_3:
        lpm                             ; Byte holen
        adiw zl,$01
        mov r16,r0
        call LCD240_WriteData
        call LCD240_INKREMENT_ADP
        dec r17
        brne LCD240_LoadNewChar_3

        call LCD240_AutoModeOff

        pop yh
        pop yl
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; LCD240_Putimage       r16,r17:x und y pos Z Adresse von Bitmap
;--------------------------------------------------------------------
LCD240_Putimage:
        set
        bld TASK_FLAGS,TASKF_TPNOTALLOWED
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE


        push r0
        push r16
        push r17
        push r18
        push zl
        push zh
        push yl
        push yh
        push task_flags

        push r19

        call lcd240_GetGraphHomeAdr
;        ldi yl,$00                      ; Adresse von Anfang von Graph
;        ldi yh,$0e                      ; Area laden

LCD240_Putimage_1:
        and r17,r17                     ; r17= abgelaufen?
        breq LCD240_Putimage_2          ; Ja: routine beenden
        dec r17
        adiw yl,40                      ; Um eine Zeile inkrementieren
        jmp LCD240_Putimage_1

LCD240_Putimage_2:
        and r16,r16
        breq LCD240_Putimage_3
        dec r16
        adiw yl,$01
        jmp LCD240_Putimage_2

LCD240_Putimage_3:
        call LCD240_SetADP

        lpm
        adiw zl,$01
        mov r18,r0                      ; Gre in X
        lpm
        adiw zl,$01
        mov r19,r0                      ; Gre in Y

        mov r17,r19                     ; Y auslagern in r17 WORKREG
        pop r19
        push r19
LCD240_Putimage_7:
        mov r16,r18                     ; X auslagern in R16 WORKREG
LCD240_Putimage_6:
        lpm                             ; Byte holen

        and r19,r19
        breq LCD240_Putimage_8

        com r0                          ; inverse!

LCD240_Putimage_8:

        adiw zl,$01                     ; Z inkrementieren

        push r16
        mov r16,r0
        call LCD240_OutChar             ; Byte in LCD schreiben

        pop r16
        dec r16                         ; X-Work-Reg dekremtieren
        brne LCD240_Putimage_6          ; Und weiter arbeiten

        adiw yl,40                      ; ADP in nchste Zeile stellen
        call LCD240_SetADP

        dec r17
        brne LCD240_Putimage_7

        pop r19
        pop TASK_FLAGS
        pop yh
        pop yl
        pop zh
        pop zl
        pop r18
        pop r17
        pop r16
        pop r0

        clt
        bld TASK_FLAGS,TASKF_TPNOTALLOWED
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE

        ret
