;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; LPTIMER              Interruptroutine
;--------------------------------------------------------------------
LPTIMER:
        sei                             ; Interrupt erlauben

        push r16
        in r16,SREG
        push r16
        push xl
        push xh

        lds xl,IRAM_LPT_VAL
        lds xh,IRAM_LPT_VAL+1           ; TIMEOUTZeit in X laden

        sbiw xl,$01                     ; Dekrementieren

        sts IRAM_LPT_VAL,xl
        sts IRAM_LPT_VAL+1,xh


        brcc LPTIMER_END

        set                             ; T-Flag setzen
        bld LPT_FLAGS,LPTF_TIMEOUT      ; und in Booleanvariable schreiben

        in r16,TIMSK
        andi r16,$7f                    ; TIMER0-Enable lschen
        out TIMSK,r16

LPTIMER_END:
        pop xh
        pop xl
        pop r16
        out SREG,r16
        pop r16

        reti

;--------------------------------------------------------------------
; Ldt den Dekrement-Timer mit dem Inhalt von X und aktiviert Int
;--------------------------------------------------------------------
LPTIMER_LOAD:
        call LPTIMER_STOP
        sts IRAM_LPT_VAL,xl
        sts iRAM_LPT_VAL+1,xh

        clt                             ; T-Flag lschen
        bld LPT_FLAGS,LPTF_TIMEOUT      ; und in Booleanvariable schreiben

        call LPTIMER_START
        ret

;--------------------------------------------------------------------
; BOOL_CheckTimeout     TimeoutBit testen Zero ist High wenn Timeout
;--------------------------------------------------------------------
BOOL_CheckLongPress:
        sez
        sbrs LPT_FLAGS,LPTF_TIMEOUT
        clz
        ret

;--------------------------------------------------------------------
; LPTIMER_INIT
;--------------------------------------------------------------------
LPTIMER_INIT:
        cli
        ldi r16,$0f                     ; Prescaler 1024
        out TCCR2,r16

        ldi r16,$ff
        out OCR2,r16

        clr r16                         ; 8-Bit Timer auf 0
        out TCNT2,r16

        clt
        bld LPT_FLAGS,LPTF_TIMEOUT
        sei                             ; Interrupt zulassen

        ret

;--------------------------------------------------------------------
; LPTIMER_STOP
;--------------------------------------------------------------------
LPTIMER_STOP:
        cli
        in r16,TIMSK
        andi r16,$7f                    ; TIMER0-Enable lschen
        out TIMSK,r16

        clt
        bld LPT_FLAGS,LPTF_TIMEOUT      ; wenn abgeschalten dann Flag lschen

        sei
        ret

;--------------------------------------------------------------------
; LPTIMER_START
;--------------------------------------------------------------------
LPTIMER_START:
        cli

        in r16,TIMSK
        ori r16,$80                     ; Timer0-Enable setzen
        out TIMSK,r16

        sei
        ret

