;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------


;--------------------------------------------------------------------
; Interrupt-table 
;--------------------------------------------------------------------
.include "m103def.inc"

                                        ; Funktion der PORTC-Pins
        jmp INIT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp PLAY_SONG                    ; Interrupt von Decoder
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp TIMER_COMPARE
        jmp NOINT
        jmp NOINT
        jmp TIMEOUTTIMER
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT
        jmp NOINT


NOINT:
        reti

;--------------------------------------------------------------------
; Globale Konstanten fr Timeoutzeiten und so weiter
;--------------------------------------------------------------------
.equ    ESC_TIMEOUT             = $0100 ;
.equ    TIMER_VAL               =  2000 ; Zeit zwischen zwei Timer-Ints
.equ    TIMEPLAY_DELAY          = $0015
.equ    LONGPRESS_DELAY         = $000a
;--------------------------------------------------------------------
;       Bitdefinitionen von PortE und PortD
;--------------------------------------------------------------------
.equ    PER_WR                  = 4
.equ    PER_RD                  = 3
.equ    LCD_CS                  = 5
.equ    LCD_CD                  = 1
.equ    IDE_CS                  = 6

.equ    IIC_SDA                 = 5
.equ    IIC_SCL                 = 4

.equ    MP3Dec_SID              = 2
.equ    MP3Dec_Sic              = 3
.equ    MP3DEC_DEMAND           = 7

.equ    MCU_A16                 = 6

;--------------------------------------------------------------------
;  Bitdefinitionen von TASK_FLAGS= R1
;--------------------------------------------------------------------
.equ    TASKF_PLAYSCREEN        = 0     ; =1 dann PLAYSCREEN anzeigen
.equ    TASKF_PLAYTIME          = 1     ; =1 dann PLAYTIME anzeigen
.equ    TASKF_FORWARD           = 2     ; =1 dann Lied vorwrts
.equ    TASKF_TIMEOUTPLAY       = 3     ; =1 dann TIMEOUT-Play initiieren
.equ    TASKF_BUTTONSTATE       = 4
.equ    TASKF_NOSCREENCHANGE    = 5     ; =1 wenn in PutImageroutine oder
                                        ; sonstige Routinen wo keine
                                        ; Task-Ausgabe erfolgen darf
.equ    TASKF_tPNOTALLOWED      = 6     ; =1 dann TIMEOUT-Play verbieten
;.equ    TASKF_AKTIV             = 7     ; =1 dann TASK schon aktiv

;--------------------------------------------------------------------
;  Bitdefinitionen von PLAYINT_FLAGS= R1
;--------------------------------------------------------------------
.equ    PLAYINTF_INTERRUPT      = 0     ; Flag fr INT-Play-Routine
.equ    PLAYINTF_SEKTOREND      = 1     ; Flag fr INT-Play-Routine
.equ    PLAYINTF_KOMPLETT       = 2     ; Flag fr INT-Play-Routine
.equ    PLAYINTF_ALLSPC         = 3     ; Flag fr INT-Play-Routine
.equ    PLAYINTF_SRAMEN         = 4     ; Flag fr INT-Play-Routine
.equ    PLAYINTF_PAUSE          = 5
.equ    PLAYINTF_PLAY           = 6
.equ    PLAYINTF_STOP           = 7

;--------------------------------------------------------------------
; Bitdefinition von TIMERINT_FLAGS= R2
;--------------------------------------------------------------------
.equ    TIMERINTF_AKTIV         = 0;

;--------------------------------------------------------------------
; Bitdefinition von TIMEOUT_FLAGS = R3
;--------------------------------------------------------------------
.equ    TIMEOUTF_TIMEOUT        = 0;
.equ    TIMEOUTF_LONGPRESS      = 1;

;--------------------------------------------------------------------
; Bitdefinition von MISC_FLAGS = R4
;--------------------------------------------------------------------
.equ    MISCF_FATSCANNED        = 0;    ; Nach dem Wechseln von Dir
                                        ; oder dem FORWARD-Knopf gibt
                                        ; die Variable an ob FAT schon
                                        ; gescannt

.equ    MISCF_PLAYSCREEN        = 1;
.equ    MISCF_NOFILETOPLAY      = 2;
.equ    MISCF_LAST_LFN          = 3;    ; Bei Directory-Scan function
.equ    MISCF_ID3AVAILABLE      = 4;
;--------------------------------------------------------------------
; Werte fr Tasten
;--------------------------------------------------------------------
.equ    KEY_REWIND              = $00;
.equ    KEY_PLAYPAUSE           = $01;
.equ    KEY_FORWARD             = $02;
.equ    KEY_STOP                = $03;
.equ    KEY_CHDIR               = $05;
.equ    KEY_FUNC                = $06;
.equ    KEY_AUDIO               = $07;
.equ    KEY_NONE                = $08;
.equ    KEY_LP_FORWARD          = $12;
.equ    KEY_LP_REWIND           = $10;

;--------------------------------------------------------------------
;       Tastennummern
;--------------------------------------------------------------------
.equ    Button_FRewind          = 0
.equ    Button_Play             = 1
.equ    Button_FForward         = 2
.equ    Button_Stop             = 3
.equ    Button_CDir             = 4
.equ    Button_Func             = 5
.equ    Button_up               = 6
.equ    button_Down             = 7
.equ    Button_OK               = 8
.equ    Button_blank            = 9
.equ    Button_PageUp           = 10
.equ    Button_PageDown         = 11
.equ    Button_TrackRep         = 12
.equ    Button_Aud              = 13
.equ    Button_Ret              = 14

.equ    MP3DEC_VOLUME           = 0
.equ    MP3DEC_BASS             = 1
.equ    MP3DEC_TREBLE           = 2

;--------------------------------------------------------------------
;                       Adressen fr IDE-Port
;--------------------------------------------------------------------
.equ    TIDE_DATAREG            = 0;
.equ    TIDE_ERRORREG           = 1;
.equ    TIDE_SECCNT             = 2;
.equ    TIDE_SECNR              = 3;
.equ    TIDE_CYLLOW             = 4;
.equ    TIDE_CYLHI              = 5;
.equ    TIDE_DRVHEAD            = 6;
.equ    TIDE_COMMAND            = 7;
.equ    TIDE_STATUS             = 7;
.equ    TIDE_DRVCTRL            = 6;

;--------------------------------------------------------------------
;       Adressen im internen RAM   Variablen  $0060 - $01ff
;--------------------------------------------------------------------
.equ    IRAM_ButtonAdr          = $0060;        ; array[0..7] of Byte
.equ    IRAM_TextArea           = $0068;        ; Word
.equ    IRAM_GraphArea          = $006a;        ; Word
.equ    IRAM_Volume             = $006c;        ; Byte
.equ    IRAM_Bass               = $006d;        ; Byte
.equ    IRAM_Treble             = $006e;        ; Byte
.equ    IRAM_OldButtonState     = $006f;        ; Byte
.equ    IRAM_AR_FIRSTDSECTOR    = $0070;        ; LongWord
.equ    IRAM_AR_NUMOFFATS       = $0074;        ; LongWord
.equ    IRAM_AR_FATSIZE         = $0078;        ; LongWord
.equ    IRAM_AR_SPC             = $007c;        ; LongWord
.equ    IRAM_AR_FIRSTSECOFCLUS  = $0080;        ; LongWord
.equ    IRAM_AR_CLUSTER         = $0084;        ; LongWord
.equ    IRAM_AR_RsvdSecCnt      = $0088;        ; LongWord
.equ    IRAM_AR_RESULT1         = $008c;        ; LongWord
.equ    IRAM_AR_RESULT2         = $0090;        ; LongWord
.equ    IRAM_LBA                = $0094;        ; LongWord
.equ    IRAM_CLUSTER            = $0098;        ; LongWord
.equ    IRAM_NEXT_CLUSTER       = $009c;        ; LongWord
.equ    IRAM_LBA_RESULT         = $00a0;        ; LongWord
.equ    IRAM_FIRST_SEC_OF_CLUS  = $00a4;        ; LongWord
.equ    IRAM_THIS_FAT_SEC_NR    = $00a8;        ; LongWord
.equ    IRAM_THIS_FAT_ENT_OFS   = $00ac;        ; LongWord
.equ    IRAM_LAST_DIR_CLUSTER   = $00b0;        ; LongWord
.equ    IRAM_FILESIZE           = $00b4;        ; LongWord
.equ    IRAM_ROOTCLUSTER        = $00b8;        ; Longword
.equ    IRAM_MENU_YPOS          = $00bc;        ; Word
.equ    IRAM_MENU_PAGE          = $00be;        ; Word
.equ    IRAM_LCD240_ADP         = $00c0;        ; Word
.equ    IRAM_TIMER_OLDMCUCR     = $00c2;        ; Byte
.equ    IRAM_OLD_SREG           = $00c3;        ; Byte
.equ    IRAM_MENU_MAX_ENTRIES   = $00c4;        ; Word
.equ    IRAM_FATBUFFER_ENTRIES  = $00c6;        ; Word
.equ    IRAM_PLAYINT_SECOND     = $00c8;        ; Byte
.equ    IRAM_PLAYINT_MINUTE     = $00c9;        ; Byte
.equ    IRAM_PLAYINT_TICKS      = $00ca;        ; Byte
.equ    IRAM_PLAYINT_HOUR       = $00cb;        ; Byte
.equ    IRAM_PLAYINT_WORD       = $00cc;        ; Word
.equ    IRAM_PLAYINT_INTERRUPT  = $00ce;        ; Byte
.equ    IRAM_PLAYINT_BITCNT     = $00cf;        ; Byte
.equ    IRAM_PLAYINT_SEKTOREND  = $00d0;        ; Byte
.equ    IRAM_PLAYINT_SPCCNT     = $00d1;        ; Byte
.equ    IRAM_PLAYINT_PLAYPOS    = $00d2;        ; Word
.equ    IRAM_PLAYINT_FATENTRIES = $00d4;        ; Word
.equ    IRAM_PLAYINT_OLDMCUCR   = $00d6;        ; Byte
.equ    IRAM_OLD_SECOND         = $00d7;        ; Byte
.equ    IRAM_OLD_MINUTE         = $00d8;        ; Byte
.equ    IRAM_SCANFAT_1PERCENT   = $00d9;        ; Word
.equ    IRAM_SCANFAT_1KASTL     = $00db;        ; Word
.equ    IRAM_SCANFAT_KASTL_COUNT= $00dd;        ; Word
.equ    IRAM_SCANFAT_PERCENT_COUNT= $00df;      ; Word
.equ    IRAM_SCANFAT_KASTL      = $00e1;        ; Byte
.equ    IRAM_SCANFAT_PERCENT    = $00e2;        ; Byte
.equ    IRAM_FIND_ATTR          = $00e3;        ; Byte
.equ    IRAM_FIND_Number        = $00e4;        ; Word
.equ    IRAM_FIND_ADR           = $00e6;        ; Word
.equ    IRAM_FIND_ADROLD        = $00e8;        ; Word
.equ    IRAM_FIND_NUMBEROLD     = $00ea;        ; Word
.equ    IRAM_TOT_VAL            = $00ec;        ; Word
.equ    IRAM_LPT_VAL            = $00ee;        ; Word
.equ    IRAM_MP3HEADER          = $00f0;        ; LongWord
.equ    IRAM_MP3HEADER_SPS      = $00f4;        ; Byte
.equ    IRAM_MP3HEADER_BitRate  = $00f5;        ; Byte
.equ    IRAM_MP3HEADER_BitIndex = $00f6;        ; Byte
.equ    IRAM_MP3HEADER_VERSION  = $00f7;        ; Byte
.equ    IRAM_MP3HEADER_FREQUENCY= $00f8;        ; Byte

.equ    IRAM_ID3_CLUSTERNR      = $0100;        ; LongWord
.equ    IRAM_ID3_SECTORNR       = $0104;        ; LongWord
.equ    IRAM_ID3_SECTOROFS      = $0108;        ; LongWord
.equ    IRAM_ID3_HELP           = $010c;        ; LongWord
.equ    IRAM_ID3_TAG            = $0110;        ; array[0..2] of char
.equ    IRAM_ID3_TITLE          = $0113;        ; array[0..29] of char
.equ    IRAM_ID3_ARTIST         = $0131;        ; array[0..29] of char
.equ    IRAM_ID3_ALBUM          = $014f;        ; array[0..29] of char
.equ    IRAM_ID3_YEAR           = $016d;        ; array[0..3] of char
.equ    IRAM_ID3_COMMENT        = $0171;        ; array[0..29] of char
.equ    IRAM_ID3_GENRE          = $018f;        ; byte


;--------------------------------------------------------------------
; Temporre Daten   $00200 - $00400 intern / $01000-$07fff extern
;--------------------------------------------------------------------
.equ    IRAM_BUFFER             = $0200;        ; Adressen fr Autodetect
.equ    IRAM_CYLINDER           = $0202;
.equ    IRAM_HEAD               = $0206;
.equ    IRAM_SECTOR             = $020c;
.equ    IRAM_STRING             = $0236;

.equ    IRAM_FAT32_BPB          = $0200;        ; Adresse fr SektorBuffer
.equ    IRAM_FAT32_OEMNAME      = $0203;        ; String "MSWIN4.1"
.equ    IRAM_FAT32_BPS          = $020b;        ; Bytes per Sector (must be 512)
.equ    IRAM_FAT32_SPC          = $020d;        ; Sectors per Cluster
.equ    IRAM_FAT32_RsvdSecCnt   = $020e;
.equ    IRAM_FAT32_NUMOFFATS    = $0210;
.equ    IRAM_FAT32_FATSIZE      = $0224;
.equ    IRAM_FAT32_ROOTCLUSTER  = $022c;        ; Cluster des ROOTs

.equ    IRAM_DIRBUFFER          = $0200;

.equ    IRAM_FATBUFFER          = $0200;

.equ    IRAM_SEKTORBUFFER       = $0200;

.equ    ERAM_DIRBUFFER          = $1000;        ; Externes RAM!!!

;--------------------------------------------------------------------
; Obere 64KB        $10000 - $1ffff
;--------------------------------------------------------------------
.equ    ERAM_FATBUFFER          = $1000;

;--------------------------------------------------------------------
;       Registerdefinition
;--------------------------------------------------------------------
;                               = r0
.def    PLAYINT_FLAGS           = r1
.def    TIMERINT_FLAGS          = r4
.def    TIMEOUT_FLAGS           = r5
.def    MISC_FLAGS              = r2
.def    TASK_FLAGS              = r3
;                               = r6
.def    tBCD0                   = r7   ;BCD value digits 1 and 0
.def    tBCD1                   = r8   ;BCD value digits 3 and 2
.def    tBCD2                   = r9   ;BCD value digit 4
;                               = r10
;                               = r11
.def    _ACCFLO                 = r12
.def    _ACCFHI                 = r13
.def    _ACCGLO                 = r14
.def    _ACCGHI                 = r15
.def    _ACCA                   = r16
.def    _ACCB                   = r17
.def    _ACCALO                 = r18
.def    _ACCAHI                 = r19
.def    _ACCBLO                 = r20
.def    _ACCBHI                 = r21
.def    _ACCCLO                 = r22
.def    _ACCCHI                 = r23
.def    _ACCDLO                 = r24
.def    _ACCDHI                 = r25
.def    _ACCELO                 = r26   ; Deckungsgleich mit XL!!!
.def    _ACCEHI                 = r27   ; Deckungsgleich mit XH!!!

;       RESERVIERT XL           = r26
;       RESERVIERT XH           = r27
;       RESERVIERT YL           = r28
;       RESERVIERT YH           = r29
;       RESERVIERT ZL           = r30
;       RESERVIERT ZH           = r31


;--------------------------------------------------------------------
; Interruptroutine fr MP3-Decoder
;--------------------------------------------------------------------
INT_PLAYINT:
        jmp PLAY_SONG

.include "DATA.INC"                     ; Daten und Tabellen
.include "LCD240.INC"                   ; Includefile fr Display
.include "IDE.INC"                      ; Includefile fr IDE-Drive
.include "BUTTON.INC"                   ; Includefile fr Buttons
.include "BCD.INC"                      ; BCD-Arithmetic
.include "TONE.INC"                     ; Klangeinstellungen
.include "MP3DEC.INC"                   ; Routinen fr MP3-Decoder
.include "IIC.INC"                      ; Routinen fr IC
.include "FAT32.INC"                    ; FAT32-Routinen
.include "ARITH32.INC"                  ; 32Bit Multiply Routines
.include "DIR.INC"                      ; Directoryfunction
.include "BAR.INC"                      ; Zeichenroutinen fr Bars
.include "PLAYINT.INC"                  ; Int-Abspielroutine
.include "SCANFAT.INC"                  ; Scannt die FAT nach Cluster
.include "MP3INFO.INC"                  ; Wertet Header und ID3 aus
.include "TIMER.INC"                    ; TASK-Manager
.include "TIMEOUT.INC"                  ; Timeout/Longpress Funktion
.include "SETPTIME.INC"                 ; Lied-Suchlauf

;--------------------------------------------------------------------
; InitPorts
;--------------------------------------------------------------------
initports:
        push r16

        ldi r16,$00                     ; Init Port A Input
        out DDRA,r16

        ldi r16,$00                     ; Init Port B Input
        out DDRB,r16

        ldi r16,$fe                     ; Init Port D Input
        out DDRD,r16

        ldi r16,$7f
        out DDRE,r16

        call IIC_SendStop

        sbi PortE,LCD_CS
        sbi PortE,IDE_CS
        sbi PortE,PER_RD
        sbi PortE,Per_WR
        cbi PortD,MP3dec_SID
        cbi PortD,MP3dec_SIC
        sbi PortE,MP3Dec_DEMAND
        cbi PORTD,MCU_A16

        pop r16
        ret

;--------------------------------------------------------------------
; InitVariables
;--------------------------------------------------------------------
initVariables:

        clt
        bld TASK_FLAGS,TASKF_FORWARD    ; Flag lschen
        bld TASK_FLAGS,TASKF_TPNOTALLOWED; nichterlaubt Flag lschen
        bld TASK_FLAGS,TASKF_TIMEOUTPLAY; TimeoutPlay-Flag lschen
        bld MISC_FLAGS,MISCF_FATSCANNED
        bld MISC_FLAGS,MISCF_ID3AVAILABLE

        set
        bld TASK_FLAGS,TASKF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYTIME
        bld TASK_FLAGS,TASKF_BUTTONSTATE

        ldi r16,$21                     ; Archive + ReadOnly
        sts IRAM_FIND_ATTR,r16

        ldi r16,$00
        sts IRAM_MP3HEADER_FREQUENCY,r16
        sts IRAM_MP3HEADER_BITRATE,r16
        sts IRAM_OldButtonState,r16

        CLR R16
        sts IRAM_MENU_YPOS,r16
        sts IRAM_MENU_YPOS+1,r16
        sts IRAM_MENU_PAGE,r16
        sts IRAM_MENU_PAGE+1,r16

        ret


;--------------------------------------------------------------------
; WAITR16               Wartet ungefhr R16*ms
;--------------------------------------------------------------------
Waitr16:
        push xl                         ; Register retten
        push xh
        push r16
WaitR16_2:
        ldi XL,$35
        ldi XH,$FD

WaitR16_1:
        adiw xl,$01
        dec r16                         ; R16 dekrementieren
        BRNE WaitR16_1                  ; Schon R16*ms abgearbeitet?
                                        ; Nein: nochmal
        pop r16                         ; Register zurckholen
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; WAITLONG              Wartet ungefhr R16*ms
;--------------------------------------------------------------------
waitlong:
        push r17
        push r16
;        ldi r17,30
waitlong_1:
        ldi r16,100
        call waitr16
        dec r17
        brne waitlong_1
        pop r16
        pop r17
        ret

;--------------------------------------------------------------------
; EnableSram     Interrupt und Variablen frn Interrupt initialisieren
;--------------------------------------------------------------------
Enable_Sram:
        push r16

        in r16,MCUCR
        andi r16,$3f
        ori r16,$c0             ; c0 fr waitstates
        out MCUCR,r16

        pop r16
        ret

;--------------------------------------------------------------------
; DisableSram     Interrupt und Variablen frn Interrupt initialisieren
;--------------------------------------------------------------------
Disable_Sram:
        push r16

        in r16,MCUCR
        andi r16,$3f
        out MCUCR,r16

        pop r16
        ret


;--------------------------------------------------------------------
; Set_PortA_Input
;--------------------------------------------------------------------
Set_PortA_Input:
        push r16
        ldi r16,$00                     ; Init Port A Output
        out DDRA,r16
        ldi r16,$ff
        out PortA,r16
        pop r16
        ret

;--------------------------------------------------------------------
; Set_PortA_Output
;--------------------------------------------------------------------
Set_PortA_Output:
        push r16
        ldi r16,$FF                     ; Init Port A Output
        out DDRA,r16
        pop r16
        ret

;--------------------------------------------------------------------
; Set_Portb_Input
;--------------------------------------------------------------------
Set_Portb_Input:
        push r16
        ldi r16,$00                     ; Init Port b Output
        out DDRB,r16
        ldi r16,$ff
        out PortB,r16
        pop r16
        ret

;--------------------------------------------------------------------
; Set_Portb_Output
;--------------------------------------------------------------------
Set_PortB_Output:
        push r16
        ldi r16,$FF                     ; Init Port b Output
        out DDRB,r16
        pop r16
        ret

;--------------------------------------------------------------------
; DIR_IS_Z_GREATER_THAN_Y    CHECK_YREG_POS
;--------------------------------------------------------------------
DIR_CHECK_YREG_POS:
        push yl
        push yh
        push zl
        push zh

        SUBI ZL, $01
        SBCI ZH, $00

        COM ZL
        COM ZH

        ADD ZL,YL
        ADC ZH,YH

        pop zh
        pop zl
        pop yh
        pop yl
        ret

;--------------------------------------------------------------------
; INC_INDIREKT  [Z]=[Z]+1
;--------------------------------------------------------------------
INC_INDIREKT:
        push xl
        push xh
        ld xl,Z+
        ld xh,Z+

        adiw xl,$01

        st -Z,xh
        st -Z,xl
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; DEC_INDIREKT  [Z]=[Z]-1
;--------------------------------------------------------------------
DEC_INDIREKT:
        push xl
        push xh
        ld xl,Z+
        ld xh,Z+

        sbiw xl,$01

        st -Z,xh
        st -Z,xl
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; DIR_COMPAER_Y_Z
;--------------------------------------------------------------------
DIR_COMPARE_Y_Z:
        cp yl,zl                        ; yl und zl gleich?
        brne DIR_COMPARE_NEQU           ; nein: Dann nicht gleich

        cp yh,zh
        brne DIR_COMPARE_NEQU

        sez
        ret

DIR_COMPARE_NEQU:
        clz
        ret

;--------------------------------------------------------------------
; DIR_COMPAER_Y_Z
;--------------------------------------------------------------------
DIR_COMPARE_X_Z:
        cp xl,zl                        ; yl und zl gleich?
        brne DIR_COMPARE_X_Z_NEQU           ; nein: Dann nicht gleich

        cp xh,zh
        brne DIR_COMPARE_X_Z_NEQU

        sez
        ret

DIR_COMPARE_X_Z_NEQU:
        clz
        ret


;--------------------------------------------------------------------
; DIR_IS_Y_ZERO:
;--------------------------------------------------------------------
DIR_IS_Y_ZERO:
        and yh,yh                       ; Hi-Byte 0?
        brne DIR_IS_Y_ZERO_1

        and yl,yl                       ; Lo-Byte 0?
        brne DIR_IS_Y_ZERO_1            ; Ja: Schleife beenden

        sez                             ; Zero setzen wenn 0
        ret

DIR_IS_Y_ZERO_1:
        clz                             ; Zero lschen wenn nicht 0
        ret


;--------------------------------------------------------------------
; Display_Pos:
;--------------------------------------------------------------------
Display_Pos:
        clr yl
        clr yh
        call LCD240_SetADP
        mov r16,zh
        call LCD240_OutVal
        mov r16,zl
        call LCD240_OutVal
        ret

;--------------------------------------------------------------------
;       SYSTEM_HALT     in Z String zum ausgeben
;--------------------------------------------------------------------
SYSTEM_HALT:
        call TIMER_STOP
        call LCD240_ClearText
        call LCD240_ClearGraph

        ldi r16,0
        ldi r17,1
        call LCD240_OutStringXY

        ldi zl,low(2*MSG_SYSTEM_HALT)
        ldi zh,high(2*MSG_SYSTEM_HALT)
        ldi r16,0
        ldi r17,3
        call LCD240_OutStringXY

SYSTEM_HALT_1:
        jmp SYSTEM_HALT_1


;--------------------------------------------------------------------
; Mainpart
;--------------------------------------------------------------------
init:
        ldi r16,low(RAMEND)             ; Stackpointer at the
        out SPL,r16                     ; end of internal Memory
        ldi r16,high(RAMEND)
        out SPH,r16

        LDI r17,255
        call waitlong

        call initports                  ; Ports initialisieren
        call INITVariables              ; Variablen initislisieren
        call enable_SRAM
        call LCD240_initLCD
        call LCD240_ClearGraph
        call LCD240_ClearText
        call Button_InitPlayBar

        clr yl
        clr yh
        call LCD240_SetADP

        call TIMEOUTTIMER_INIT          ; Timeouttimer initialisieren
        call IDE_Autodetect             ; Autodetectfunktion ausfhren
        call lcd240_cleartext           ; Text-screen lschen
        call DIR_INIT                   ; Verzeichns einlesen
        call FAT32_ReadBPB              ; FAT32 und ROOT lesen
        call DIR_FIND_FIRST             ; Erstes File suchen
        call PLAYINT_STOP               ; Anhalten sonst Konflikt
        call PLAY_INIT                  ; Song initialisieren
        call TIMER_INIT                 ; TASK-Timer initalisieren
        call TIMER_START                ; Task-Timer starten
        call TONE_INIT

        call lcd240_ClearText

        set
        bld MISC_FLAGS,MISCF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYTIME


MAINCASE:
        set
        bld MISC_FLAGS,MISCF_PLAYSCREEN

        clt
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE

        call Keyboard_check             ; Warten auf Tastendrck

        cpi r17,KEY_NONE                ; Loopen
        breq MAINCASE

;---------------------------------------- Audio-Button --------------
        cpi r17,KEY_AUDIO
        brne MAINCASE_1

        clt
        bld MISC_FLAGS,MISCF_PLAYSCREEN

        call Tone_Control               ; Tone-Control ausgewhlt

        set
        bld MISC_FLAGS,MISCF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYTIME

        ldi r17,KEY_NONE
;---------------------------------------- CHDIR-Button --------------
MAINCASE_1:
        cpi r17,KEY_CHDIR               ; Directory wechseln?
        brne MAINCASE_2

        call PLAYINT_STOP

        clt
        bld MISC_FLAGS,MISCF_PLAYSCREEN

        call DIR_Change

        set
        bld MISC_FLAGS,MISCF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYTIME
;        call DISPLAY_PLAYSCREEN

        ldi r17,KEY_NONE
;---------------------------------------- PLAY/PAUSE Button ---------
MAINCASE_2:
        cpi r17,KEY_PLAYPAUSE
        brne MAINCASE_3

        sbrc MISC_FLAGS,MISCF_NoFiletoPlay
        jmp MAINCASE_3

        call PLAYINT_PAUSE
        ldi r17,KEY_NONE
;---------------------------------------- STOP Button ---------------
MAINCASE_3:
        cpi r17,KEY_STOP
        brne MAINCASE_4

        sbrc PLAYINT_FLAGS,PLAYINTF_STOP; Schon Stop??
        call DIR_FIND_FIRST             ; ja: Erstes File suchen

        call PLAYINT_STOP
        call PLAY_INIT

        set
        bld TASK_FLAGS,TASKF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYTIME

        ldi r17,KEY_NONE
;---------------------------------------- Rewind-Button -------------
MAINCASE_4:

        cpi r17,KEY_REWIND
        brne MAINCASE_5

MAINCASE_4_1:
        sbrc MISC_FLAGS,MISCF_NoFiletoPlay
        jmp MAINCASE_5

        ldi r16,$01
        call PLAYINT_REWIND
        ldi r17,KEY_NONE
;---------------------------------------- Forward-Button ------------
MAINCASE_5:
        cpi r17,KEY_FORWARD
        brne MAINCASE_6

MAINCASE_5_1:
        sbrc MISC_FLAGS,MISCF_NoFiletoPlay
        jmp MAINCASE_6

        ldi r16,$01
        call PLAYINT_FORWARD
        ldi r17,KEY_NONE
;---------------------------------------- Longpress-Forward ---------
MAINCASE_6:
        cpi r17,KEY_LP_FORWARD
        brne MAINCASE_7

        sbrc MISC_FLAGS,MISCF_NoFiletoPlay
        jmp MAINCASE_7

        sbrs PLAYINT_FLAGS,PLAYINTF_PLAY
        jmp MAINCASE_7

        call SETPTIME_FORWARD
        ldi r17,KEY_NONE
;---------------------------------------- Longpress-Rewind ----------
MAINCASE_7:
        cpi r17,KEY_LP_REWIND
        brne MAINCASE_8

        sbrc MISC_FLAGS,MISCF_NoFiletoPlay
        jmp MAINCASE_8

        sbrs PLAYINT_FLAGS,PLAYINTF_PLAY
        jmp MAINCASE_8

        call SETPTIME_REWIND
        ldi r17,KEY_NONE
;---------------------------------------- Ende ----------------------
MAINCASE_8:
        cpi r17,KEY_FUNC
        brne MAINCASE_9

        ldi r16,0
        ldi r17,0
        call lcd240_SetCursor

        in r16,SPH
        call lcd240_OutVal
        in r16,SPL
        call lcd240_OutVal

MAINCASE_9:

        jmp MAINCASE


