;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; MP3DEC_DeviceAccess
;--------------------------------------------------------------------
;MP3DEC_Deviceaccess:
        push r16
MP3DEC_DeviceAccess_1:
        rcall IIC_SendStop
        rcall IIC_SendStart
        ldi r16,$3a
        rcall IIC_SendByte

        sbi PortD,IIC_SDA
        cbi DDRD,IIC_SDA
        rcall IIC_Wait
        sbi PortD,IIC_SCL
MP3DEC_DeviceAccess_2:
        sbic PIND,IIC_SDA
        rjmp MP3DEC_DeviceAccess_1
        cbi PortD,IIC_SCL
MP3DEC_DeviceAccess_3:
        sbis PIND,IIC_SDA
        rjmp MP3DEC_DeviceAccess_3
        sbi DDRD,IIC_SDA
        cbi PortD,IIC_SDA
        pop r16
        ret

;--------------------------------------------------------------------
; MP3DEC_WriteD1Memory      X:Adr,Z:Tablepointer
;--------------------------------------------------------------------
MP3Dec_WriteD1Memory:
        push r16
        push r17
        push zl
        push zh
        push r0

MP3Dec_WriteD1Memory_OK:
        rcall IIC_SendStop
        rcall IIC_SendStart
        ldi r16,$3a
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

;        rcall MP3DEC_DeviceAccess

        ldi r16,$68
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        ldi r16,$B0
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        ldi r16,$00
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        ldi r16,$00
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        ldi r16,$01                             ; 7f8
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        mov r16,xh
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        mov r16,xl
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        ldi r17,$04

MP3Dec_WriteD1Memory_1:
        lpm
        adiw zl,$01
        mov r16,r0
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        dec r17
        brne MP3Dec_WriteD1Memory_1

        rcall IIC_SendStop

        pop r0
        pop zh
        pop zl
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; MP3DEC_ToneControl        r16 NR (Bass,Treb,Vol) r17:Wert
;--------------------------------------------------------------------
MP3DEC_ToneControl:
        push r0
        push r16
        push r17
        push r18
        push zl
        push zh
        push xh
        push xl

        mov r18,r16

        cpi r18,MP3DEC_VOLUME
        breq MP3DEC_ToneControl_Volume

        ldi zl,low(2*DATA_BASSTABLE)
        ldi zh,high(2*DATA_BASSTABLE)

        cpi r18,MP3DEC_BASS
        breq MP3DEC_ToneControl_BassTreble_3

        ldi zl,low(2*DATA_TREBLETABLE)
        ldi zh,high(2*DATA_TREBLETABLE)

MP3DEC_ToneControl_BassTreble_3:
        and r17,r17
        breq MP3DEc_ToneControl_BassTreble_2

        adiw zl,$02
        dec r17
        brne MP3Dec_ToneControl_BassTreble_3

MP3DEC_ToneControl_BassTreble_2:
        push yl
        push yh
        ldi yl,40
        ldi yh,$00
        rcall LCD240_SetADP
        pop yh
        pop yl

        rcall IIC_SendStop
        rcall IIC_SendStart
        ldi r16,$3a
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

;        rcall MP3DEC_DeviceAccess

        ldi r16,$68
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        ldi r16,$96
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        ldi r16,$b0

        cpi r18,MP3DEC_BASS
        breq MP3DEC_ToneControl_BassTreble_4
        ldi r16,$f0
MP3DEC_ToneControl_BassTreble_4:

        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        lpm
        adiw zl,$01
        mov r16,r0
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        lpm
        adiw zl,$01
        mov r16,r0
        rcall IIC_SendByte
        rcall IIC_ReceiveACK

        rcall IIC_SendStop

        rjmp MP3DEC_ToneControl_end

MP3DEC_ToneControl_Volume:
        ldi zl,low(2*DATA_VOLUMETABLE)
        ldi zh,high(2*DATA_VOLUMETABLE)

MP3DEC_ToneControl_Volume_1:
        and r17,r17
        breq MP3DEc_ToneControl_Volume_2

        adiw zl,$04
        dec r17
        brne MP3Dec_ToneControl_Volume_1

MP3Dec_ToneControl_Volume_2:
        ldi xl,$f8
        ldi xh,$07
        rcall MP3Dec_WriteD1Memory

        ldi xl,$fb
        ldi xh,$07
        rcall MP3Dec_WriteD1Memory

MP3DEC_ToneControl_end:
        pop xl
        pop xh
        pop zh
        pop zl
        pop r18
        pop r17
        pop r16
        pop r0
        ret

;--------------------------------------------------------------------
; MP3_SendByte          (r0)
;--------------------------------------------------------------------
MP3_SendByte:
        push r18
        ldi r18,128                     ; R18 mit 8 laden
MP3_SendByte_Sub1_1:
        SBIS pind,MP3DEC_DEMAND         ; Demand-Bit gesetzt?
        rjmp MP3_SendByte_Sub1_1        ; Nein: nochmal testen

        SBI portd,MP3DEC_SIC            ; Set SIC Bit high

        push r0                         ; R0 retten
        and r0,r18                      ; Mit R1 Und verknpfen
        pop r0                          ; r0 wieder holen
        breq MP3_SendByte_Sub1_2        ; Bit 0? Dann lschen
        SBI portd,MP3DEC_SID            ; SID-Bit setzen wenn nicht 0
        rjmp MP3_SendByte_Sub1_3
MP3_SendByte_Sub1_2:
        CBI portd,MP3DEC_SID            ; SID lschen
MP3_SendByte_Sub1_3:
        CBI portd,MP3DEC_SIC            ; Clr SIC Bit

        LSR r18                         ; R1 um eins nach rechts schieben
        brne MP3_SendByte_Sub1_1        ; R1 0? (=alle 8bits bearbeitet)
        pop r18
        ret                             ; 16384 Bytes gespeichert

;--------------------------------------------------------------------
; Warten auf Demand
;--------------------------------------------------------------------
MP3DEC_WAIT_FOR_DEMAND:
        SBIS pine,MP3DEC_DEMAND         ; Demand-Bit gesetzt?
        rjmp MP3DEC_WAIT_FOR_DEMAND     ; Will keine Daten mehr?

;        call MP3Dec_Writed0Memory

        ret


