;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; MP3_GETINFO
;--------------------------------------------------------------------
MP3_GETINFO_ERROR:
        set
        bld TASK_FLAGS,TASKF_FORWARD    ; Flag setzen
        sez                             ; Zero setzen
        rjmp MP3_GETINFO_POPSTACK       ; Flags vom Stack POPpen

MP3_GETINFO:
        push r0
        push r16
        push r17
        push r18
        push r19
        push r20
        push r21
        push r22
        push r23
        push r24
        push r25
        push xl
        push xh
        push zl
        push zh
        push yl
        push yh

        ldi zl,low(ERAM_FATBUFFER)
        ldi zh,high(ERAM_FATBUFFER)
        ldi xl,low(IRAM_LBA)
        ldi xh,high(IRAM_LBA)
        call COPY32_INDIREKT_HI_TO_LO   ; Sektoradresse nach LBA kopieren

        ldi xl,low(IRAM_SEKTORBUFFER)
        ldi xh,high(IRAM_SEKTORBUFFER)
        push xl
        push xh
        ldi r16,1                       ; einen sektor laden
        call IDE_READ_LBA
        pop xh
        pop xl

        ldi zl,low(512)
        ldi zh,high(512)

MP3_GETINFO_1:
        adiw zl,$0                      ; ist Z= 0?
        breq MP3_GETINFO_ERROR          ; Dann immer noch nichts gefunden!

        sbiw zl,$01                     ; Z dekrementieren

        ld r16,X+                       ; ein byte holen
        cpi r16,$ff

        breq MP3_GETINFO_2              ; ist $ff? dann weiter sonst

        rjmp MP3_GETINFO_1              ; noch einen Durchlauf

MP3_GETINFO_2:
        ld r16,X+
        push r16
        andi r16,$e0                    ; obere 3 Bits maskieren
        cpi r16,$e0                     ; waren sie gesetzt?
        pop r16
        brne MP3_GETINFO_1              ; Nein: dann kein Synchrobyte

        sbiw zl,$01                     ; Z um 1 dekrementieren

        push r16
        ldi r16,$ff                     ; kompletten MP3-Header restaurieren
        sts IRAM_MP3HEADER+3,r16
        pop r16

        sts IRAM_MP3HEADER+2,r16
        ld r16,X+
        sts IRAM_MP3HEADER+1,r16
        ld r16,X+
        sts IRAM_MP3HEADER,r16

;---------------------------------------- MPEG-Version ermitteln ----
        lds r16,IRAM_MP3HEADER+2

        andi r16,$1e                    ; Version und Layer ausmaskieren
        sts IRAM_MP3HEADER_VERSION,r16  ; Abspeichern

        clr r17

        ldi zl,low(2*DATA_VERSION_LAYER_TABLE)
        ldi zh,high(2*DATA_VERSION_LAYER_TABLE)

        add zl,r16
        adc zh,r17                      ; Eintrag der Adresse in Tabelle suchen

        lpm                             ; Lo-Byte von Adresse holen
        push r0                         ; Auf dem Stack zwischenspeichern
        adiw zl,$01

        lpm                             ; Hi-Byte von Adresse holen
        push r0                         ; Auf dem Stack zwischenspeichern
        adiw zl,$01

        pop zh
        pop zl                          ; und zurck nach Z

        adiw zl,0                       ; Unerlaubte Typ?
        brne MP3_GETINFO_CONT1          ; Nein: Dann weiter
        rjmp MP3_GETINFO_ERROR          ; Ja: Dann beenden

MP3_GETINFO_CONT1:

        lds r16,IRAM_MP3HEADER+1        ; BitRate ermitteln

        sts IRAM_MP3HEADER_BitIndex,r16

        andi r16,$f0                    ; Oberes Bit maskieren
        swap r16                        ; Nibbles vertauschen

        clr r17

        add zl,r16                      ; Zu BitRateTable offset addieren
        adc zh,r17

        lpm
        mov r16,r0

        sts IRAM_MP3HEADER_BitRate,r16  ; und im Speicher ablegen
        lsr r16                         ; durch 4 teilen um Sektoren p. Sek
        lsr r16                         ; zu bekommen

        dec r16
        sts IRAM_MP3HEADER_SPS,r16      ; und abspeichern

;--------------------------------------- Frequenz ermitteln ---------
        lds r16,IRAM_MP3HEADER_VERSION
        andi r16,$18
        lsr r16                         ; 1 Bit nach rechts schieben

        lds r17,IRAM_MP3HEADER+1
        andi r17,$0c                    ; FrequencyIndex ausmaskieren
        lsr r17
        lsr r17                         ; 2 Bits nach rechts schieben

        or r16,r17
        clr r17

        ldi zl,low(2*DATA_FREQUENCYTABLE)
        ldi zh,high(2*DATA_FREQUENCYTABLE)
        add zl,r16
        adc zh,r17                      ; Z=Z+Index

        LPM
        sts IRAM_MP3HEADER_FREQUENCY,r0 ; Frequenz abspeichern

        and r0,r0                       ; Unerlaubte Frequenz?
        brne MP3_GETINFO_CONT2         ; Ja: Dann nchstes Lied
        rjmp MP3_GETINFO_ERROR         ; Ja: Dann nchstes Lied

MP3_GETINFO_CONT2:
;        set
;        bld TASK_FLAGS,TASKF_PLAYSCREEN ; Task einschalten

        clz
MP3_GETINFO_POPSTACK:
        pop yh
        pop yl
        pop zh
        pop zl
        pop xh
        pop xl
        pop r25
        pop r24
        pop r23
        pop r22
        pop r21
        pop r20
        pop r19
        pop r18
        pop r17
        pop r16
        pop r0
        ret

;--------------------------------------------------------------------
; MP3_GetID3    Wertet den ID3-Tag des Files aus
;--------------------------------------------------------------------
MP3_GetID3_Sub1:
;--------------------------------------------------------------------
; FILESIZE=FILESIZE - ID3HELP(=128)
;--------------------------------------------------------------------
        ldi xl,low(IRAM_FILESIZE)
        ldi xh,high(IRAM_FILESIZE)
        mov zl,xl
        mov zh,xh

        ldi r16,128
        sts IRAM_ID3_HELP,r16
        clr r16
        sts IRAM_ID3_HELP+1,r16
        sts IRAM_ID3_HELP+2,r16
        sts IRAM_ID3_HELP+3,r16

        ldi yl,low(IRAM_ID3_HELP)
        ldi yh,high(IRAM_ID3_HELP)

        call SUB32_INDIREKT

;--------------------------------------------------------------------
; SECTORNR=FILESIZE DIV 512     REST in SecOFS
;--------------------------------------------------------------------
        ldi zl,low(IRAM_ID3_SECTORNR)
        ldi zh,high(IRAM_ID3_SECTORNR)
        ldi xl,low(IRAM_FILESIZE)
        ldi xh,high(IRAM_FILESIZE)
        ldi yl,low(IRAM_ID3_SECTOROFS)
        ldi yh,high(IRAM_ID3_SECTOROFS)
        call DIV32_BY512_INDIREKT

;--------------------------------------------------------------------
; SECTORNR=SECTORNR DIV SecPerClus     SectorOfsInCluster in ID3_HELP
;--------------------------------------------------------------------
        ldi zl,low(IRAM_ID3_SECTORNR)
        ldi zh,high(IRAM_ID3_SECTORNR)
        ldi xl,low(IRAM_AR_SPC)
        ldi xh,high(IRAM_AR_SPC)
        ldi yl,low(IRAM_ID3_HELP)
        ldi yh,high(IRAM_ID3_HELP)
        call DIV32_indirekt

;--------------------------------------------------------------------
; Clusternummer in die Variable IRAM_ID3_CLUSTERNR kopieren
;--------------------------------------------------------------------
        ldi zl,low(IRAM_ID3_CLUSTERNR)
        ldi zh,high(IRAM_ID3_CLUSTERNR)
        ldi xl,low(IRAM_ID3_SECTORNR)
        ldi xh,high(IRAM_ID3_SECTORNR)
        call COPY32_INDIREKT

;--------------------------------------------------------------------
; SectorNummer in die Variable IRAM_ID3_SECTORNR kopieren
;--------------------------------------------------------------------
        ldi zl,low(IRAM_ID3_SECTORNR)
        ldi zh,high(IRAM_ID3_SECTORNR)
        ldi xl,low(IRAM_ID3_HELP)
        ldi xh,high(IRAM_ID3_HELP)
        call COPY32_INDIREKT

;--------------------------------------------------------------------
; Aus der FAT den richtigen Cluster rausklauben
; IRAM_LBA = FATBUFFER [CLUSTERNR]
;--------------------------------------------------------------------
        ldi zl,low(ERAM_FATBUFFER)
        ldi zh,high(ERAM_FATBUFFER)
        lds r16,IRAM_ID3_CLUSTERNR      ; Hier maximal 16 bit gro!!!
        lds r17,IRAM_ID3_CLUSTERNR+1

        lsl r16
        rol r17

        lsl r16
        rol r17

        add zl,r16                      ; 16-Bit-Addition mit Carry
        adc zh,r17

        ldi xl,low(IRAM_LBA)
        ldi xh,high(IRAM_LBA)
        call COPY32_INDIREKT_HI_TO_LO   ; Sektoradresse nach LBA kopieren

;--------------------------------------------------------------------
; Zu dem Sektor die SectorNr dazuadieren
; IRAM_LBA = IRAM_LBA + SECTORNR
;--------------------------------------------------------------------
        ldi zl,low(IRAM_LBA)
        ldi zh,high(IRAM_LBA)
        mov xl,zl
        mov xh,zh

        ldi yl,low(IRAM_ID3_SECTORNR)
        ldi yh,high(IRAM_ID3_SECTORNR)
        call ADD32_INDIREKT             ; und 32 Bit Addition ausfhren

;--------------------------------------------------------------------
; Sektor laden
;--------------------------------------------------------------------
        ldi xl,low(IRAM_SEKTORBUFFER)
        ldi xh,high(IRAM_SEKTORBUFFER)
        push xl
        push xh
        ldi r16,1                       ; einen sektor laden
        call IDE_READ_LBA
        pop xh
        pop xl

        lds r16,IRAM_ID3_SECTOROFS
        lds r17,IRAM_ID3_SECTOROFS+1    ; SectorOfs holen und zu X addieren

        add xl,r16
        adc xh,r17

        ret

MP3_GetID3:
        push r0
        push r16
        push r17
        push r18
        push r19
        push r20
        push r21
        push r22
        push r23
        push r24
        push r25
        push xl
        push xh
        push zl
        push zh
        push yl
        push yh
;--------------------------------------------------------------------
; FILESIZE ermitteln und Subroutine aufrufen
;--------------------------------------------------------------------
        call DIR_GET_FileSize_From_Find ; Gre holen
        call MP3_GetID3_Sub1

;--------------------------------------------------------------------
; Tag rauskopieren aus dem Sektorbuffer   128 * X -> Y
;--------------------------------------------------------------------
        ldi yl,low(IRAM_ID3_TAG)
        ldi yh,high(IRAM_ID3_TAG)
        ldi r19,$00

MP3_GetID3_1:
        ld r16,X+
        st Y+,r16                       ; Byte abspeichern

        inc r19
                                        ; X schon aus dem Puffer raus?
        cpi xh,high(IRAM_SEKTORBUFFER+$0200)
        breq MP3_GetID3_LoadNextSektor

        cpi r19,128                     ; Schon 128 Bytes kopiert?
        brne MP3_GetID3_1

        clt

        lds r16,IRAM_ID3_TAG
        cpi r16,'T'
        brne MP3_GetID3_NoTag

        lds r16,IRAM_ID3_TAG+1
        cpi r16,'A'
        brne MP3_GetID3_NoTag

        lds r16,IRAM_ID3_TAG+2
        cpi r16,'G'
        brne MP3_GetID3_NoTag

        set

MP3_GetID3_NoTag:
        bld MISC_FLAGS,MISCF_ID3AVAILABLE

        pop yh
        pop yl
        pop zh
        pop zl
        pop xh
        pop xl
        pop r25
        pop r24
        pop r23
        pop r22
        pop r21
        pop r20
        pop r19
        pop r18
        pop r17
        pop r16
        pop r0
        RET

MP3_GetID3_LoadNextSektor:
        push yl
        push yh
        push r19

        call DIR_GET_FileSize_From_Find ; Gre holen

        ldi xl,low(IRAM_FILESIZE)
        ldi xh,high(IRAM_FILESIZE)
        mov zl,xl
        mov zh,xh

        sts IRAM_ID3_HELP,r19
        clr r16
        sts IRAM_ID3_HELP+1,r16
        sts IRAM_ID3_HELP+2,r16
        sts IRAM_ID3_HELP+3,r16

        ldi yl,low(IRAM_ID3_HELP)
        ldi yh,high(IRAM_ID3_HELP)
        call ADD32_INDIREKT

        call MP3_GetID3_Sub1

        lds yl,IRAM_ID3_SECTOROFS
        lds yh,IRAM_ID3_SECTOROFS+1
        adiw yl,$00
        brne MP3_GETID3_ERROR

        pop r19
        pop yh
        pop yl
        rjmp MP3_GetID3_1

MP3_GETID3_ERROR:
        ldi zl,low(2*MSG_INTERNALERROR)
        ldi zh,high(2*MSG_INTERNALERROR)
        call SYSTEM_HALT

        ret                             ; Hier kommt man NIE hin!

