;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;  Includefile fr MEGA1
;--------------------------------------------------------------------


;--------------------------------------------------------------------
; PLAY_READ_LBA     r16=Anzahl der Sektoren  X=BufferAdresse
;--------------------------------------------------------------------
PLAY_READ_LBA_AND_PLAY:
        push zl
        push zh
        push r16

        sbrc PLAYINT_FLAGS,PLAYINTF_INTERRUPT   ; Nicht abgebrochen?
        rjmp PLAY_READ_LBA_AND_PLAY_OLDWORD     ; Dann normale Routine

        set
        bld PLAYINT_FLAGS,PLAYINTF_SEKTOREND

        call IDE_WaitWhileBusy
        call IDE_WaitForReady

        ldi zl,TIDE_SECCNT
        ldi zh,$90
        ldi r16,1
        ST Z,r16

        ldi zl,TIDE_SECNR
        lds r16,IRAM_LBA
        ST Z,r16

        ldi zl,TIDE_CYLLOW
        lds r16,IRAM_LBA+1
        ST Z,r16

        ldi zl,TIDE_CYLHI
        lds r16,IRAM_LBA+2
        ST Z,r16

        ldi zl,TIDE_DRVHEAD
        lds r16,IRAM_LBA+3
        ori r16,$e0
        ST Z,r16

        ldi zl,TIDE_COMMAND
        ldi r16,$20
        ST Z,r16

        call IDE_WaitforDRQ

PLAY_READ_LBA_AND_PLAY_Loop1:
        ldi zl,TIDE_DATAREG
        ldi zh,$90
        ld r16,Z
        sts IRAM_PLAYINT_WORD,r16

        ldi zl,TIDE_DATAREG
        ldi zh,$80
        ld r16,Z
        sts IRAM_PLAYINT_WORD+1,r16

PLAY_READ_LBA_AND_PLAY_OLDWORD:
        call PLAY_SENDWORD

        sbrc PLAYINT_FLAGS,PLAYINTF_INTERRUPT
        rjmp PLAY_READ_LBA_AND_PLAY_INT

        call IDE_checkDRQ
        brne PLAY_READ_LBA_AND_PLAY_LOOP1

        clt                             ; Normal beenden
        bld PLAYINT_FLAGS,PLAYINTF_INTERRUPT

        call IDE_WaitWhileBusy
        call IDE_WaitForReady

        clt
        bld PLAYINT_FLAGS,PLAYINTF_SEKTOREND

PLAY_READ_LBA_AND_PLAY_INT:

        pop r16
        pop zh
        pop zl
        ret

;--------------------------------------------------------------------
; PLAY_SENDWORD          (r0)
;--------------------------------------------------------------------
PLAY_SENDWORD:
        push r18

        clt                             ; Interruptmarke ausschalten
        bld PLAYINT_FLAGS,PLAYINTF_INTERRUPT

        lds zl,IRAM_PLAYINT_WORD+1      ; Absichtlich verdreht!!!
        lds zh,IRAM_PLAYINT_WORD

        lds r18,IRAM_PLAYINT_BITCNT

PLAY_SENDWORD_1:
        SBIS pine,MP3DEC_DEMAND         ; Demand-Bit gesetzt?
        rjmp PLAY_SENDWORD_INTERRUPT    ; Will keine Daten mehr?

        SBI portd,MP3DEC_SIC            ; Set SIC Bit high

        sbrc zh,7
        sbi PortD,MP3DEC_SID            ; Bit SID auf high
        sbrs zh,7                       ; Bit 15 gesetzt? Nein: berspringen
        cbi PortD,MP3DEC_SID            ; Bit SID auf LO

        CBI PortD,MP3DEC_SIC            ; Clock wieder zurcknehmen

        LSL zl                          ; 16 Bit um 1 nach links
        ROL zh                          ; ROL bewirkt CARRY bertrag

        dec r18
        brne PLAY_SENDWORD_1

PLAY_SENDWORD_2:

        ldi r18,16                      ; 16 Bits bearbeiten
        sts IRAM_PLAYINT_BITCNT,r18

        pop r18
        ret

PLAY_SENDWORD_INTERRUPT:
        sts IRAM_PLAYINT_WORD+1,zl      ; absichtlich verdreht!!!
        sts IRAM_PLAYINT_WORD,zh
        sts IRAM_PLAYINT_BITCNT,r18

        set                             ; T setzen und nach
        bld PLAYINT_FLAGS,PLAYINTF_INTERRUPT

        pop r18
        ret

;--------------------------------------------------------------------
; PLAYINT_INKREMENT_TIME
;--------------------------------------------------------------------
PLAYINT_INKREMENT_TIME:
        push r16

        lds r16,IRAM_PLAYINT_TICKS      ; Ticks aus Memory holen
        inc r16                         ; Ticks inkrementieren
        sts IRAM_PLAYINT_TICKS,r16

        lds r17,IRAM_MP3HEADER_SPS      ; Und SecPerSecond holen

        cp r16,r17                      ; und vergleichen
        brne PLAYINT_INKREMENT_TIME_END ; nicht gleich? Dann ende

        clr r16
        sts IRAM_PLAYINT_TICKS,r16      ; Ticks lschen und

        set
        bld TASK_FLAGS,TASKF_PLAYTIME   ; PLAYTIME Task aktivieren

        lds r16,IRAM_PLAYINT_SECOND     ; Sekunde inkrementieren
        inc r16
        sts IRAM_PLAYINT_SECOND,r16     ; und wieder abspeichern

        cpi r16,60                      ; schon 60 Sekunden erreicht?
        brne PLAYINT_INKREMENT_TIME_END

        clr r16
        sts IRAM_PLAYINT_SECOND,r16

        lds r16,IRAM_PLAYINT_MINUTE     ; Minute inkrementieren
        inc r16
        sts IRAM_PLAYINT_MINUTE,r16     ; und wieder abspeichern

        cpi r16,60                      ; schon 60 minuten erreicht??
        brne PLAYINT_INKREMENT_TIME_END

        clr r16
        sts IRAM_PLAYINT_MINUTE,r16

        lds r16,IRAM_PLAYINT_HOUR       ; Minute inkrementieren
        inc r16
        sts IRAM_PLAYINT_HOUR,r16       ; und wieder abspeichern

PLAYINT_INKREMENT_TIME_END:
        lds r17,IRAM_PLAYINT_SPCCNT
        dec r17
        sts IRAM_PLAYINT_SPCCNT,r17

        brne PLAYINT_INKREMENT_TIME_END_2

        lds r17,IRAM_AR_SPC
        sts IRAM_PLAYINT_SPCCNT,r17
        sez

PLAYINT_INKREMENT_TIME_END_2:

        pop r16
        ret

;--------------------------------------------------------------------
; INKREMENT_PLAYPOS
;--------------------------------------------------------------------
PLAYINT_INKREMENT_PLAYPOS:
        push xl
        push xh
        lds xl,IRAM_PLAYINT_FATENTRIES
        lds xh,IRAM_PLAYINT_FATENTRIES+1
        adiw xl,$00                     ; schon 0?
        breq PLAYINT_INKREMENT_PLAYPOS_1
        sbiw xl,$01
        breq PLAYINT_INKREMENT_PLAYPOS_1
        sts IRAM_PLAYINT_FATENTRIES,xl
        sts IRAM_PLAYINT_FATENTRIES+1,xh

        lds xl,IRAM_PLAYINT_PLAYPOS
        lds xh,IRAM_PLAYINT_PLAYPOS+1
        adiw xl,$04
        sts IRAM_PLAYINT_PLAYPOS,xl
        sts IRAM_PLAYINT_PLAYPOS+1,xh

        clz

PLAYINT_INKREMENT_PLAYPOS_1:
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; DEKREMENT_PLAYPOS
;--------------------------------------------------------------------
PLAYINT_DEKREMENT_PLAYPOS:
        push xl
        push xh
        lds xl,IRAM_PLAYINT_PLAYPOS
        lds xh,IRAM_PLAYINT_PLAYPOS+1

        cpi xh,high(ERAM_DIRBUFFER)
        brne PLAYINT_DEKREMENT_PLAYPOS_2

        cpi xl,low(ERAM_DIRBUFFER)
        brne PLAYINT_DEKREMENT_PLAYPOS_2

        sez
        rjmp PLAYINT_DEKREMENT_PLAYPOS_1

PLAYINT_DEKREMENT_PLAYPOS_2:
        sbiw xl,$04
        sts IRAM_PLAYINT_PLAYPOS,xl
        sts IRAM_PLAYINT_PLAYPOS+1,xh

        lds xl,IRAM_PLAYINT_FATENTRIES
        lds xh,IRAM_PLAYINT_FATENTRIES+1
        adiw xl,$01
        sts IRAM_PLAYINT_FATENTRIES,xl
        sts IRAM_PLAYINT_FATENTRIES+1,xh

        clz

PLAYINT_DEKREMENT_PLAYPOS_1:
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; PLAY_SONG
;--------------------------------------------------------------------
PLAY_SONG:
        push r17
        in r17,SREG
        push r17
        push xl
        push xh
        push zl
        push zh

        in r17,MCUCR
        sts IRAM_PLAYINT_OLDMCUCR,r17

        ldi r17,$c0
        out MCUCR,r17

        cbi DDRE,MP3DEC_DEMAND         ; Und Wieder auf Eingabe
PLAY_SONG_1:
        sbrc PLAYINT_FLAGS,PLAYINTF_INTERRUPT
        rjmp PLAY_SONG_5

        lds zl,IRAM_PLAYINT_PLAYPOS
        lds zh,IRAM_PLAYINT_PLAYPOS+1
        ldi xl,low(IRAM_LBA)
        ldi xh,high(IRAM_LBA)
        call COPY32_INDIREKT_HI_TO_LO   ; Sektoradresse nach LBA kopieren

PLAY_SONG_5:
        call PLAY_READ_LBA_AND_PLAY     ; Sectoren in RAM laden

        sbrc PLAYINT_FLAGS,PLAYINTF_INTERRUPT ; abgebrochen?
        rjmp PLAY_SONG_INTERRUPT

        sbrc PLAYINT_FLAGS,PLAYINTF_SEKTOREND ; Sektor komplett?
        rjmp PLAY_SONG_5                ; Nein: Nochmal

        call IDE_INKREMENT_SEKTOR       ; Ja: Sektor inkrementieren

        call PLAYINT_INKREMENT_TIME     ; Zeit inkrementieren
        brne PLAY_SONG_5

        call PLAYINT_INKREMENT_PLAYPOS  ; PlayPos-Inkrementieren
        brne PLAY_SONG_1


        call PLAYINT_STOP               ; 25.1.

        set
        bld PLAYINT_FLAGS,PLAYINTF_KOMPLETT
        bld TASK_FLAGS,TASKF_FORWARD    ; Flag setzen

PLAY_SONG_INTERRUPT:
        lds r17,IRAM_PLAYINT_OLDMCUCR
        out MCUCR,r17

        pop zh
        pop zl
        pop xh
        pop xl
        pop r17
        out SREG,r17
        pop r17
        reti                            ; Return from interrupt

;--------------------------------------------------------------------
; INIT_PLAY
;--------------------------------------------------------------------
PLAY_INIT:
        push xl
        push xh
        push zl
        push zh
        push r16

        clt
        bld PLAYINT_FLAGS,PLAYINTF_INTERRUPT     ; Keine Unterbrechung
        bld PLAYINT_FLAGS,PLAYINTF_SEKTOREND     ; Neuer Sektor
        bld PLAYINT_FLAGS,PLAYINTF_ALLSPC
        bld PLAYINT_FLAGS,PLAYINTF_KOMPLETT
        bld PLAYINT_FLAGS,PLAYINTF_PAUSE
        bld PLAYINT_FLAGS,PLAYINTF_PLAY

        set
        bld PLAYINT_FLAGS,PLAYINTF_STOP
        clt

        lds xl,IRAM_FATBUFFER_ENTRIES
        lds xh,IRAM_FATBUFFER_ENTRIES+1
        sts IRAM_PLAYINT_FATENTRIES,xl
        sts IRAM_PLAYINT_FATENTRIES+1,xh

        ldi zl,low(ERAM_FATBUFFER)
        ldi zh,high(ERAM_FATBUFFER)
        sts IRAM_PLAYINT_PLAYPOS,zl
        sts IRAM_PLAYINT_PLAYPOS+1,zh

        lds r16,IRAM_AR_SPC             ; Sector per Cluster holen und
        sts IRAM_PLAYINT_SPCCNT,r16     ; und in INT Variable speichern

        clr r16
        sts IRAM_PLAYINT_SECOND,r16     ; Zeitzhler auf 0 setzen
        sts IRAM_PLAYINT_MINUTE,r16
        sts IRAM_PLAYINT_TICKS,r16
        sts IRAM_PLAYINT_HOUR,r16


        pop r16
        pop zh
        pop zl
        pop xh
        pop xl
        ret




;--------------------------------------------------------------------
; PLAYINT_START
;--------------------------------------------------------------------
PLAYINT_START:
        push r16
;        cli                             ; Interrupts sperren

        sbrc MISC_FLAGS,MISCF_FATSCANNED; Wurde FAT schon gescannt?
        jmp PLAYINT_START_1

        call PLAY_SCANFAT               ; Fat scannen und danach
        call MP3_GETINFO
        breq PLAYINT_START_END          ; ungltige Datei?
        call MP3_GETID3

PLAYINT_START_1:
        set
        bld MISC_FLAGS,MISCF_FATSCANNED

        lds xl,IRAM_FATBUFFER_ENTRIES
        lds xh,IRAM_FATBUFFER_ENTRIES+1
        sts IRAM_PLAYINT_FATENTRIES,xl
        sts IRAM_PLAYINT_FATENTRIES+1,xh

        cli

        ldi r16,$80                     ; Interrupt 7 aktivieren
        out EIMSK,r16

        ldi r16,$c0
        out EICR,r16                    ; Int 7 rising Edge macht INTerrupt

        sei                             ; Interrupts aktivieren

        sbi DDRE,MP3DEC_DEMAND          ; Demand auf Ausgabe
        cbi PORTE,MP3DEC_DEMAND         ; Demand auf Lo ziehen
        cbi DDRE,MP3DEC_DEMAND          ; DEMAND auf Eingabe
        sbi PORTE,MP3DEC_DEMAND         ; Demand auf HI

        set
        bld PLAYINT_FLAGS,PLAYINTF_PLAY ; PLAY setzen

        clt
        bld PLAYINT_FLAGS,PLAYINTF_PAUSE; PLAY setzen
        bld PLAYINT_FLAGS,PLAYINTF_STOP ; PLAY setzen


PLAYINT_START_END:
        set
        bld TASK_FLAGS,TASKF_PLAYSCREEN
        bld TASK_FLAGS,TASKF_PLAYTIME

        pop r16
        ret

;--------------------------------------------------------------------
; PLAYINT_STOP
;--------------------------------------------------------------------
PLAYINT_STOP:
        push r16
        cli
        clr r16
        out EIMSK,r16
        call MP3DEC_WAIT_FOR_DEMAND
        sei

        call IDE_CLEARBUFFER            ; Sektor schon fertig?

        clt
        bld PLAYINT_FLAGS,PLAYINTF_PLAY ; PLAY setzen
        bld PLAYINT_FLAGS,PLAYINTF_PAUSE; PLAY setzen

        set
        bld PLAYINT_FLAGS,PLAYINTF_STOP ; Stop-Bit setzen

        call TIMEOUTTIMER_STOP


        pop r16
        ret

;--------------------------------------------------------------------
; PLAYINT_PAUSE
;--------------------------------------------------------------------
PLAYINT_PAUSE:
        sbrs PLAYINT_FLAGS,PLAYINTF_PLAY        ; Play berhaupt gesetzt?
        rjmp PLAYINT_STARTNEW

        sbrs PLAYINT_FLAGS,PLAYINTF_PAUSE       ; Schon Pause aktiv?
        rjmp PLAYINT_PAUSE_ON                  ; Wenn nein dann aktivieren

PLAYINT_PAUSE_OFF:
;        ldi r16,$80                     ; Interrupt 7 aktivieren
;        out EIMSK,r16
;
;        ldi r16,$c0
;        out EICR,r16                    ; Int 7 rising Edge macht INTerrupt
;
;        sei                             ; Interrupts aktivieren
;
;        sbi DDRE,MP3DEC_DEMAND          ; Demand auf Ausgabe
;        cbi PORTE,MP3DEC_DEMAND         ; Demand auf Lo ziehen
;        cbi DDRE,MP3DEC_DEMAND          ; DEMAND auf Eingabe
;        sbi PORTE,MP3DEC_DEMAND         ; Demand auf HI
;
;        set
;        bld PLAYINT_FLAGS,PLAYINTF_PLAY ; PLAY setzen
;
;        clt
;        bld PLAYINT_FLAGS,PLAYINTF_PAUSE; PLAY setzen
;        bld PLAYINT_FLAGS,PLAYINTF_STOP ; PLAY setzen

        call PLAYINT_START

        ret

PLAYINT_PAUSE_ON:
        call PLAYINT_STOP

        set
        bld PLAYINT_FLAGS,PLAYINTF_PLAY
        bld PLAYINT_FLAGS,PLAYINTF_PAUSE

        clt
        bld PLAYINT_FLAGS,PLAYINTF_STOP

        ret

PLAYINT_STARTNEW:
        call PLAYINT_STOP
        call IDE_CLEARBUFFER            ; Sektor schon fertig?

        call PLAY_INIT
        call PLAYINT_START

        ret

;--------------------------------------------------------------------
; PLAY_REWIND
;--------------------------------------------------------------------
PLAYINT_REWIND:
        push r16
        push xl
        push xh
        push PLAYINT_FLAGS
        call PLAYINT_STOP


        lds r16,IRAM_PLAYINT_MINUTE
        brne PLAYINT_REWIND_1

        lds r16,IRAM_PLAYINT_SECOND
        cpi r16,2                       ; kleiner als 2sek spielzeit?
        brlo PLAYINT_REWIND_1           ; Ja: dann Titel zurck
        rjmp PLAYINT_REWIND_2

PLAYINT_REWIND_1:
        clr r16
        sts IRAM_MP3HEADER_FREQUENCY,r16
        sts IRAM_MP3HEADER_BitRate,r16

        call DIR_FIND_LAST              ; Titelsuchen wenn <10sek

PLAYINT_REWIND_2:                       ; Hier einsprung wenn >10sek
        call PLAY_INIT

        pop PLAYINT_FLAGS
        sbrs PLAYINT_FLAGS,PLAYINTF_PLAY
        rjmp PLAYINT_REWIND_END

        ldi xl,low(TIMEPLAY_DELAY);
        ldi xh,high(TIMEPLAY_DELAY);
        call TIMEOUTTIMER_LOAD          ; Timeouttimer laden

        set
        bld TASK_FLAGS,TASKF_TIMEOUTPLAY

PLAYINT_REWIND_END:
        set
        bld TASK_FLAGS,TASKF_PLAYSCREEN   ; Task ausschalten
        bld TASK_FLAGS,TASKF_PLAYTIME     ; Task ausschalten neu

        pop xh
        pop xl
        pop r16
        ret

;--------------------------------------------------------------------
; PLAY_FORWARD          r16: PLAYSCREEN display enable
;--------------------------------------------------------------------
PLAYINT_FORWARD:
        push r16
        push xl
        push xh
        push PLAYINT_FLAGS

        call DIR_FIND_NEXT                      ; neu
        breq PLAYINT_FORWARD_NOTFOUND                   ; neu

        call PLAYINT_STOP               ; Anhalten sonst Konflikt

        clr r16
        sts IRAM_MP3HEADER_FREQUENCY,r16
        sts IRAM_MP3HEADER_BitRate,r16

;        call DIR_FIND_NEXT
;        breq PLAYINT_FORWARD_NOTFOUND


        call PLAY_INIT

        pop PLAYINT_FLAGS

        sbrs PLAYINT_FLAGS,PLAYINTF_PLAY
        rjmp PLAYINT_FORWARD_END

        ldi xl,low(TIMEPLAY_DELAY);
        ldi xh,high(TIMEPLAY_DELAY);
        call TIMEOUTTIMER_LOAD          ; Timeouttimer laden
        set
        bld TASK_FLAGS,TASKF_TIMEOUTPLAY

PLAYINT_FORWARD_END:
        set
        bld TASK_FLAGS,TASKF_PLAYSCREEN   ; Task einschalten
        bld TASK_FLAGS,TASKF_PLAYTIME     ; Task ausschalten neu

        pop xh
        pop xl
        pop r16
        ret

PLAYINT_FORWARD_NOTFOUND:
        pop PLAYINT_FLAGS
        rjmp PLAYINT_FORWARD_END


;--------------------------------------------------------------------
; PLAY_FORWARDI          r16: PLAYSCREEN display enable
; Funktion sucht nchstes Lied und spielt es sofort ab!
;--------------------------------------------------------------------
PLAYINT_FORWARDI:
        push r17

        push r16
        push xl
        push xh
        push PLAYINT_FLAGS

        call PLAYINT_STOP               ; Anhalten sonst Konflikt

        call DIR_FIND_NEXT
        breq PLAYINT_FORWARDI_NOTFOUND

        call PLAY_INIT

        pop PLAYINT_FLAGS
        call PLAYINT_START

PLAYINT_FORWARDI_END:
        set
        bld TASK_FLAGS,TASKF_PLAYSCREEN   ; Task ausschalten
        bld TASK_FLAGS,TASKF_PLAYTIME     ; Task ausschalten neu

        pop xh
        pop xl
        pop r16
        pop r17
        ret

PLAYINT_FORWARDI_NOTFOUND:
        pop PLAYINT_FLAGS
        call PLAYINT_STOP
        call DIR_FIND_FIRST              ; neu
        call PLAY_INIT                  ; neu
;        set                                  ; neu
;        bld TASK_FLAGS,TASKF_PLAYSCREEN   ; Task ausschalten neu
;        bld TASK_FLAGS,TASKF_PLAYTIME     ; Task ausschalten neu

        rjmp PLAYINT_FORWARDI_END










