;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;INKREMENT_FATBUFFER_ENTRIES
;--------------------------------------------------------------------
INKREMENT_FATBUFFER_ENTRIES:
        push xl
        push xh
        lds xl,IRAM_FATBUFFER_ENTRIES
        lds xh,IRAM_FATBUFFER_ENTRIES+1
        adiw xl,$01
        sts IRAM_FATBUFFER_ENTRIES,xl
        sts IRAM_FATBUFFER_ENTRIES+1,xh
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
;DEKREMENT_FATBUFFER_ENTRIES
;--------------------------------------------------------------------
DEKREMENT_FATBUFFER_ENTRIES:
        push xl
        push xh
        lds xl,IRAM_FATBUFFER_ENTRIES
        lds xh,IRAM_FATBUFFER_ENTRIES+1
        sbiw xl,$01
        sts IRAM_FATBUFFER_ENTRIES,xl
        sts IRAM_FATBUFFER_ENTRIES+1,xh
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; PLAY_SCANFAT_INIT:
;--------------------------------------------------------------------
PLAY_SCANFAT_Init:

        sbrs MISC_FLAGS,MISCF_PLAYSCREEN
        rjmp PLAY_SCANFAR_INIT_1

        ldi r16,2
        ldi r17,1
        ldi r18,21
        ldi r19,2
        call CHARRECT_PAINT

        ldi r16,3
        ldi r17,2
        ldi zl,low(2*MSG_SCANNINGFAT)
        ldi zh,high(2*MSG_SCANNINGFAT)
        call LCD240_OutStringXY

        ldi r16,3
        ldi r17,3
        ldi zl,low(2*MSG_SCANNINGBALKEN)
        ldi zh,high(2*MSG_SCANNINGBALKEN)
        call LCD240_OutStringXY

PLAY_SCANFAR_INIT_1:
        clr r16
        sts IRAM_FATBUFFER_ENTRIES,r16
        sts IRAM_FATBUFFER_ENTRIES+1,r16

;--------------------------------------------------------------------
; FILESIZE=FILESIZE DIV 512
;--------------------------------------------------------------------
        call DIR_GET_FileSize_From_Find ; Gre holen
        ldi xl,low(IRAM_FILESIZE)
        ldi xh,high(IRAM_FILESIZE)
        mov zl,xl
        mov zh,xh
        ldi yl,low(IRAM_AR_RESULT1)
        ldi yh,high(IRAM_AR_RESULT1)
        call DIV32_BY512_INDIREKT

;--------------------------------------------------------------------
; FILESIZE=FILESIZE DIV SectorsPerCluster
;--------------------------------------------------------------------
        ldi zl,low(IRAM_FILESIZE)
        ldi zh,high(IRAM_FILESIZE)
        ldi xl,low(IRAM_AR_SPC)
        ldi xH,high(IRAM_AR_SPC)
        ldi yl,low(IRAM_ID3_HELP)
        ldi yh,high(IRAM_ID3_HELP)
        call DIV32_INDIREKT

;--------------------------------------------------------------------
; FILESIZE=loword(FILESIZE) DIV 100= 1%
;--------------------------------------------------------------------
        lds dd16Uh,IRAM_FILESIZE+1
        lds dd16Ul,IRAM_FILESIZE

        ldi dv16Uh,high(100)
        ldi dv16Ul,low(100)

        clc
        call DIV16U                     ; Dividieren
        clc

        mov yl,dres16Ul
        mov yh,dres16Uh

        sts IRAM_SCANFAT_1PERCENT,yl
        sts IRAM_SCANFAT_1PERCENT+1,yh  ; und 1Percent abspeichern
        sts IRAM_SCANFAT_PERCENT_COUNT,yl
        sts IRAM_SCANFAT_PERCENT_COUNT+1,yh

;--------------------------------------------------------------------
; FILESIZE=loword(FILESIZE) DIV 21= 4,7%
;--------------------------------------------------------------------
        lds dd16Uh,IRAM_FILESIZE+1
        lds dd16Ul,IRAM_FILESIZE

        ldi dv16Uh,high(22)
        ldi dv16Ul,low(22)

        clc
        call DIV16U                     ; Dividieren
        clc

        mov yl,dres16Ul
        mov yh,dres16Uh

        sts IRAM_SCANFAT_1KASTL,yl
        sts IRAM_SCANFAT_1KASTL+1,yh    ; und 1Kastl abspeichern
        sts IRAM_SCANFAT_KASTL_COUNT,yl
        sts IRAM_SCANFAT_KASTL_COUNT+1,yh


        clr r16
        sts IRAM_SCANFAT_KASTL,r16
        sts IRAM_SCANFAT_PERCENT,r16

        ret

;--------------------------------------------------------------------
; Dekrement_kastl
;--------------------------------------------------------------------
DEKREMENT_KASTL:
        push yl
        push yh
        lds yl,IRAM_SCANFAT_KASTL_COUNT         ; KASTLCount
        lds yh,IRAM_SCANFAT_KASTL_COUNT+1       ; KASTLCount
        sbiw yl,$01                     ; Kastl Dekrement
        breq DEKREMENT_KASTL_2
        sts IRAM_SCANFAT_KASTL_COUNT,yl
        sts IRAM_SCANFAT_KASTL_COUNT+1,yh
        pop yh
        pop yl
        ret

DEKREMENT_KASTL_2:
        push r16
        push r17
        lds yl,IRAM_SCANFAT_1KASTL
        lds yh,IRAM_SCANFAT_1KASTL+1
        sts IRAM_SCANFAT_KASTL_COUNT,yl
        sts IRAM_SCANFAT_KASTL_COUNT+1,yh

        ldi r16,21
        lds yl,IRAM_SCANFAT_KASTL
        cpse yl,r16
        inc yl
        sts IRAM_SCANFAT_KASTL,yl

        ldi r16,2
        ldi r17,3
        add r16,yl
        call lcd240_setCursor
        ldi r16,$c9
        call lcd240_OutAscii

        pop r17
        pop r16
        pop yh
        pop yl
        ret

;--------------------------------------------------------------------
; Dekrement_PERCENT
;--------------------------------------------------------------------
DEKREMENT_PERCENT:
        push yl
        push yh
        lds yl,IRAM_SCANFAT_PERCENT_COUNT         ; PERCENTCount
        lds yh,IRAM_SCANFAT_PERCENT_COUNT+1       ; PERCENTCount
        sbiw yl,$01                     ; PERCENT Dekrement
        breq DEKREMENT_PERCENT_2
        sts IRAM_SCANFAT_PERCENT_COUNT,yl
        sts IRAM_SCANFAT_PERCENT_COUNT+1,yh
        pop yh
        pop yl
        ret

DEKREMENT_PERCENT_2:
        push r16
        push r17
        lds yl,IRAM_SCANFAT_1PERCENT
        lds yh,IRAM_SCANFAT_1PERCENT+1
        sts IRAM_SCANFAT_PERCENT_COUNT,yl
        sts IRAM_SCANFAT_PERCENT_COUNT+1,yh

        ldi r16,99
        lds yl,IRAM_SCANFAT_PERCENT
        cpse yl,r16
        inc yl
        sts IRAM_SCANFAT_PERCENT,yl

        mov r16,yl
        call bin2bcd8
        ldi r16,19
        ldi r17,2
        call lcd240_setCursor
        mov r16,tBCD0
        call lcd240_outVal
        ldi r16,'%'
        call lcd240_outAscii

        pop r17
        pop r16
        pop yh
        pop yl
        ret

;--------------------------------------------------------------------
; PLAY_SCANFAT
;--------------------------------------------------------------------
PLAY_SCANFAT:
        push r0
        push r16
        push r17
        push r18
        push r19
        push r20
        push r21
        push r22
        push r23
        push r24
        push r25
        push xl
        push xh
        push zl
        push zh
        push yl
        push yh

        set
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE     ; aktiv wenn in Putimage

        call PLAY_SCANFAT_INIT

        call DIR_GET_CLUSTER_FROM_FIND

        ldi zl,low(ERAM_FATBUFFER)
        ldi zh,high(ERAM_FATBUFFER)     ; Fatbuffer ab $11000

PLAY_1:
        call INKREMENT_FATBUFFER_ENTRIES
        sbrc MISC_FLAGS,MISCF_PLAYSCREEN
        call DEKREMENT_KASTL
        sbrc MISC_FLAGS,MISCF_PLAYSCREEN
        call DEKREMENT_PERCENT

        push zl                         ; In Z ist FATBUFFER
        push zh                         ; Sector von Cluster holen
        call FAT32_Get_First_sector_of_Clus     
        pop zh
        pop zl

        ldi xl,low(IRAM_FIRST_SEC_OF_CLUS)      
        ldi xh,high(IRAM_FIRST_SEC_OF_CLUS)
        call COPY32_INDIREKT_LO_TO_HI   ; FirstSector in LBA kopieren

        adiw zl,$04

        push zl
        push zh
        call FAT32_Get_Next_Cluster     ; nchsten Cluster holen
        call FAT32_Check_Cluster        ; Ein EOF-Cluster???
        pop zh
        pop zl

        brne PLAY_1

        call DEKREMENT_FATBUFFER_ENTRIES

        sbrc MISC_FLAGS,MISCF_PLAYSCREEN
        call LCD240_ClearText

        clt
        bld TASK_FLAGS,TASKF_NOSCREENCHANGE     ; aktiv wenn in Putimage

;        set
;        bld TASK_FLAGS,TASKF_PLAYSCREEN
;        bld TASK_FLAGS,TASKF_PLAYTIME

        pop yh
        pop yl
        pop zh
        pop zl
        pop xh
        pop xl
        pop r25
        pop r24
        pop r23
        pop r22
        pop r21
        pop r20
        pop r19
        pop r18
        pop r17
        pop r16
        pop r0
        ret
