;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; SET-Play-Time
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; SetPTime_Start
;--------------------------------------------------------------------
SetPTime_StarT:
        push r16
        cli                             ; Interrupts sperren

        ldi r16,$80                     ; Interrupt 7 aktivieren
        out EIMSK,r16

        ldi r16,$c0
        out EICR,r16                    ; Int 7 rising Edge macht INTerrupt

        sei                             ; Interrupts aktivieren

        sbi DDRE,MP3DEC_DEMAND          ; Demand auf Ausgabe
        cbi PORTE,MP3DEC_DEMAND         ; Demand auf Lo ziehen
        cbi DDRE,MP3DEC_DEMAND          ; DEMAND auf Eingabe
        sbi PORTE,MP3DEC_DEMAND         ; Demand auf HI

        set
        bld PLAYINT_FLAGS,PLAYINTF_PLAY ; PLAY setzen

        clt
        bld PLAYINT_FLAGS,PLAYINTF_PAUSE; PLAY setzen
        bld PLAYINT_FLAGS,PLAYINTF_STOP ; PLAY setzen

        pop r16
        ret

;--------------------------------------------------------------------
; SETPTIME_INKREMENT_TIME
;--------------------------------------------------------------------
SETPTIME_INKREMENT_TIME:
        push r16
        push r17

        lds r16,IRAM_PLAYINT_TICKS      ; PLAYINT_Ticks und SPC addieren
        lds r17,IRAM_AR_SPC
        add r16,r17
        sts IRAM_PLAYINT_TICKS,r16

SETPTIME_INKREMENT_TIME_AGAIN:
        lds r16,IRAM_PLAYINT_TICKS      ; PLAYINT_Ticks und SPC addieren
        lds r17,IRAM_MP3HEADER_SPS      ; SPS holen und testen ob addition
        cp r17,r16                      ; grer als SPS ist
        brsh SETPTIME_INKREMENT_TIME_END; Nein: dann beenden

        sub r16,r17                     ; SPS abziehen und rest behalten
        sts IRAM_PLAYINT_TICKS,r16

        lds r16,IRAM_PLAYINT_SECOND     ; Sekunde inkrementieren
        inc r16
        sts IRAM_PLAYINT_SECOND,r16     ; und wieder abspeichern

        cpi r16,60                      ; schon 60 Sekunden erreicht?
        brne SETPTIME_INKREMENT_TIME_AGAIN

        clr r16
        sts IRAM_PLAYINT_SECOND,r16

        lds r16,IRAM_PLAYINT_MINUTE     ; Minute inkrementieren
        inc r16
        sts IRAM_PLAYINT_MINUTE,r16     ; und wieder abspeichern

        cpi r16,60                      ; schon 60 minuten erreicht??
        brne SETPTIME_INKREMENT_TIME_AGAIN

        clr r16
        sts IRAM_PLAYINT_MINUTE,r16

        rjmp SETPTIME_INKREMENT_TIME_AGAIN

SETPTIME_INKREMENT_TIME_END:
        pop r17
        pop r16
        ret


;--------------------------------------------------------------------
; SETPTIME_DEKREMENT_TIME
;--------------------------------------------------------------------
SETPTIME_DEKREMENT_TIME:
        push r16
        push r17

        lds r16,IRAM_PLAYINT_TICKS      ; PLAYINT_Ticks und SPC addieren
        lds r17,IRAM_AR_SPC
        sub r16,r17
        sts IRAM_PLAYINT_TICKS,r16

SETPTIME_DEKREMENT_TIME_AGAIN:
        lds r16,IRAM_PLAYINT_TICKS      ; PLAYINT_Ticks und SPC addieren
        sbrs r16,7                      ; Bit 7 gesetzt = negative
        rjmp SETPTIME_DEKREMENT_TIME_END

        lds r17,IRAM_MP3HEADER_SPS      ; SPS holen und testen ob addition
        add r16,r17                     ; SPS abziehen und rest behalten
        sts IRAM_PLAYINT_TICKS,r16

        lds r16,IRAM_PLAYINT_SECOND     ; Sekunde DEKREMENTieren
        dec r16
        sts IRAM_PLAYINT_SECOND,r16     ; und wieder abspeichern

        cpi r16,$ff                     ; schon 60 Sekunden erreicht?
        brne SETPTIME_DEKREMENT_TIME_AGAIN

        ldi r16,59
        sts IRAM_PLAYINT_SECOND,r16

        lds r16,IRAM_PLAYINT_MINUTE     ; Minute DEKREMENTieren
        dec r16
        sts IRAM_PLAYINT_MINUTE,r16     ; und wieder abspeichern

        cpi r16,$ff                     ; schon 60 minuten erreicht??
        brne SETPTIME_DEKREMENT_TIME_AGAIN

        ldi r16,59
        sts IRAM_PLAYINT_MINUTE,r16
        rjmp SETPTIME_DEKREMENT_TIME_AGAIN

SETPTIME_DEKREMENT_TIME_END:
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; SETPTIME_DISPLAY_TIME
;--------------------------------------------------------------------
SETPTIME_DISPLAY_TIME:
        lds r19,IRAM_PLAYINT_MINUTE
        lds r20,IRAM_PLAYINT_SECOND

        mov r16,r19
        call bin2BCD8

        ldi r16,31
        ldi r17,28
        mov r18,tBCD0
        call LCD240_OutLargeVal

        ldi r16,35
        ldi r17,28
        clr r19
        ldi zl,low(2*DATA_BitMap_Doppelpunkt)
        ldi zh,high(2*DATA_BitMap_Doppelpunkt)
        call LCD240_PutImage

        mov r16,r20
        call bin2BCD8

        ldi r16,36
        ldi r17,28
        mov r18,tBCD0
        call LCD240_OutLargeVal

        ret

;--------------------------------------------------------------------
; SetPTime_Forward
;--------------------------------------------------------------------
SetPTime_Forward:
        call PLAYINT_STOP
;        set
;        bld PLAYINT_FLAGS,PLAYINTF_PLAY

;        call TASK_ButtonState

SetPTime_Forward_1:
        in r16,PINF
        push r16

        call PLAYINT_INKREMENT_PLAYPOS
        brne SetPTime_Forward_2
        call PLAYINT_DEKREMENT_PLAYPOS
        call SETPTIME_DEKREMENT_TIME
        rjmp SetPTIME_Forward_3
SetPTime_Forward_2:
        call SETPTIME_INKREMENT_TIME    ; Cluster inkrementieren

        call SETPTIME_DISPlaY_TIME

SetPTime_Forward_3:
        pop r16
        cpi r16,$ff                     ; Taste wieder losgelassen?
        brne SETPTIME_FORWARD_1

        call SetPTime_START

        ldi r17,2
        call Button_DisplayNormal
        ret

;--------------------------------------------------------------------
; SetPTime_REWIND
;--------------------------------------------------------------------
SetPTime_REWIND:
        call PLAYINT_STOP
;        set
;        bld PLAYINT_FLAGS,PLAYINTF_PLAY

;        call TASK_ButtonState

SetPTime_REWIND_1:
        in r16,PINF
        push r16

        call PLAYINT_DEKREMENT_PLAYPOS
        brne SetPTime_Rewind_2
        call PLAYINT_INKREMENT_PLAYPOS
        call SETPTIME_INKREMENT_TIME
        rjmp SetPTIME_Rewind_3
SetPTime_REWIND_2:
        call SETPTIME_DEKREMENT_TIME    ; Cluster inkrementieren

        call SETPTIME_DISPlaY_TIME
SetPTIME_Rewind_3:
        pop r16
        cpi r16,$ff                     ; Taste wieder losgelassen?
        brne SETPTIME_REWIND_1

        call SetPTime_START

        ldi r17,0
        call Button_DisplayNormal
        ret


