;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; TIMEOUTTIMER              Interruptroutine
;--------------------------------------------------------------------
TIMEOUTTIMER_SUB1:
        sbrc TIMEOUT_FLAGS,TIMEOUTF_TIMEOUT
        rjmp TIMEOUTTIMER_SUB1_END

        lds xl,IRAM_TOT_VAL
        lds xh,IRAM_TOT_VAL+1
        adiw xl,$00
        breq TIMEOUTTIMER_SUB1_END

        sbiw xl,$01                     ; schon 0?
        sts IRAM_TOT_VAL,XL
        sts IRAM_TOT_VAL+1,XH

        brne TIMEOUTTIMER_SUB1_END
        set
        bld TIMEOUT_FLAGS,TIMEOUTF_TIMEOUT

TIMEOUTTIMER_SUB1_END:
        ret

TIMEOUTTIMER_SUB2:
        sbrc TIMEOUT_FLAGS,TIMEOUTF_LONGPRESS
        rjmp TIMEOUTTIMER_SUB2_END

        lds xl,IRAM_LPT_VAL
        lds xh,IRAM_LPT_VAL+1
        adiw xl,$00
        breq TIMEOUTTIMER_SUB2_END

        sbiw xl,$01                     ; schon 0?
        sts IRAM_LPT_VAL,XL
        sts IRAM_LPT_VAL+1,XH

        brne TIMEOUTTIMER_SUB2_END
        set
        bld TIMEOUT_FLAGS,TIMEOUTF_LONGPRESS

TIMEOUTTIMER_SUB2_END:
        ret

TIMEOUTTIMER:
        push xl
        push xh
        push r16
        in r16,SREG
        push r16

        sei

        call TIMEOUTTIMER_SUB2
        call TIMEOUTTIMER_SUB1

        pop r16
        out SREG,r16
        pop r16
        pop xh
        pop xl
        reti

;--------------------------------------------------------------------
; Ldt den Dekrement-Timer mit dem Inhalt von X und aktiviert Int
;--------------------------------------------------------------------
TIMEOUTTIMER_LOAD:
        cli
        sts IRAM_TOT_VAL,xl
        sts iRAM_TOT_VAL+1,xh
        clt
        bld TIMEOUT_FLAGS,TIMEOUTF_TIMEOUT
        sei
        ret

;--------------------------------------------------------------------
; Ldt den Dekrement-Timer mit dem Inhalt von X und aktiviert Int
;--------------------------------------------------------------------
LPTIMER_LOAD:
        cli
        sts IRAM_LPT_VAL,xl
        sts iRAM_LPT_VAL+1,xh
        clt
        bld TIMEOUT_FLAGS,TIMEOUTF_LONGPRESS
        sei
        ret

;--------------------------------------------------------------------
; BOOL_CheckTimeout     TimeoutBit testen Zero ist High wenn Timeout
;--------------------------------------------------------------------
;BOOL_CheckTimeout:
;        sez
;        sbrs TIMEOUT_FLAGS,TIMEOUTF_TIMEOUT
;        clz
;        ret

;--------------------------------------------------------------------
; BOOL_CheckTimeout     TimeoutBit testen Zero ist High wenn Timeout
;--------------------------------------------------------------------
BOOL_CheckTimeout:
        push xl
        push xh
        lds xl,IRAM_TOT_VAL
        lds xh,IRAM_TOT_VAL+1
        adiw xl,$00
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; BOOL_CheckLongPress    TimeoutBit testen Zero ist High wenn Timeout
;--------------------------------------------------------------------
;BOOL_CheckLongPress:
;        sez
;        sbrs TIMEOUT_FLAGS,TIMEOUTF_LONGPRESS
;        clz
;        ret


;--------------------------------------------------------------------
; BOOL_CheckLongPress    TimeoutBit testen Zero ist High wenn Timeout
;--------------------------------------------------------------------
BOOL_CheckLongPress:
        push xl
        push xh
        lds xl,IRAM_LPT_VAL
        lds xh,IRAM_LPT_VAL+1
        adiw xl,$00
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; TIMEOUTTIMER_INIT
;--------------------------------------------------------------------
TIMEOUTTIMER_INIT:
        push r16

        cli
        ldi r16,$0f                     ; Prescaler 1024
        out TCCR0,r16

        ldi r16,$ff
        out OCR0,r16

        clr r16                         ; 8-Bit Timer auf 0
        out TCNT0,r16

        in r16,TIMSK
        ori r16,$02                     ; Timer0-Enable setzen
        out TIMSK,r16

        sei                             ; Interrupt zulassen
        pop r16
        ret

;--------------------------------------------------------------------
; TIMEOUTTIMER_STOP
;--------------------------------------------------------------------
TIMEOUTTIMER_STOP:
        push xl
        push xh
        ldi xl,$00
        ldi xh,$00
        cli
        sts IRAM_TOT_VAL,xl
        sts IRAM_TOT_VAL+1,xh
        clt
        bld TIMEOUT_FLAGS,TIMEOUTF_TIMEOUT
        sei
        pop xh
        pop xl
        ret

;--------------------------------------------------------------------
; LPTIMER_STOP
;--------------------------------------------------------------------
LPTIMER_STOP:
        push xl
        push xh
        ldi xl,$00
        ldi xh,$00
        cli
        sts IRAM_LPT_VAL,xl
        sts IRAM_LPT_VAL+1,xh
        clt
        bld TIMEOUT_FLAGS,TIMEOUTF_LONGPRESS
        sei
        pop xh
        pop xl
        ret

