;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; Includefile Timer
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; DISPLAY_PLAYSCREEN
;--------------------------------------------------------------------
DISPLAY_PLAYSCREEN_SUB1:
        lds xl,IRAM_FIND_ADR
        lds xh,IRAM_FIND_ADR+1

        ldi r18,40
        call LCD240_OutString_IRAM
        ret

DISPLAY_PLAYSCREEN_SUB2:
        ldi zl,low(2*MSG_NOFiletoPlay)
        ldi zh,high(2*MSG_NOFiletoPlay)
        call LCD240_OutString
        ret

DISPLAY_PLAYSCREEN:
        sbrc TASK_FLAGS,TASKF_NOSCREENCHANGE
        ret

        sbrs MISC_FLAGS,MISCF_PLAYSCREEN        ; Ausgabe nicht erlaubt?
        ret

        push r18
        push r16
        push r17
        push xl
        push xh
        push zl
        push zh

        ldi r16,0
        ldi r17,1
        call LCD240_SetCursor

        sbrs MISC_FLAGS,MISCF_NoFileToPlay
        call DISPLAY_PLAYSCREEN_SUB1            ; normal ausgeben
        sbrc MISC_FLAGS,MISCF_NoFileToPlay
        call DISPLAY_PLAYSCREEN_SUB2            ; NoFile ausgeben

        lds r16,IRAM_MP3HEADER_BitRate
        clr r17
        call BIN2BCD16

        ldi r16,0
        ldi r17,4
        ldi zl,low(2*msg_BitRate)
        ldi zh,high(2*msg_BitRate)
        call LCD240_OutStringXY

        mov r16,tBCD1
        call LCD240_OutVal
        mov r16,tBCD0
        call LCD240_OutVal

        ldi zl,low(2*msg_BitRateExt)
        ldi zh,high(2*msg_BitRateExt)
        call LCD240_OutString

        clt
        bld TASK_FLAGS,TASKF_PLAYSCREEN   ; Task ausschalten

        pop zh
        pop zl
        pop xh
        pop xl
        pop r17
        pop r16
        pop r18
        ret

;--------------------------------------------------------------------
; DISPLAY_PLAYTIME
;--------------------------------------------------------------------
DISPLAY_PLAYTIME:
        sbrc TASK_FLAGS,TASKF_NOSCREENCHANGE
        ret

        sbrs MISC_FLAGS,MISCF_PLAYSCREEN        ; Ausgabe nicht erlaubt?
        ret

        push r16
        push r17
        push r18
        push r19
        push r20
        push zl
        push zh

        lds r19,IRAM_PLAYINT_MINUTE     ; GLEICHZEITIG ZEIT HOLEN!!!
        lds r20,IRAM_PLAYINT_SECOND

        mov r16,r19
        call bin2BCD8

        ldi r16,31
        ldi r17,24
        mov r18,tBCD0
        call LCD240_OutLargeVal

        ldi r16,35
        ldi r17,24
        clr r19
        ldi zl,low(2*DATA_BitMap_Doppelpunkt)
        ldi zh,high(2*DATA_BitMap_Doppelpunkt)
        call LCD240_PutImage

        mov r16,r20
        call bin2BCD8

        ldi r16,36
        ldi r17,24
        mov r18,tBCD0
        call LCD240_OutLargeVal

        clt
        bld TASK_FLAGS,TASKF_PLAYTIME   ; Task ausschalten

        pop zh
        pop zl
        pop r20
        pop r19
        pop r18
        pop r17
        pop r16
        ret

;--------------------------------------------------------------------
; TASK_TIMEOUTPLAY
;--------------------------------------------------------------------
TASK_TIMEOUTPLAY:
        sbrc TASK_FLAGS,TASKF_TPNOTALLOWED
        ret


        call BOOL_CHECKTIMEOUT  ; Testen ob verzgertes abspielen
        brne TASK_TIMEOUTPLAY_NOTIMEOUT

        call TIMEOUTTIMER_STOP          ; anhalten
        call PLAYINT_START              ; und abspielen

        clt
        bld TASK_FLAGS,TASKF_TIMEOUTPLAY; und deaktivieren!

TASK_TIMEOUTPLAY_NOTIMEOUT:
        ret

;--------------------------------------------------------------------
; TIMER_COMPARE
;--------------------------------------------------------------------
TIMER_COMPARE:
        push r16
        push r17
        in r16,SREG
        push r16
        in r16,MCUCR
        push r16

        ldi r17,$c0                     ; Memory aktivieren!!
        out MCUCR,r17

        sei                             ; Doppelunterbrechung zulassen!!!

        sbrc TASK_FLAGS,TASKF_PLAYSCREEN
        call display_Playscreen         ; Liedinfos anzeigen

        sbrc TASK_FLAGS,TASKF_PLAYTIME
        call DISPLAY_PLAYTIME

        sbrc TASK_FLAGS,TASKF_FORWARD
        call PLAYINT_FORWARDI           ; Forwrts und sofort abspielen

        sbrc TASK_FLAGS,TASKF_TIMEOUTPLAY
        call TASK_TIMEOUTPLAY

        cli
        pop r16
        out MCUCR,r16
        pop r16
        out SREG,r16
        pop r17
        pop r16
        reti

;--------------------------------------------------------------------
; TIMER_INIT
;--------------------------------------------------------------------
TIMER_INIT:
        cli
        ldi r16,$0b                     ; Prescaler 1024
        out TCCR2,r16
        ldi r16,$0b
        out TCCR1B,r16

        ldi r16,$00
        out TCCR1A,r16

        ldi r16,high(TIMER_VAL)
        out OCR1AH,r16
        ldi r16,low(TIMER_VAL)
        out OCR1AL,r16

        clr r16
        out TCNT1H,r16
        out TCNT1L,r16

        sei                             ; Interrupt zulassen

        ret

;--------------------------------------------------------------------
; TIMER_STOP
;--------------------------------------------------------------------
TIMER_STOP:
        cli
        in r16,TIMSK
        andi r16,$ef
        out TIMSK,r16

        sei
        ret

;--------------------------------------------------------------------
; TIMER_START
;--------------------------------------------------------------------
TIMER_START:
        cli
        in r16,TIMSK
        ori r16,$10
        out TIMSK,r16
        sei
        ret
