;
;                 AVRMP3Car - Standalone MP3-Player
;                          Version 1.02   
;	written 1999-2000 by Pototschnig Thomas (skymab@gmx.de)
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation - version 2.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License in file COPYING for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;Please report any bug/fix, modification, suggestion to
;
;           skymab@gmx.de
;
;--------------------------------------------------------------------
;--------------------------------------------------------------------
; Vol, Bass und Treble vorinitialisieren
;--------------------------------------------------------------------
TONE_INIT:
        ldi yl,low(IRAM_Volume)
        ldi yh,high(IRAM_Volume)
        ldi r16,22                      ; Halbe Lautstrke
        st Y+,r16
        ldi r16,15
        st Y+,r16                       ; Halber Bass und Treble
        st Y+,r16

        lds r17,IRAM_VOLUME
        ldi r16,mp3dec_VOLUME
        rcall MP3dec_ToneControl

        lds r17,IRAM_BASS
        ldi r16,mp3dec_BASS
        rcall MP3dec_ToneControl

        lds r17,IRAM_TREBLE
        ldi r16,mp3dec_TREBLE
        rcall MP3dec_ToneControl

        ret


;--------------------------------------------------------------------
; Tone_DrawBar
;--------------------------------------------------------------------
Tone_DrawBar:
        push yl
        push yh
        push r17
        push r16

        ldi yl,$C5
        ldi yh,$11
        ldi r17,31
        rcall LCD240_SetADP

Tone_DrabBar_1:
        ldi r16,$ff
        rcall LCD240_OutChar
        dec r17
        brne Tone_DrabBar_1

        adiw yl,40
        rcall LCD240_SetADP

        ldi r17,$06

Tone_DrabBar_2:
        ldi r16,$20
        rcall LCD240_Outchar
        adiw yl,30
        rcall LCD240_SetADP
        ldi r16,$01
        rcall LCD240_OutChar
        adiw yl,10
        rcall LCD240_SetADP

        dec r17
        brne Tone_DrabBar_2

        ldi r17,31
Tone_DrabBar_3:
        ldi r16,$ff
        rcall LCD240_OutChar
        dec r17
        brne Tone_DrabBar_3

        pop r16
        pop r17
        pop yh
        pop yl
        ret



;--------------------------------------------------------------------
; Tone_DisplayBlock
;--------------------------------------------------------------------
Tone_Displayblock_SUB1:
        push r18
        push r19

        ldi r18,$00

        lsr r19                         ; R19 durch 2 teilen
Tone_Displayblock_sub1_1:
        and r19,r19
        breq Tone_Displayblock_sub1_2

        ldi r16,$cb
        call lcd240_OutAscii

        dec r19
        inc r18
        rjmp Tone_Displayblock_sub1_1

Tone_Displayblock_sub1_2:
        pop r19

        sbrs r19,0                      ; Bit 0 gesetzt?
        ldi r16,$20
        sbrc r19,0                      ; Bit 0 gesetzt?
        ldi r16,$ca                     ; Nein: R16 mit CA laden
        call LCD240_OutAscii
        inc r18

Tone_DisplayBlock_sub1_3:
        cpi r18,15                      ; war 20!
        brsh Tone_DisplayBlock_Sub1_END
        inc r18
        ldi r16,$20
        call LCD240_OutAscii
        rjmp Tone_DisplayBlock_sub1_3

Tone_DisplayBlock_Sub1_END:
        pop r18
        ret

Tone_DisplayBlock:
        push r18
        push r17
        push r16

        ldi r16,20
        ldi r17,2
        call lcd240_SetCursor
        call Tone_Displayblock_Sub1

        ldi r16,20
        ldi r17,3
        call lcd240_SetCursor
        call Tone_Displayblock_Sub1

        mov r16,r19
        call bin2bcd8

        ldi r16,14
        ldi r17,16
        mov r18,tBCD0
        call LCD240_OutLargeVal

        pop r16
        pop r17
        pop r18
        ret

;--------------------------------------------------------------------
; Tone_InkrementBar             inkrementiert bar r19
;--------------------------------------------------------------------
Tone_InkrementBar:
        cpi r19,30
        breq Tone_InkrementBar_End
        inc r19
        push r16
        push r17
        mov r17,r19
        mov r16,r18
        rcall MP3dec_ToneControl
        pop r17
        pop r16
Tone_inkrementBar_end:
        rcall Tone_DisplayBlock
        ret

;--------------------------------------------------------------------
; Tone_dekrementBar
;--------------------------------------------------------------------
Tone_dekrementBar:
        and r19,r19
;        cpi r19,1
        breq Tone_DekrementBar_end
        dec r19
        push r16
        push r17
        mov r17,r19
        mov r16,r18
        rcall MP3dec_ToneControl
        pop r17
        pop r16
Tone_DekrementBar_end:        
        rcall Tone_DisplayBlock
        ret

;--------------------------------------------------------------------
; Tone_HandleBar
;--------------------------------------------------------------------
Tone_HandleBar:
        rcall Tone_displayblock
Tone_HandleBar_1:
        rcall Keyboard_check

        cpi r17,$00
        brne Tone_Control_Case1
        rcall Tone_InkrementBar

Tone_Control_Case1:
        cpi r17,$01
        brne Tone_Control_Case2
        rcall Tone_dekrementbar

Tone_Control_Case2:
        cpi r17,$07
        brne Tone_HandleBar_1
        ret

;--------------------------------------------------------------------
; Tone_DisplayVolScale
;--------------------------------------------------------------------
Tone_DisplayVolScale:
        push r16
        push yl
        push yh

        ldi yl,164
        ldi yh,$00
        rcall LCD240_SetADP
        ldi r16,'-'
        rcall LCD240_OutAscii
        ldi r16,'3'
        rcall LCD240_OutAscii
        ldi r16,'1'
        rcall LCD240_OutAscii

        adiw yl,31
        rcall LCD240_SEtAdp
        ldi r16,'0'
        rcall LCD240_OutAscii

        pop yh
        pop yl
        pop r16
        ret

;--------------------------------------------------------------------
; Tone_DisplayToneScale
;--------------------------------------------------------------------
Tone_DisplayToneScale:
        push r16
        push yl
        push yh

        ldi yl,164
        ldi yh,$00
        rcall LCD240_SetADP
        ldi r16,'-'
        rcall LCD240_OutAscii
        ldi r16,'1'
        rcall LCD240_OutAscii
        ldi r16,'5'
        rcall LCD240_OutAscii

        adiw yl,16
        rcall LCD240_SEtAdp
        ldi r16,'0'
        rcall LCD240_OutAscii
        adiw yl,14
        rcall LCD240_SEtAdp
        ldi r16,'+'
        rcall LCD240_OutAscii
        ldi r16,'1'
        rcall LCD240_OutAscii
        ldi r16,'5'
        rcall LCD240_OutAscii

        pop yh
        pop yl
        pop r16
        ret
        ret

;--------------------------------------------------------------------
; Tone_Control
;--------------------------------------------------------------------
Tone_Control:
        rcall Button_InitToneCtrlBar            ; Tone-Control-Bar-

        ldi r16,1
        ldi r17,1
        ldi r18,34
        ldi r19,2
        call CHARRECT_PAINT

        ldi r16,13
        ldi r17,16
        ldi r19,0
        ldi zl,low(2*DATA_BITMAP_DOPPELPUNKT)
        ldi zh,high(2*DATA_BITMAP_DOPPELPUNKT)
        call LCD240_PutImage

        ldi r16,2
        ldi r17,16
        ldi r19,0
        ldi zl,low(2*VOLUME_PIC)
        ldi zh,high(2*VOLUME_PIC)
        call LCD240_PutImage

        ldi yl,low(IRAM_Volume)
        ldi yh,high(IRAM_Volume)

        ld r19,Y
        ldi r18,MP3DEC_VOLUME
        rcall Tone_HandleBar
        st Y+,r19

        ldi r16,2
        ldi r17,16
        ldi r19,0
        ldi zl,low(2*BASS_PIC)
        ldi zh,high(2*BASS_PIC)
        call LCD240_PutImage

        ldi yl,low(IRAM_Bass)
        ldi yh,high(IRAM_Bass)
        ld r19,Y
        ldi r18,MP3DEC_Bass
        rcall Tone_HandleBar
        st Y+,r19

        ldi r16,2
        ldi r17,16
        ldi r19,0
        ldi zl,low(2*TREBLE_PIC)
        ldi zh,high(2*TREBLE_PIC)
        call LCD240_PutImage

        ldi yl,low(IRAM_Treble)
        ldi yh,high(IRAM_Treble)
        ld r19,Y
        ldi r18,MP3DEC_Treble
        rcall Tone_HandleBar
        st Y+,r19

        rcall Button_InitPlayBar

        ldi r17,$08

        ret
